R3095 | 6c05f1da | biwa | 01.11.2019, 00:21
--------------------------------------------------------------------------------
- Fixed a problem in the 3D floor mode plugin that caused an exception when saving the program preferences. Fixes #310.


R3094 | 75d6214d | biwa | 31.10.2019, 21:34
--------------------------------------------------------------------------------
@ Added some missing files for the tools


R3093 | 7c7d3cbe | biwa | 31.10.2019, 21:29
--------------------------------------------------------------------------------
@ Cleaned up some annoying debug messages in 3D Floor Mode


R3092 | 7dc01a94 | biwa | 31.10.2019, 21:23
--------------------------------------------------------------------------------
- Updated tools to use .Net 4.6.1 to be in line with GZDB-BF


R3091 | b94dd31f | biwa | 31.10.2019, 21:16
--------------------------------------------------------------------------------
- Fixed a bug where the wrong sectors and linedefs were highlighted in UDMF under certain conditions. Fixes #307.


R3090 | 8b98ce09 | biwa | 23.10.2019, 20:55
--------------------------------------------------------------------------------
- Added 3D Floor Mode plugin
- Flipped top/bottom in 3D Floor Mode plugin dialogs to be consistent with the edit sector dialog
@ fixed all compiler warnings in 3D Floor Mode plugin


R3089 | 05a64b4a | biwa | 19.10.2019, 20:58
--------------------------------------------------------------------------------
- Fixed a bug where searching for generalized sector effects was not handled properly in Find & Replace Mode. Fixes 305.


R3088 | 4b86f545 | biwa | 19.10.2019, 16:52
--------------------------------------------------------------------------------
- Increased max view distance from 9000 to 64000 map units. Step size increased from 200 to 500 map units
@ Improved performance of VisualBlockMap.GetFrustumRange so that high view distances is actually usable. This does not do anything to the rendering speed, so that's still slow


R3087 | 560d2389 | biwa | 19.10.2019, 00:29
--------------------------------------------------------------------------------
- Auto-aligning textures now produces more intuitive results and is consistent between UDMF and non-UDMF maps


R3086 | ba6dc546 | biwa | 13.10.2019, 13:47
--------------------------------------------------------------------------------
- (Hopefully) addressed a problem where images failed to load when opening another map in the 64 bit version
@ This is a workaround for #295.


R3085 | 4089ff10 | biwa | 07.10.2019, 19:13
--------------------------------------------------------------------------------
- (G)ZDoom action 51:Sector_SetLink is now flagged to not require an activation, since it's mostly used statically


R3084 | 8fe66886 | biwa | 07.10.2019, 19:07
--------------------------------------------------------------------------------
- The Updater is now x64 in the x64 build and can update the x64 version of GZDB-BF


R3083 | c255a6e9 | biwa | 06.10.2019, 21:56
--------------------------------------------------------------------------------
- Fixed several issues where slopes were not shown correctly in visual mode


R3082 | 6aa82e2a | biwa | 21.09.2019, 14:03
--------------------------------------------------------------------------------
- Slope effects related to slope things are now displayed more correctly in visual mode (they were not applied at all). Fixes #160
- Slope effects of UDMF vertex heights are now displayed more correctly in visual mode (they could be overwritten by lower tier slopes)


R3081 | 67a68186 | biwa | 20.09.2019, 23:14
--------------------------------------------------------------------------------
- UDMF vertex heights are now preserved in a more sensible way when joining vertices. Fixes #299.


R3080 | c6b879bb | mykola-ambar | 20.09.2019, 20:49
--------------------------------------------------------------------------------
Fix sector offset transformation in Edit Selection mode (PR#274 by mykola-ambar)


R3079 | 6e0acdf7 | biwa | 17.09.2019, 20:23
--------------------------------------------------------------------------------
Merge branch 'master' of https://github.com/jewalky/GZDoom-Builder-Bugfix


R3078 | e799d882 | biwa | 17.09.2019, 20:22
--------------------------------------------------------------------------------
Fixed a crash when manually modifying a sidedef's sector index to a sector with a tag


R3077 | 399e527b | Xabis | 05.09.2019, 12:37
--------------------------------------------------------------------------------
Support for RenderRadius (PR#297 by Xabis)


R3076 | a8ef8d52 | DoomKrawa | 03.09.2019, 10:57
--------------------------------------------------------------------------------
ZDaemon sprites (PR#282 by Krawa)

* Flags and Railgun taken from zdaemon.wad.

Thanks to ZDaemon team for the sprites.

* ZDaemon Flags and Railgun.


R3075 | 64c04f42 | biwa | 24.08.2019, 12:43
--------------------------------------------------------------------------------
- Fixed a bug where lights defined in GLDEFS wouldn't show up in visual mode. Fixes #294.


R3074 | b603cb35 | biwa | 08.08.2019, 15:06
--------------------------------------------------------------------------------
- Unused textures error checker doesn't erroneously report textures on 3D floors with the use upper/lower flags set (followup to #269)
@ Refactored texture error checks to reuse code


R3073 | c00a8995 | biwa | 08.08.2019, 12:17
--------------------------------------------------------------------------------
- Fixed a crash when loading OBJ models with faces without normals


R3072 | d2452abe | biwa | 16.07.2019, 20:46
--------------------------------------------------------------------------------
- Improved the wording for the "hidden" UDMF sector flag to make clear that it only hides the sector on the textured automap


R3071 | 363a07c6 | biwa | 16.07.2019, 20:37
--------------------------------------------------------------------------------
- Fixed a bug where a thread unsafe string length measuring method could cause a crash. Fixes #275.


R3070 | 2516b97c | biwa | 20.06.2019, 15:38
--------------------------------------------------------------------------------
- Added option to enable additive paint selecting without holding shift independently from regular additive selecting


R3069 | 8d75bfc3 | biwa | 20.06.2019, 14:53
--------------------------------------------------------------------------------
- The missing textures checker now finds missing upper/lower textures on 3D floors when the appropriate flags of the Sector_Set3dFloor special are used. Fixes #269


R3068 | a2567e4d | biwa | 18.06.2019, 21:20
--------------------------------------------------------------------------------
- Textures will now wrap correctly in visual mode when the flag of the Line_SetIdentification special is set in Hexen format. Fixes #271


R3067 | 57054c13 | biwa | 16.06.2019, 20:14
--------------------------------------------------------------------------------
- Fixed a bug where the unknown texture error checker didn't report unknown textures on sidedefs that were never seen. Fixed #270


R3066 | 34f2c308 | biwa | 16.06.2019, 19:31
--------------------------------------------------------------------------------
- More model texture loading weirdness is now regarded


R3065 | c2b18a91 | biwa | 16.06.2019, 18:40
--------------------------------------------------------------------------------
- Fixed a bug where textures for internal model skin names did not load when "Path" was specified in MODELDEF


R3064 | 70b2be5e | biwa | 16.06.2019, 12:05
--------------------------------------------------------------------------------
- Fixed a crash that happened when there were OBJ elements without parameters


R3063 | dc746178 | biwa | 16.06.2019, 00:03
--------------------------------------------------------------------------------
- Fixed a problem with OBJ models being flipped


R3062 | 97d4fdd7 | biwa | 15.06.2019, 21:26
--------------------------------------------------------------------------------
@Fixed some compiler warnings


R3061 | dde8742f | biwa | 15.06.2019, 17:44
--------------------------------------------------------------------------------
- Added support for Wavefront OBJ models
- Fixed a problem where model textures were not loaded from the textures directory or from TEXTUREx definitions. Fixes #173 and #226


R3060 | 44745bdb | biwa | 31.05.2019, 23:11
--------------------------------------------------------------------------------
- More speed improvements to the texture browser


R3059 | 48af52af | biwa | 31.05.2019, 00:20
--------------------------------------------------------------------------------
- Improved performance of the texture browser. This should significantly reduce the times it takes to open the texture browser when using large texture sets


R3058 | 22df516e | biwa | 20.04.2019, 16:55
--------------------------------------------------------------------------------
- Fixed a bug where moving the mouse outside the window could crash when pasting a selection while having auto dragging enabled. Fixes #110.


R3057 | fbf4b259 | biwa | 20.04.2019, 13:22
--------------------------------------------------------------------------------
- Fixed a freeze in the Tag Range plug-in when using the "relative" and "skip used tags" options. Fixes #125.


R3056 | 36361de8 | biwa | 19.04.2019, 19:58
--------------------------------------------------------------------------------
- Fixed a bug where script compile errors were not shown under certain circumstances. Fixes #161.


R3055 | b5e950df | biwa | 19.04.2019, 16:14
--------------------------------------------------------------------------------
- Fixed an issue where the current editing mode was not re-initialized properly when opening a map from current WAD


R3054 | aafe42c8 | biwa | 16.04.2019, 18:05
--------------------------------------------------------------------------------
- Test map from current mouse position now works properly in Hexen/UDMF maps with multiple player starts. Also works in maps without a valid player start now. Fixes #263.


R3053 | 03cb5249 | biwa | 14.04.2019, 18:27
--------------------------------------------------------------------------------
Merge branch 'master' of https://github.com/jewalky/GZDoom-Builder-Bugfix


R3052 | f2a343e1 | biwa | 14.04.2019, 18:24
--------------------------------------------------------------------------------
- Added support for the ForceWorldPanning MAPINFO option. Fixes #258
- Improved support for auto aligning scaled textures


R3051 | 95a9d287 | ZZYZX | 29.03.2019, 19:40
--------------------------------------------------------------------------------
Specify git.exe instead of just 'git' for compatibility with my environment with Cygwin git...


R3050 | 3d156a3b | biwa | 27.03.2019, 21:47
--------------------------------------------------------------------------------
3D floors are now updated in real time in visual mode when their control sector is sloped through the line slope action. Fixes #250.


R3049 | b9459419 | biwa | 27.03.2019, 20:23
--------------------------------------------------------------------------------
Visplane Explorer is now working in the x64 version


R3048 | 838d04e9 | davidxn | 27.02.2019, 18:12
--------------------------------------------------------------------------------
Missing Activation map check (PR#260 by davidxn)

* Adding check for missing activations on lines that have an activation-requiring action

* Adding skip check if the map isn't UDMF

* Oops, typo in name of check


R3047 | 227a0402 | DoomKrawa | 14.02.2019, 10:59
--------------------------------------------------------------------------------
New defines for GetPlayerInfo (ZDaemon 1.10.07) (PR#257 by Krawa)


R3046 | 82101676 | volte | 28.01.2019, 00:27
--------------------------------------------------------------------------------
Fix for rotated grid algorithm causing a freeze in some circumstances (PR#255 by Volte)


R3045 | 5c420357 | ZZYZX | 19.01.2019, 09:02
--------------------------------------------------------------------------------
Fixed unused variable warnings; fixed compilation error in Renderer2D


R3044 | eaebf7ec | biwa | 19.01.2019, 08:56
--------------------------------------------------------------------------------
Added paint selecting to visual mode (PR#248 by biwa)


R3043 | 5157dafd | volte | 16.01.2019, 07:44
--------------------------------------------------------------------------------
Various fixes for rotated grid functionality (PR#253 by Volte)


R3042 | a1d28e1e | volte | 14.01.2019, 19:07
--------------------------------------------------------------------------------
Grid rotation and alignment functionality (PR#252 by Volte)


R3041 | e1b9f315 | ZZYZX | 02.12.2018, 16:51
--------------------------------------------------------------------------------
Updated ZDoom ACS definitions; Updated ZScript parser for compatibility with latest GZDoom


R3040 | a705dc1e | ZZYZX | 08.10.2018, 00:26
--------------------------------------------------------------------------------
Maintenance: added missing FolderSelectDialog.cs


R3039 | 6fc15a17 | ZZYZX | 25.07.2018, 15:03
--------------------------------------------------------------------------------
Fixed crash while trying to reference nonexistent vertices in Unreal models


R3038 | 80b7d86c | ZZYZX | 24.07.2018, 10:35
--------------------------------------------------------------------------------
Added: color user variable, //$UserReinterpret for color control on integer user variable


R3037 | 04dc210d | ZZYZX | 24.07.2018, 09:27
--------------------------------------------------------------------------------
Added: string/float user variables, //$UserDefaultValue &lt;value&gt; for specifying default user variable value


R3036 | 74e31b65 | ZZYZX | 16.07.2018, 20:33
--------------------------------------------------------------------------------
Fixed Builder.exe.config, only this time properly


R3035 | a196457f | ZZYZX | 16.07.2018, 16:06
--------------------------------------------------------------------------------
Fixed: GZDB wouldn't load plugins on certain paranoid systems due to plugin DLL's being "remote" and unsigned (reported by Lorenzo)


R3034 | 20f96cd1 | ZZYZX | 13.07.2018, 07:20
--------------------------------------------------------------------------------
Added .iwad, .ipk3, .ipk7 extensions to recognized list (reported by someone somewhere some time ago...)


R3033 | 1933b0b6 | ZZYZX | 13.07.2018, 06:56
--------------------------------------------------------------------------------
Changed Resource directory browser to use Win7 folder dialog, not Win9x one (reported by dpJudas)


R3032 | afd71080 | Marisa Kirisame | 05.07.2018, 11:50
--------------------------------------------------------------------------------
Update .3d support to match coelckers/gzdoom#506 (PR#221 by Marisa_Kirisame)


R3031 | 50d458f7 | ZZYZX | 23.06.2018, 18:20
--------------------------------------------------------------------------------
Fixed null reference in visual mode when trying to render a thing without a sector (reported by Ozymandias81)


R3030 | b026e58a | ZZYZX | 09.06.2018, 16:26
--------------------------------------------------------------------------------
Added: MODELDEF #include support


R3029 | 3c433cfc | ZZYZX | 07.06.2018, 10:59
--------------------------------------------------------------------------------
Fixed scalar in UE1 model reader (was 127, should be 128)


R3028 | 6768bc7f | JakeSmokie | 07.06.2018, 10:32
--------------------------------------------------------------------------------
Added sector raise/lower by 128mp (PR #215 by JakeSmokie)


R3027 | 0f469e90 | ZZYZX | 28.05.2018, 10:12
--------------------------------------------------------------------------------
Updated Unreal model loading to the fixed behavior (only this time really fixed)


R3026 | 320b5f01 | ZZYZX | 28.05.2018, 10:00
--------------------------------------------------------------------------------
Updated Unreal model loading to the fixed behavior in GZDoom - axes were remapped incorrectly (I blame Marisa_Kirisame)


R3025 | 8af4a46c | ZZYZX | 28.05.2018, 03:06
--------------------------------------------------------------------------------
Actually fixed vertex axes in Unreal models.  Fixed the order of rotations in MODELDEF Offsets (this was not releavent to Unreal issues)


R3024 | 260ffbe5 | ZZYZX | 27.05.2018, 22:25
--------------------------------------------------------------------------------
Fixed skin remapping method


R3023 | 85f00ab9 | ZZYZX | 27.05.2018, 20:05
--------------------------------------------------------------------------------
Added multiple texture support for Unreal models


R3022 | 634ba548 | ZZYZX | 27.05.2018, 08:00
--------------------------------------------------------------------------------
Update zspecial.acs for ZDoom, revert ACC to 1.56


R3021 | 4213be1c | ZZYZX | 27.05.2018, 07:53
--------------------------------------------------------------------------------
Added simple Unreal model support;  Fixed numerous issues with normal handling;  Fixed outright invalid handling of AngleOffset/PitchOffset/RollOffset in MODELDEF


R3020 | d6e1b815 | ZZYZX | 27.05.2018, 03:25
--------------------------------------------------------------------------------
Added platform information to application log


R3019 | db362934 | ZZYZX | 16.04.2018, 02:22
--------------------------------------------------------------------------------
Added platform information to the saved error report


R3018 | e9c83d06 | ZZYZX | 16.04.2018, 00:51
--------------------------------------------------------------------------------
Fixed: GZDB was built against wrong SlimDX version (including 64-bit which was built against 32-bit SlimDX) - (reported by StrikerMan780, leodoom85, Rockstar Racoon)


R3017 | 1e129ba2 | ZZYZX | 15.04.2018, 01:11
--------------------------------------------------------------------------------
Fixed: 64-bit updater had wrong path and would not update


R3016 | a2a6004a | ZZYZX | 15.04.2018, 00:59
--------------------------------------------------------------------------------
Fixed (?): The new .NET 4.6.x JIT method inlining was fucking with GetCallingAssembly-based plugin detection


R3015 | 000ecfba | ZZYZX | 14.04.2018, 17:15
--------------------------------------------------------------------------------
Made GZDB output 64-bit in the title


R3014 | d9dfab64 | ZZYZX | 14.04.2018, 17:11
--------------------------------------------------------------------------------
Made some edits to the build scripts and auto-update routine to support 64-bit updating


R3013 | 0b14bdee | jewalky | 14.04.2018, 15:55
--------------------------------------------------------------------------------
GZDB native 64-bit binary support (PR#197 by StrikerMan780)


R3012 | 0a5a2e81 | ZZYZX | 10.04.2018, 20:07
--------------------------------------------------------------------------------
Updated ZDoom ACC to the latest dev build (reported by printz)


R3011 | 5344700f | ZZYZX | 10.04.2018, 19:54
--------------------------------------------------------------------------------
Added UDMF desaturation preview in classic modes


R3010 | 9742a9f7 | ZZYZX | 10.04.2018, 18:41
--------------------------------------------------------------------------------
Added UDMF desaturation preview in visual modes


R3009 | 88d98acd | ZZYZX | 31.03.2018, 13:13
--------------------------------------------------------------------------------
Fixed: zero-radius point lights would crash upon entering things mode (reported by blood)


R3008 | 10167038 | ZZYZX | 31.03.2018, 13:01
--------------------------------------------------------------------------------
Fixed: on a second thought, let's just make FileImageReader fall back to guessed image if possible...


R3007 | f7c2a577 | ZZYZX | 31.03.2018, 12:38
--------------------------------------------------------------------------------
Fixed: made more correct checking for legal file formats; now it should actually validate the format upon loading


R3006 | abdacb32 | ZZYZX | 31.03.2018, 12:07
--------------------------------------------------------------------------------
Fixed: flats are now unconditionally detected as Doom Flat if they are exactly 4096 bytes long and inside F_ markers or flats directory.  (reported by Chickenlegz)


R3005 | 995e23f2 | ZZYZX | 25.03.2018, 00:40
--------------------------------------------------------------------------------
Enabled parsing of NaN in UDMF so that the existing buggy maps load;  made it throw exceptions when a NaN vertex is added to the map


R3004 | efd2ded0 | ZZYZX | 04.02.2018, 12:20
--------------------------------------------------------------------------------
Made 2D spotlight projection even more accurate (reported by Gutawer)


R3003 | a0ef5209 | ZZYZX | 04.02.2018, 08:18
--------------------------------------------------------------------------------
Fixed light color picker to work with spotlights


R3002 | f97b0b2e | ZZYZX | 04.02.2018, 06:28
--------------------------------------------------------------------------------
Made 2D spotlight projection more accurate


R3001 | 4462224a | ZZYZX | 04.02.2018, 05:30
--------------------------------------------------------------------------------
Oops quickfix: inherited generic lights did not work


R3000 | 57911718 | ZZYZX | 04.02.2018, 05:16
--------------------------------------------------------------------------------
Added proper spotlight preview in 2D mode


R2999 | e91fe947 | ZZYZX | 04.02.2018, 04:16
--------------------------------------------------------------------------------
Added string support for spotlight colors


R2998 | 6565b83a | ZZYZX | 04.02.2018, 03:27
--------------------------------------------------------------------------------
Moved spotlights to separate directory;  fixed parameter names;  added animated spotlights to game configurations


R2997 | 184982dc | ZZYZX | 04.02.2018, 03:18
--------------------------------------------------------------------------------
Added spotlight preview in visual mode


R2996 | 089906ba | ZZYZX | 04.02.2018, 01:50
--------------------------------------------------------------------------------
Removed leftovers of default string value implementation


R2995 | d8bee559 | ZZYZX | 03.02.2018, 21:31
--------------------------------------------------------------------------------
Did some maxcode refactoring about dynamic lights;  added initial spotlight support (at least they are recognized as lights now)


R2994 | 8375ece2 | ZZYZX | 22.01.2018, 12:20
--------------------------------------------------------------------------------
Fixed collection modification inside foreach. (reported by Lud)


R2993 | 1d36d3fe | ZZYZX | 25.12.2017, 01:45
--------------------------------------------------------------------------------
Updated ZScript parser for const array definition support (reported by SanyaWaffles)


R2992 | d428272f | Anthony M. Cook | 08.11.2017, 04:37
--------------------------------------------------------------------------------
The indoor lightning descriptions were reversed. (#164) (by acook)


R2991 | f0364c15 | ZZYZX | 25.10.2017, 06:58
--------------------------------------------------------------------------------
Fixed one-line issue in model lighting pipeline (reported by everyone)


R2990 | 3f357319 | ZZYZX | 06.09.2017, 17:57
--------------------------------------------------------------------------------
Fixed: allow dotted identifier in array dimensions


R2989 | e7328e4c | ZZYZX | 27.08.2017, 07:09
--------------------------------------------------------------------------------
Added support for non-1.2 pixel ratios if view stretching is enabled (reported by Nash);  Fixed: map names in quotes were not recognized properly.


R2988 | b8e68083 | ZZYZX | 24.08.2017, 15:24
--------------------------------------------------------------------------------
Fixed: BaseVisualMode object was used before fully initialized (reported by Martix10)


R2987 | 7168ad20 | Mistranger | 24.08.2017, 15:24
--------------------------------------------------------------------------------
Add "Mouse selection threshold" option (#141 by Mistranger)

* Mouse selection threshold

* Cleanup

* Fix selection bug


R2986 | c9162c6f | ZZYZX | 10.08.2017, 15:01
--------------------------------------------------------------------------------
Fixed: builtin dynamic lights were rendered at wrong height (reported by +Ku6EPyXOBEPTKA+)


R2985 | 113d86a5 | Ioan Chera | 05.08.2017, 08:53
--------------------------------------------------------------------------------
Add the fields new to Eternity 3.42.03 (#135) (by printz)

* Replace the wrong portal_ceil_alpha and portal_floor_alpha with alphaceiling and alphafloor.

* Added the new fields of Eternity 3.42.03


R2984 | c0b3f983 | ZZYZX | 26.07.2017, 18:34
--------------------------------------------------------------------------------
Fixed minor translucent rendering issue


R2983 | a122dacf | ZZYZX | 26.07.2017, 17:35
--------------------------------------------------------------------------------
Added lights on models


R2982 | febc91ad | ZZYZX | 25.07.2017, 19:16
--------------------------------------------------------------------------------
Fixed (?) esoteric plugin issue


R2981 | 131c51d7 | biwa | 18.07.2017, 13:56
--------------------------------------------------------------------------------
Added improvements to the "Fit Texture" action: (#124) (by biwa)

- Dialog can't be resized anymore
- Dialog can be canceled by pressing the escape key
- Changed input boxes to the appropriate GZDB version, so steps and modifier key work correctly
- Added checkboxes to automatically fit the textures optimally based on the width/height of the line(s) in respect to the width/height of the texture
- Added input boxes to manually set a width/height pattern size of the texture that will be used when automatically fitting textures


R2980 | f14a4bd6 | ZZYZX | 20.06.2017, 20:30
--------------------------------------------------------------------------------
Added new flags for internal dynamic lights (reported by Nash)


R2979 | 7603e5fa | ZZYZX | 29.05.2017, 05:38
--------------------------------------------------------------------------------
Fixed: INHERITACTORPITCH was actually changed along with USEACTORPITCH...doesn't really make sense compatibility-wise but there it is. (reported by alekv)


R2978 | d9d8c352 | ZZYZX | 10.05.2017, 21:53
--------------------------------------------------------------------------------
Fixed: pitch formula was duplicated and not changed in one of the places. (reported by Ozymandias81)


R2977 | 0e43985f | ZZYZX | 10.05.2017, 05:13
--------------------------------------------------------------------------------
Fixed: flipped +USEACTORPITCH direction for recent GZDoom versions;  this can be reverted by putting "buggymodeldefpitch = true;" in the game configuration for your specific projects if they are using old GZDoom versions.  Note: already added for Zandronum.


R2976 | 04324cd1 | ZZYZX | 09.05.2017, 05:06
--------------------------------------------------------------------------------
Fixed (?) cross-thread bitmap usage. (reported by Xane123)


R2975 | 021bcf69 | Sean Baggaley | 29.04.2017, 15:52
--------------------------------------------------------------------------------
Fix texture filtering not disabling properly (resolves #106) (#107 by csnxs)


R2974 | ad6ae111 | ZZYZX | 29.04.2017, 12:56
--------------------------------------------------------------------------------
Fixed: render sorting issues with multiple translucent 3D floors next to each other on different heights


R2973 | de7445b7 | ZZYZX | 17.04.2017, 11:40
--------------------------------------------------------------------------------
Fixed nested template types handling in ZScript parser


R2972 | b4d38e3d | Ioan Chera | 15.04.2017, 03:58
--------------------------------------------------------------------------------
Replace the wrong portal_ceil_alpha and portal_floor_alpha with alphaceiling and alphafloor. (#101 by printz)


R2971 | 594dab97 | ZZYZX | 11.04.2017, 03:48
--------------------------------------------------------------------------------
Fixed: regression in texture selection window caused by previous fixes (reported by simc2)


R2970 | 0c4051a5 | ZZYZX | 11.04.2017, 03:45
--------------------------------------------------------------------------------
Fixed 0.5/1.0 second sector light blinking specials (reported by printz)


R2969 | 3d943f12 | ZZYZX | 11.04.2017, 03:33
--------------------------------------------------------------------------------
Fixed: Internal: added off-grid vertices check to BuilderModes project


R2968 | 08b15cb8 | davidxn | 10.04.2017, 22:52
--------------------------------------------------------------------------------
Added error check for vertices with non-integer positions (#94 by davidxn)


R2967 | 983dea1b | ZZYZX | 04.04.2017, 13:06
--------------------------------------------------------------------------------
Fixed: all the old magic in SafeDistanceToSq is now only working for non-UDMF maps


R2966 | 8dbe5f7a | ZZYZX | 04.04.2017, 13:04
--------------------------------------------------------------------------------
Fixed: Visplane Explorer depended on the old behavior of SafeDistanceToSq. (reported by riderr3)


R2965 | 356eac34 | ZZYZX | 03.04.2017, 19:45
--------------------------------------------------------------------------------
Internal: Oops: removed debug leftovers (x2)


R2964 | b80c8feb | ZZYZX | 03.04.2017, 19:42
--------------------------------------------------------------------------------
Internal: Oops: removed debug leftovers


R2963 | a2c9de39 | ZZYZX | 03.04.2017, 19:40
--------------------------------------------------------------------------------
Fixed: changing flat names around is wrong... (reported by Lud)


R2962 | 20c94662 | ZZYZX | 03.04.2017, 12:48
--------------------------------------------------------------------------------
Fixed: 'Compiling the editor' help page had slightly broken CSS reference. (reported by Kappes Buur)


R2961 | 3013723e | davidxn | 03.04.2017, 10:20
--------------------------------------------------------------------------------
Improve MakeDoor form - options for line special and tag (PR #91 by davidxn)


R2960 | 153c63b5 | ZZYZX | 29.03.2017, 03:11
--------------------------------------------------------------------------------
Fixed: the model should be Z-scaled to 0.83 even in unstretched view to ensure that models fit the geometry right (reported by Ozymandias81)


R2959 | bb650fa6 | ZZYZX | 28.03.2017, 14:07
--------------------------------------------------------------------------------
Updated ZScript parser to support abstract on classes


R2958 | 10aa7e94 | ZZYZX | 25.03.2017, 04:19
--------------------------------------------------------------------------------
Fixed translucent sprites. Added visual stencil color preview. (reported by Lud)


R2957 | aff6998d | ZZYZX | 25.03.2017, 03:15
--------------------------------------------------------------------------------
Fixed: reduced magic in Linedef.SafeDistanceToSq - fixes line/sector selection with 0.125mp grid (reported by camaxide)


R2956 | 816e61d1 | ZZYZX | 25.03.2017, 02:47
--------------------------------------------------------------------------------
Added: binding actions to horizontal mouse wheel


R2955 | 480a1152 | ZZYZX | 19.03.2017, 17:19
--------------------------------------------------------------------------------
Fixed: 3D floor with translucent texture but 255 alpha was rendered opaque.


R2954 | 6fc1dac3 | ZZYZX | 18.03.2017, 18:34
--------------------------------------------------------------------------------
Readme: minor fixes.


R2953 | e9030bd5 | ZZYZX | 18.03.2017, 18:33
--------------------------------------------------------------------------------
Readme: devbuilds link should point to the right page.


R2952 | 814fdd90 | ZZYZX | 17.03.2017, 16:48
--------------------------------------------------------------------------------
Fixed: texture copy/paste in the visual mode was detected as failed pasting and caused a beep. (reported by DOOMGABR, abbuw, Turret_Master)


R2951 | 6f1b6c72 | ZZYZX | 15.03.2017, 09:29
--------------------------------------------------------------------------------
Fixed: forgot to add ZDDomPoint sprites...


R2950 | 53ce14fc | ZZYZX | 15.03.2017, 07:52
--------------------------------------------------------------------------------
Internal: fixed compiler warnings


R2949 | 579b90a1 | ZZYZX | 14.03.2017, 19:31
--------------------------------------------------------------------------------
Fixed: the old way of checking for GZDB's directory writability would not work in certain versions of WINE/Mono


R2948 | dceeed6b | ZZYZX | 13.03.2017, 02:26
--------------------------------------------------------------------------------
Fixed: removing a thing should also remove it from the visible things list. (reported by DOOMGABR)


R2947 | 36af3424 | ZZYZX | 13.03.2017, 02:12
--------------------------------------------------------------------------------
Internal: removed debug code from Renderer3D.


R2946 | d3b4060f | ZZYZX | 13.03.2017, 02:10
--------------------------------------------------------------------------------
Merge branch 'master' of github.com:jewalky/GZDoom-Builder-Bugfix


R2945 | 35f8c5e1 | ZZYZX | 13.03.2017, 02:10
--------------------------------------------------------------------------------
Fixed: cutting a thing in visual mode would leave disposed BaseVisualThings in the selection. (reported by DOOMGABR)


R2944 | bbeadf65 | Ioan Chera | 13.03.2017, 01:45
--------------------------------------------------------------------------------
Eternity config: add polycross property and remove 'copy' thing types (PR#79 by ioan-chera)


R2943 | 9bd51a01 | ZZYZX | 12.03.2017, 12:26
--------------------------------------------------------------------------------
Updated ZDoom ACS compiler


R2942 | ee28f1d0 | ZZYZX | 09.03.2017, 18:09
--------------------------------------------------------------------------------
Made Skulltag item sprites optional to support default Skulltag+Zandronum config without producing 100 errors


R2941 | 589b6746 | ZZYZX | 09.03.2017, 17:24
--------------------------------------------------------------------------------
Fixed: returned accidentally lost Skulltag thing types


R2940 | ce6074fd | ZZYZX | 09.03.2017, 17:01
--------------------------------------------------------------------------------
Internal: Oops: removed useless leftover file


R2939 | 4f8f3907 | ZZYZX | 09.03.2017, 16:58
--------------------------------------------------------------------------------
Updated Zandronum game configurations to include invasion spawners and MBF items (dog, evil sceptre, unholy bible, beta lost soul)


R2938 | 509fb55e | ZZYZX | 09.03.2017, 00:32
--------------------------------------------------------------------------------
Fixed field caption for floor glow color.


R2937 | 957314a9 | ZZYZX | 09.03.2017, 00:24
--------------------------------------------------------------------------------
Fixed: field name for things is called color_sprites.


R2936 | d8701b7a | ZZYZX | 09.03.2017, 00:00
--------------------------------------------------------------------------------
Added: proper GUI tab for color-related sector properties. The tab now hosts Doom64 lighting as well as old color-related things (floor/ceiling glow, light color, fade color and desaturation).


R2935 | 87a2a14d | ZZYZX | 08.03.2017, 22:34
--------------------------------------------------------------------------------
Fixed: FAIL medal sprite in zandronum.pk3 was not parsed correctly


R2934 | 4611aa1b | ZZYZX | 08.03.2017, 04:35
--------------------------------------------------------------------------------
Added more specific debug logging to random NullPointerException crash place


R2933 | 717e48ed | ZZYZX | 07.03.2017, 02:06
--------------------------------------------------------------------------------
Fixed: for scaled walls, texture offsets should not be scaled (reported by Tormentor667)


R2932 | bbe651d3 | ZZYZX | 06.03.2017, 05:08
--------------------------------------------------------------------------------
Camera texture can be longer than 8 characters


R2931 | 92825a08 | ZZYZX | 06.03.2017, 05:07
--------------------------------------------------------------------------------
Updated ZScript parser to the latest syntax


R2930 | 8c36eafb | ZZYZX | 04.03.2017, 15:50
--------------------------------------------------------------------------------
Fixed state lookup logic for sprite guessing; it should always prefer SPRITE_CHECK_STATES to using the random first frame.


R2929 | 522c1e3f | ZZYZX | 04.03.2017, 01:25
--------------------------------------------------------------------------------
Fixed: never pick up POL5 frame definition from Actor::GenericCrush. Ew, blood.


R2928 | 4b1a31c3 | ZZYZX | 04.03.2017, 01:13
--------------------------------------------------------------------------------
Fixed: duration 0 frames should be skipped if there are nonzero frames after them (reported by Tormentor667, Ozymandias81). Fixed crash if some actor had a modeldef entry but doesn't anymore.


R2927 | f97c15ae | ZZYZX | 03.03.2017, 19:33
--------------------------------------------------------------------------------
Fixed: Internal: made most 'get' calls in WADReader use synchronized MemoryStream duplicate as opposed to operating on WAD stream directly. Hopefully fixes multithreading issues with sprite loading. (reported by Mysterious Haruko, camaxide)


R2926 | 59c13209 | ZZYZX | 02.03.2017, 19:14
--------------------------------------------------------------------------------
Fixed: flats and textures with the same name were not cached correctly in the texture browser. (reported by DOOMGABR)


R2925 | 52e771fe | ZZYZX | 01.03.2017, 23:57
--------------------------------------------------------------------------------
Internal: Fixed: builtin light alteration by actor flags logic in GetGZLightTypeByClass


R2924 | 61085027 | ZZYZX | 01.03.2017, 23:36
--------------------------------------------------------------------------------
Fixed: actor flags with inheritance from GZDoom dynamic lights (i.e. PointLight)


R2923 | 748fe9e2 | ZZYZX | 01.03.2017, 23:21
--------------------------------------------------------------------------------
Fixed: inheritance from game configuration for dynamic lights; Fixed: visual representation of inherited lights (reported by Nash); Fixed: inherited thing arguments from game configuration; Added: //$ClearArgs for clearing inherited arguments.


R2922 | 125844b3 | ZZYZX | 01.03.2017, 17:35
--------------------------------------------------------------------------------
Fixed: sprite replacements with different rotation count weren't handled correctly. (reported by DOOMGABR)


R2921 | 6661ed44 | ZZYZX | 26.02.2017, 11:03
--------------------------------------------------------------------------------
Fixed: saving a script would reset scrolling to the top


R2920 | 39889a94 | ZZYZX | 25.02.2017, 15:30
--------------------------------------------------------------------------------
Fixed: arg0str TextBox wasn't aligned to the right on Windows 10 (reported by SanyaWaffles)


R2919 | 72352792 | ZZYZX | 25.02.2017, 10:08
--------------------------------------------------------------------------------
Changed: just use //$ArgNStr to check if arg0str is supported. If the argument is present, arg0str will be shown.


R2918 | 2bb2c92a | ZZYZX | 25.02.2017, 10:04
--------------------------------------------------------------------------------
Fixed: don't use script control for non-script arg0str. That breaks things.


R2917 | 6d171733 | ZZYZX | 25.02.2017, 09:41
--------------------------------------------------------------------------------
Added: custom arg0str things with //$ArgNAllowStr and //$ArgNStr (title for string version)


R2916 | 1a8b9d40 | ZZYZX | 25.02.2017, 09:31
--------------------------------------------------------------------------------
Added: search&replace support for non-script arg0str


R2915 | e7ed533e | ZZYZX | 23.02.2017, 14:10
--------------------------------------------------------------------------------
Added: arg0str for non-script specials in Search (only output, matching and replacement not work yet)


R2914 | 3748ea63 | ZZYZX | 23.02.2017, 14:01
--------------------------------------------------------------------------------
Fixed: handling of arg0str in non-script specials in info panel; default arg0str.


R2913 | 5ff54ab3 | ZZYZX | 23.02.2017, 13:19
--------------------------------------------------------------------------------
Added: arg0str in non-script specials. Kinda.


R2912 | 3ac39598 | ZZYZX | 23.02.2017, 12:54
--------------------------------------------------------------------------------
Fixed: forgot to add ZDaemon_common.cfg; Fixed: Internal: removed hardcoded arg0str only for scripts


R2911 | 1cb3682c | ZZYZX | 20.02.2017, 12:42
--------------------------------------------------------------------------------
Updated ZDaemon configuration and related files (13.02.2017 by Krawa)


R2910 | 0ec18242 | ZZYZX | 20.02.2017, 08:13
--------------------------------------------------------------------------------
Fixed: SplitLinesByVertices could leave disposed lines for iteration, which resulted in crashes on certain geometry while using 'Replace with Dragged Geometry'.


R2909 | e2fa70cd | ZZYZX | 20.02.2017, 07:21
--------------------------------------------------------------------------------
Internal: Oops: removed debug logging


R2908 | dba70886 | ZZYZX | 20.02.2017, 07:14
--------------------------------------------------------------------------------
Internal: threw out a lot of unoptimized code in TraceSector. Now using Tools.FindPotentialSectorAt.


R2907 | 6988bae7 | ZZYZX | 20.02.2017, 06:30
--------------------------------------------------------------------------------
Fixed: check for mathing argument lists was doing god-knows-what. Should now be ok.


R2906 | 679f2eec | ZZYZX | 20.02.2017, 06:26
--------------------------------------------------------------------------------
Fixed: check for matching argument lists was severely broken and was resetting or not resetting almost randomly


R2905 | 271df46f | ZZYZX | 20.02.2017, 06:07
--------------------------------------------------------------------------------
Added: script editor will now automatically trim trailing whitespace on save.


R2904 | bd00eef8 | ZZYZX | 19.02.2017, 07:40
--------------------------------------------------------------------------------
Fixed: preferences window size was off


R2903 | 4a79c748 | jewalky | 15.02.2017, 21:48
--------------------------------------------------------------------------------
Merge pull request #43 from Xabis/master

Fixed crash with arg type 14, and support target class filter


R2902 | d3289d01 | Xabis | 15.02.2017, 20:03
--------------------------------------------------------------------------------
* Fixed a crash if setting an argument to the thing type ($Arg#Type = 14) on a decorate actor
* Added support for using the "Target Class" filter for argument thing types. Configure using the new $Arg$TargetClasses property. Note: only actors with a valid classname may be added to the filter.


R2901 | 3540f55a | jewalky | 14.02.2017, 21:37
--------------------------------------------------------------------------------
Merge pull request #42 from Xabis/master

Direct tag-to-tag associations


R2900 | b4fbcf5d | ZZYZX | 14.02.2017, 19:27
--------------------------------------------------------------------------------
Fixed: 'forbidden' lumps are not supposed to count towards matching while detecting map type


R2899 | a886a53e | Xabis | 14.02.2017, 18:33
--------------------------------------------------------------------------------
* A direct tag-to-tag relationship can now be established between two things, which allows event lines to be properly setup between them. This is intended for interpolation and patrol specials which are linked via a shared tag, instead of an argument. A POSITIVE value represents the parent thing, where a NEGATIVE value represents the child thing.
* Added interpolation and patrol point specials to the persistent event line processing


R2898 | 4a624785 | ZZYZX | 14.02.2017, 16:48
--------------------------------------------------------------------------------
Fixed: 'Save into' would detect non-map lumps with the same name as maps and ask if you want to save over...


R2897 | d4686082 | ZZYZX | 14.02.2017, 15:10
--------------------------------------------------------------------------------
Fixed: in case there are other (non-map) lumps in the archive that have the same name as a map (e.g. MB2 patch and MB2 map in idl201x WADs) only the valid map is read.


R2896 | 780482f4 | ZZYZX | 14.02.2017, 14:39
--------------------------------------------------------------------------------
Fixed: consequential duplicate maps weren't handled properly


R2895 | f8959507 | ZZYZX | 14.02.2017, 14:25
--------------------------------------------------------------------------------
Fixed: old map format is now autodetected when saving a map over an existing one. Saving a map in different format shouldn't leave junk lumps anymore.


R2894 | d9eecbdc | ZZYZX | 14.02.2017, 11:13
--------------------------------------------------------------------------------
Internal: reverted mysterious MaxED edit in map saving functions


R2893 | dee1e0f4 | ZZYZX | 14.02.2017, 10:57
--------------------------------------------------------------------------------
Internal: removed now unneeded CopyAllLumpsExceptMap


R2892 | b996d8a3 | ZZYZX | 14.02.2017, 10:56
--------------------------------------------------------------------------------
Internal: not copying all lumps manually anymore on 'Save As'. The WAD is copied with File.Copy anyway.


R2891 | 12314508 | ZZYZX | 13.02.2017, 02:02
--------------------------------------------------------------------------------
Fixed: Find&Replace in Script Editor would go into an infinite loop if replacement contains the searched text


R2890 | db1db76b | ZZYZX | 13.02.2017, 01:06
--------------------------------------------------------------------------------
Fixed: Doom64 lighting was not displayed in 2D modes


R2889 | 6bb79c1c | ZZYZX | 12.02.2017, 23:23
--------------------------------------------------------------------------------
Fixed: Internal: StairSectorBuilder wasn't marked as dependent on Builder project


R2888 | 946e8051 | ZZYZX | 12.02.2017, 19:33
--------------------------------------------------------------------------------
Added: action numbers in linedef action selection dialog; Fixed: improper usages of 'Window' white color in place of 'Control' gray color in dialogs.


R2887 | bffb499f | ZZYZX | 12.02.2017, 17:35
--------------------------------------------------------------------------------
Fixed: removed useless rounding to 1px in Draw Curve, Draw Ellipse, Draw Rectangle, Draw Grid tools; this performed incorrectly with grid sizes less than 1px


R2886 | 251c89f3 | ZZYZX | 11.02.2017, 16:45
--------------------------------------------------------------------------------
Supposedly fixed handling of multidimensional arrays in ZScript, as well as specifying array dimensions in the type


R2885 | 6f76b538 | ZZYZX | 11.02.2017, 02:27
--------------------------------------------------------------------------------
Added very basic ZDaemon configuration


R2884 | 02d5ce4c | ZZYZX | 10.02.2017, 11:32
--------------------------------------------------------------------------------
Internal: Oops: missing files


R2883 | db9bb4f4 | ZZYZX | 09.02.2017, 18:14
--------------------------------------------------------------------------------
Info panel might work a bit faster now


R2882 | e3ebe7dc | ZZYZX | 09.02.2017, 15:49
--------------------------------------------------------------------------------
Fixed: additive-translucent geometry should not be lit


R2881 | d47dd9a5 | ZZYZX | 09.02.2017, 14:45
--------------------------------------------------------------------------------
Fixed: slightly incorrect texture name offsets in classic view in the texture browser


R2880 | fbbfaad5 | ZZYZX | 09.02.2017, 14:20
--------------------------------------------------------------------------------
Fixed: changing brightness of upper/lower/middle sidedef did not update the whole sidedef brightness until 3D mode restart


R2879 | cafd1a6f | ZZYZX | 09.02.2017, 14:03
--------------------------------------------------------------------------------
Fixed: lights were not applied to translucent textures


R2878 | 3d69ec12 | ZZYZX | 09.02.2017, 13:28
--------------------------------------------------------------------------------
Fixed: lights behind the camera shouldn't count towards the max lights counter


R2877 | 2b69b38e | ZZYZX | 09.02.2017, 12:28
--------------------------------------------------------------------------------
Added dynamic light count = 256 for high end users. Fixed: incorrect attenuated&lt;-&gt;subtractive light ordering caused invisible subtractive lights.


R2876 | e62bbba9 | ZZYZX | 09.02.2017, 03:07
--------------------------------------------------------------------------------
Internal: ZScript: now using StringBuilder in the internal tokenizer loops, might speed it up a bit


R2875 | 1fb1167e | ZZYZX | 09.02.2017, 01:39
--------------------------------------------------------------------------------
Fixed: Internal: resumed resource would lose readonly attribute


R2874 | 7f2f51d4 | ZZYZX | 09.02.2017, 01:26
--------------------------------------------------------------------------------
Added: primitive support for ZScript in the script editor (all classes in the current file are listed)


R2873 | 1382d144 | ZZYZX | 08.02.2017, 22:55
--------------------------------------------------------------------------------
Added: basic support for automatic user variables from ZScript classes, currently only for int variables (as supported by GZDoom).


R2872 | 0d43a7be | ZZYZX | 08.02.2017, 18:21
--------------------------------------------------------------------------------
Fixed: 'Texture sizes below names' was handled incorrectly with 'Show texture sizes' disabled


R2871 | ed6e5985 | ZZYZX | 08.02.2017, 17:58
--------------------------------------------------------------------------------
Fixed: item selection gradient in classic views was severely off.


R2870 | 46cc1df0 | ZZYZX | 08.02.2017, 17:36
--------------------------------------------------------------------------------
Merge anotak's optimizations - stage 4: Texture Browser


R2869 | 4faed76b | ZZYZX | 08.02.2017, 13:20
--------------------------------------------------------------------------------
Merge anotak's optimizations - stage 3


R2868 | 0fe77cf8 | ZZYZX | 08.02.2017, 13:18
--------------------------------------------------------------------------------
Merge anotak's optimizations - stage 2


R2867 | 09b8c27d | ZZYZX | 08.02.2017, 13:18
--------------------------------------------------------------------------------
Merge anotak's optimizations - stage 1


R2866 | 34d1af94 | ZZYZX | 07.02.2017, 19:02
--------------------------------------------------------------------------------
Reverted anotak's PR: it causes 'Cancel' button in Edit windows to automatically do undo or something similar, breaking maps completely


R2865 | 2821149a | jewalky | 07.02.2017, 09:56
--------------------------------------------------------------------------------
Merge pull request #31 from anotak/master

Speedup on opening properties windows


R2864 | b5f7db1d | anotak | 07.02.2017, 05:53
--------------------------------------------------------------------------------
Speedup on opening properties windows


R2863 | 52b47cd0 | anotak | 06.02.2017, 07:10
--------------------------------------------------------------------------------
Revert "Revert "actionmanager change""

This reverts commit 4d9d1eda0f30b1e7ff0b776ac6a04ffb40d6a7d3.


R2862 | 4d9d1eda | anotak | 06.02.2017, 06:40
--------------------------------------------------------------------------------
Revert "actionmanager change"

This reverts commit a3ff16cacb8960afa2f0531d99fd00be354792c5.


R2861 | a3ff16ca | anotak | 06.02.2017, 03:47
--------------------------------------------------------------------------------
actionmanager change

actionmanager change


R2860 | 6971f6df | ZZYZX | 04.02.2017, 21:03
--------------------------------------------------------------------------------
Internal: ~ConfigurationInfo destructor might be called before full construction took place


R2859 | 5a5c6d04 | ZZYZX | 04.02.2017, 16:25
--------------------------------------------------------------------------------
Internal: ZScriptTokenizer shouldn't reinitialize static stuff on every construction


R2858 | e6ca4958 | ZZYZX | 03.02.2017, 08:15
--------------------------------------------------------------------------------
Fixed: links should now open in the default browser and not what GZDB thinks to be the default browser.
Fixed: ZScript parser should no more crash on severely invalid code.


R2857 | 7e502a1f | ZZYZX | 02.02.2017, 06:34
--------------------------------------------------------------------------------
Fixed: color_absolute is not actually in GZDoom


R2856 | cb8473fa | ZZYZX | 01.02.2017, 19:16
--------------------------------------------------------------------------------
Added: 3D floor should be affected by control sector's color_floor and color_ceiling.


R2855 | 76b2b1be | ZZYZX | 01.02.2017, 18:10
--------------------------------------------------------------------------------
Added: an option to display image sizes below names, not over texture previews


R2854 | 71440fb2 | ZZYZX | 01.02.2017, 16:29
--------------------------------------------------------------------------------
Implemented more reliable dynlight-surface angle clip threshold


R2853 | fc7b9ec9 | ZZYZX | 01.02.2017, 15:53
--------------------------------------------------------------------------------
Removed dynlight-surface angle clip threshold - it didn't work properly anyway


R2852 | 469942d2 | ZZYZX | 01.02.2017, 08:57
--------------------------------------------------------------------------------
Fixed: glow should apply before Doom64 coloring


R2851 | 42c2fc20 | ZZYZX | 01.02.2017, 08:48
--------------------------------------------------------------------------------
Added: rendering of Doom64 lighting


R2850 | b80ead12 | ZZYZX | 01.02.2017, 07:29
--------------------------------------------------------------------------------
Added custom fields for Doom64 lighting in the ZDoom configuration


R2849 | 24c8b049 | ZZYZX | 30.01.2017, 05:20
--------------------------------------------------------------------------------
fixed: First and last texture entires could never be selected using up/down controls


R2848 | 1cd255fb | ZZYZX | 29.01.2017, 03:56
--------------------------------------------------------------------------------
Fixed: autoaligning and limited floodfill didn't work for selection.


R2847 | f4947a20 | ZZYZX | 26.01.2017, 14:33
--------------------------------------------------------------------------------
Added: more magic to the autoalign/select neighbours logic; These functions should not anymore wrap around to the opposite side of two-sided linedefs, allowing you to select back and front sides separately using shift+click, and reducing infinite broken autoalign loops.


R2846 | dd48b5ed | ZZYZX | 26.01.2017, 11:01
--------------------------------------------------------------------------------
Fixed: internal images were a bit broken by the previous commit


R2845 | 7de5d10c | ZZYZX | 26.01.2017, 08:09
--------------------------------------------------------------------------------
Fixed: long texture names are no longer activated for Doom flat images (GZDoom doesn't support these)


R2844 | 5ebdbd12 | ZZYZX | 25.01.2017, 16:31
--------------------------------------------------------------------------------
Fixed: 65:Plat_UpByValue had incorrect argument description


R2843 | ee936152 | ZZYZX | 21.01.2017, 04:05
--------------------------------------------------------------------------------
ZScript: added #region support


R2842 | 4c636a6d | ZZYZX | 21.01.2017, 03:16
--------------------------------------------------------------------------------
ZScript: added support for //$GZDB_SKIP special comment in the root scope.


R2841 | 8c9514fb | ZZYZX | 21.01.2017, 02:44
--------------------------------------------------------------------------------
Fixed: broken previous gitbuild


R2840 | a5a942c7 | ZZYZX | 21.01.2017, 02:13
--------------------------------------------------------------------------------
Fixed: lump saving in script editor after editing archive with SLADE.\n Fixed: checking for concurrent modification in script editor while trying to save the lump.


R2839 | a705e47f | ZZYZX | 19.01.2017, 23:59
--------------------------------------------------------------------------------
Fixed GLDEFS attenuate 1 and subtractive 1 logic


R2838 | 49f55120 | ZZYZX | 19.01.2017, 23:27
--------------------------------------------------------------------------------
Added: GLDEFS support for 'attenuate 1' keyword


R2837 | 30a5edfd | ZZYZX | 19.01.2017, 23:17
--------------------------------------------------------------------------------
Added: attenuated dynamic light support


R2836 | 819ef649 | ZZYZX | 19.01.2017, 08:16
--------------------------------------------------------------------------------
Fixed: wild exception while replacing ZScript actor from DECORATE


R2835 | 55b24eef | ZZYZX | 18.01.2017, 07:35
--------------------------------------------------------------------------------
Fixed: ZScript: scale property should be expanded into xscale and yscale; Fixed: if actor's Spawn state starts with TNT1, first non-TNT1 frame will be used


R2834 | 87fdd67f | ZZYZX | 17.01.2017, 19:34
--------------------------------------------------------------------------------
ZScript: himBHcomment arguments should be stripped of whitespace


R2833 | a1dc4bb1 | ZZYZX | 17.01.2017, 19:19
--------------------------------------------------------------------------------
Internal: Remembered various ZScript operators for the future; Script Editor: fixed script type icons


R2832 | 7a70ac8c | ZZYZX | 17.01.2017, 10:40
--------------------------------------------------------------------------------
Internal: removed parser stuff from ActorStructure, StateStructure, StateGoto classes


R2831 | b783ea1c | ZZYZX | 17.01.2017, 10:20
--------------------------------------------------------------------------------
ZScript: enabled custom GZDB actor properties in Default block (//$ comments, same as DECORATE)


R2830 | a85a7a40 | ZZYZX | 17.01.2017, 09:39
--------------------------------------------------------------------------------
Renamed default category Decorate to User-defined


R2829 | c1387a8e | ZZYZX | 17.01.2017, 09:19
--------------------------------------------------------------------------------
Internal: refactored ZScriptTokenizer.ExpectToken for less redundancy


R2828 | dc72c533 | ZZYZX | 17.01.2017, 06:28
--------------------------------------------------------------------------------
ZScript: fixed odd cases of inheritance (class SpecialShotgun : Shotgun replaces Shotgun) causing stack overflow


R2827 | 05a160b5 | ZZYZX | 17.01.2017, 06:13
--------------------------------------------------------------------------------
ZScript: moved actor inheritance code to separate step; ZScript: ported game configuration inheritance code from DECORATE


R2826 | 8fa63cae | ZZYZX | 17.01.2017, 05:58
--------------------------------------------------------------------------------
Fixed: DECORATE and ZScript parsers would ignore TNT1 when used in states


R2825 | 0787f960 | ZZYZX | 17.01.2017, 05:53
--------------------------------------------------------------------------------
GLDEFS, MODELDEF: Included ZScript actors in missing class check


R2824 | 3bdfadc1 | ZZYZX | 17.01.2017, 05:41
--------------------------------------------------------------------------------
ZScript: implemented 'transient' and 'property' keywords


R2823 | 76213ae1 | ZZYZX | 17.01.2017, 03:56
--------------------------------------------------------------------------------
Internal: tried to fix case sensitivity issues in X11R6RGB colors


R2822 | 17fb9157 | ZZYZX | 17.01.2017, 03:51
--------------------------------------------------------------------------------
Fixed: MAPINFO parser wouldn't take quoted OutsideFogDensity


R2821 | 76ce87ea | ZZYZX | 16.01.2017, 13:10
--------------------------------------------------------------------------------
Fixed null reference access while searching for superclass state; Fixed incorrect parsing of random() in frame duration; Fixed incorrect parsing of quoted sprite names


R2820 | 37a3eab1 | ZZYZX | 16.01.2017, 12:18
--------------------------------------------------------------------------------
Enabled prototype ZScript support


R2819 | 8afd01f6 | ZZYZX | 16.01.2017, 09:20
--------------------------------------------------------------------------------
Internal: Disconnected ZDoom actor state data from DECORATE parsing code


R2818 | a0674f13 | ZZYZX | 16.01.2017, 07:10
--------------------------------------------------------------------------------
Internal: finished enumeration of ZSCript actor properties and flags


R2817 | ad5b542c | ZZYZX | 16.01.2017, 06:20
--------------------------------------------------------------------------------
Internal: finished enumeration of ZScript actor fields and methods


R2816 | b42de7db | ZZYZX | 16.01.2017, 02:49
--------------------------------------------------------------------------------
Internal: Moved ZScript class initialization logic to after querying all lumps


R2815 | db088027 | ZZYZX | 16.01.2017, 01:08
--------------------------------------------------------------------------------
Enabled DECORATE classes to inherit ZScript ones


R2814 | 6147ed23 | ZZYZX | 16.01.2017, 00:35
--------------------------------------------------------------------------------
Internal: disconnected actor parsing from generic ZDoom actor structure


R2813 | fbf1aefe | ZZYZX | 15.01.2017, 23:21
--------------------------------------------------------------------------------
Internal: Fixed class extension, error reporting on invalid top-level keyword


R2812 | 856cb9f8 | ZZYZX | 15.01.2017, 23:03
--------------------------------------------------------------------------------
Internal: Added ZScriptParser.cs, ZScriptTokenizer.cs


R2811 | 38ffc861 | ZZYZX | 15.01.2017, 23:00
--------------------------------------------------------------------------------
Internal: started implementing ZScript parser. Nothing works for now, aside from the actual parsing code.


R2810 | 96ffb786 | ZZYZX | 15.01.2017, 17:12
--------------------------------------------------------------------------------
Finished upgrading to VS2015


R2809 | e0fb41d3 | ZZYZX | 15.01.2017, 05:30
--------------------------------------------------------------------------------
Changed ZDoom/GitHub links so that people can report issues to the correct page


R2808 | de781072 | ZZYZX | 15.01.2017, 04:20
--------------------------------------------------------------------------------
Updated README.md


R2807 | de46f297 | ZZYZX | 15.01.2017, 04:20
--------------------------------------------------------------------------------
Updated README.md


R2806 | 5a152767 | ZZYZX | 15.01.2017, 04:19
--------------------------------------------------------------------------------
Updated README.md


R2805 | 5e110729 | ZZYZX | 15.01.2017, 04:12
--------------------------------------------------------------------------------
Added IOException handling to image loading from disk (fixes GZDB Git issue #8)


R2804 | 8277d7b6 | ZZYZX | 15.01.2017, 02:39
--------------------------------------------------------------------------------
fixed: Classic Texture Select: selected item in white background is supposed to be blue;
fixed: Texture Select: visible items were not clipped correctly;
fixed: 128x128 texture previews were too large for small window size in Texture Set editor


R2803 | 98432339 | ZZYZX | 15.01.2017, 02:00
--------------------------------------------------------------------------------
Funny commit to make it increment the revision number. Also, edited Updater.ini.


R2802 | fa7c536a | ZZYZX | 15.01.2017, 00:41
--------------------------------------------------------------------------------
Product name somehow reset AGAIN. Fixed.


R2801 | 741897af | ZZYZX | 15.01.2017, 00:40
--------------------------------------------------------------------------------
Actually changed the product name


R2800 | 668cb137 | ZZYZX | 15.01.2017, 00:22
--------------------------------------------------------------------------------
Updated GIT build batch


R2799 | 107b4887 | ZZYZX | 15.01.2017, 00:20
--------------------------------------------------------------------------------
Fixed the output name in gzbuilder_setup.iss


R2798 | 58211523 | ZZYZX | 15.01.2017, 00:14
--------------------------------------------------------------------------------
Always show the revision number in window title, also renamed to GZDB-Bugfix


R2797 | ebd7fb1a | ZZYZX | 14.01.2017, 23:35
--------------------------------------------------------------------------------
Upgrade to VS2015 (14.0)


R2796 | 36a5aa6c | ZZYZX | 09.01.2017, 13:32
--------------------------------------------------------------------------------
Even with used textures on top disabled, textures should be separate from directories


R2795 | 88ff83b7 | ZZYZX | 09.01.2017, 06:21
--------------------------------------------------------------------------------
Use the word 'flats' if currently browsing flats


R2794 | e43e3e12 | ZZYZX | 09.01.2017, 06:11
--------------------------------------------------------------------------------
Removed global 'available textures' header from classic view


R2793 | 36381c51 | ZZYZX | 09.01.2017, 06:00
--------------------------------------------------------------------------------
Should not have used textures category if not having them on top


R2792 | 819d2788 | ZZYZX | 09.01.2017, 05:47
--------------------------------------------------------------------------------
Initial classic view mode in texture browser


R2791 | b3442f4f | MaxED | 08.01.2017, 23:05
--------------------------------------------------------------------------------
Merge branch 'master' of https://github.com/m-x-d/GZDoom-Builder


R2790 | 2b24ce3c | MaxED | 08.01.2017, 23:04
--------------------------------------------------------------------------------
Updated, Textures Browser: texture name length is now taken into account when calculating the width of texture items.
Internal: moved thing helper shapes creation logic from ThingsMode to LinksCollector.


R2789 | ae11b169 | Ioan Chera | 08.01.2017, 20:06
--------------------------------------------------------------------------------
Eternity config: add thing class1 class2 class3 (#5)

* Updated the EE config linedefs, fixing stuff around
* Added back the class definitions for the Eternity namespace
The only namespaces where they're unneeded are the vanilla games. Otherwise it's safe and important to keep class1, class2, class3 in case Hexen pops up
* Added new special (273) to UDMF Eternity linedefs
* Added special 140 to the Eternity linedefs


R2788 | 9dc31afa | Ioan Chera | 07.01.2017, 23:56
--------------------------------------------------------------------------------
Updated the EE config linedefs, fixing stuff around (#4)


R2787 | a41058be | MaxED | 07.01.2017, 21:53
--------------------------------------------------------------------------------
Fixed, Script Editor: bottom panel was not automatically expanded after adding a script error.
Fixed, Script Editor: in some cases extra indentation was added to the duplicated line when using "Duplicate Line" command.
Added, Script Editor: some editor comments were missing from ZDoom_DECORATE.cfg.
Fixed, Game Configurations: fixed a crash when overriding an existing linedef action definition by a one from a different category (this fixes Issue #1).


R2786 | 1c684f72 | MaxED | 06.01.2017, 13:59
--------------------------------------------------------------------------------
Added, Things mode, Visual mode: added the ability to specify minimum/maximum argument range hint shapes using special DECORATE comments and Game Configuration properties (loosely based on range finder patch by Xabis).
Updated documentation ("Game Configuration - Action Argument Settings" and "DECORATE keys" pages).


R2785 | cd854779 | MaxED | 06.01.2017, 11:01
--------------------------------------------------------------------------------
Fixed, Classic modes, UDMF: grid size didn't go below 1 mu. when zooming in when "Dynamic grid size" option was enabled.
Internal: restored GridSetup DB2 compatibility.
Updated ZDoom_ACS.cfg (SetFogDensity, SetSectorGlow).


R2784 | bd74d1d3 | Max Waine | 05.01.2017, 20:58
--------------------------------------------------------------------------------
Added Plane_Copy to Eternity config (#2)


R2783 | a7d24178 | MaxED | 04.01.2017, 14:28
--------------------------------------------------------------------------------
Visual mode, UDMF: added rendering support for fogdensity and floor/ceiling glow properties.
Internal, build tools: use origin/master to get commits count and current hash instead of local master.


R2782 | c9ab3274 | MaxED | 30.12.2016, 11:45
--------------------------------------------------------------------------------
Merge branch 'master' of https://github.com/m-x-d/GZDoom-Builder


R2781 | 7052dbec | MaxED | 30.12.2016, 11:31
--------------------------------------------------------------------------------
Fixed, Sector Edit window, UDMF: fixed some incorrect tooltips.


R2780 | 6bb37efb | MaxED | 30.12.2016, 11:43
--------------------------------------------------------------------------------
Changed some step values to better match with the values being edited.


R2779 | 9c1ea6fd | MaxED | 30.12.2016, 11:31
--------------------------------------------------------------------------------
Fixed, Sector Edit window, UDMF: fixed some incorrect tooltips.


R2778 | f44ddc23 | MaxED | 29.12.2016, 19:37
--------------------------------------------------------------------------------
Internal: looks like "git rev-parse --short" is not guaranteed to output a 7-char hash...


R2777 | 92cc0133 | Ioan Chera | 29.12.2016, 18:58
--------------------------------------------------------------------------------
Eternity config (#1)

Updated the Eternity UDMF configurations with the latest items.


R2776 | a9c19754 | MaxED | 29.12.2016, 16:15
--------------------------------------------------------------------------------
Added, Sector Edit window, UDMF: added UI support for "floor_reflect", "ceiling_reflect", "floorglowcolor", "floorglowheight", "ceilingglowcolor", "ceilingglowheight" and "fogdensity" UDMF properties.
Updated ZDoom ACC.


R2775 | be1e7996 | MaxED | 28.12.2016, 13:24
--------------------------------------------------------------------------------
Internal: Git commit hash is how shown in the About window.
Internal: Git commit hashes are now shown in the Update window changelog.
Internal: Exception window now links to GitHub Issue Tracker instead of zdoom.org GZDB thread.


R2774 | 9f4e700c | MaxED | 28.12.2016, 12:32
--------------------------------------------------------------------------------
Updated Eternity game configurations with the ones provided by printz.
Internal: renamed several build batch files, updated relevant info in the documentation.


R2773 | 659250e8 | MaxED | 28.12.2016, 12:29
--------------------------------------------------------------------------------
Internal: removed some old unused resource/test/documentation files. This reduces repository size by approx. 20Mb.


R2772 | be7ba0a0 | MaxED | 27.12.2016, 14:59
--------------------------------------------------------------------------------
Added: minimum grid size is now 0.125 instead of 1.


R2771 | e1213074 | MaxED | 27.12.2016, 14:52
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2770 | 2bffd068 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2769 | 16593e3f | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2768 | c746f3b5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2767 | f5dd1430 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2766 | 072271ea | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2765 | 7a320728 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2764 | 2d78ae71 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2763 | 07df0862 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2762 | a6330346 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2761 | a715d903 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2760 | 6cc07cd4 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2759 | 642c3d38 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2758 | 0b3a128f | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2757 | b50361fb | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2756 | 17865428 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2755 | f2fb07c0 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2754 | 4c499aab | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2753 | 509d23b4 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2752 | 60b6a90d | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2751 | 17c3fa41 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2750 | 1584a180 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2749 | c9877c04 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2748 | 50b04c0b | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2747 | 91d5c6c9 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2746 | 1755a4f0 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2745 | 4df915c3 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2744 | 08635012 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2743 | cf1279db | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2742 | 65babc18 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2741 | 8bc73767 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2740 | c6a1f908 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2739 | cddd12bf | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2738 | 3c33eabb | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2737 | 8ba249bd | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2736 | a5869600 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2735 | 9979647d | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2734 | 15bbf380 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2733 | 2091b851 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2732 | 39bdc350 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2731 | 460b3b21 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2730 | 50722ea2 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2729 | f9a1e2ac | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2728 | 29c58825 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2727 | c36ce4ae | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2726 | a96e4604 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2725 | 4b75b7c9 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2724 | 270c7bc4 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2723 | 7cd8ad24 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2722 | 6945bac7 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2721 | be66cfb3 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2720 | 4015db28 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2719 | 7ba5e4f9 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2718 | 4115d73b | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2717 | 9889f756 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2716 | 52b85895 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2715 | 8eb97a4e | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2714 | d68002ab | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2713 | 507ea669 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2712 | 28f83eaa | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2711 | 34df5652 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2710 | 9c5bbe8d | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2709 | 6c2ca31b | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2708 | 513cb320 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2707 | 60b6d3cb | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2706 | 5fb4e3e0 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2705 | e049b9d4 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2704 | 96a599a2 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2703 | 731bd825 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2702 | cf4c5003 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2701 | 7b510317 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2700 | 6f25254f | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2699 | c8195d9b | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2698 | 5da768f3 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2697 | 00fe3924 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2696 | afd1c650 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2695 | a3545b7d | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2694 | 9b8677a5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2693 | 9d808038 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2692 | a2fd4e9b | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2691 | 400bd0ac | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2690 | d6dd1fd5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2689 | 2cd3f1b5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2688 | d28856e6 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2687 | 0eaee1b3 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2686 | d293c8b6 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2685 | f1a82387 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2684 | 4292395f | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2683 | 449cffe6 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2682 | b0b517f5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2681 | 2604df89 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2680 | 2cb05cfa | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2679 | 010d3db7 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2678 | ebcec12c | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2677 | 994df539 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2676 | e3b1ea94 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2675 | fabef11f | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2674 | ba270cdf | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2673 | 6e379e07 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2672 | c9cd01bd | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2671 | d9e7eca1 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2670 | 8f3643cd | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2669 | 779dd0c5 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2668 | 45c0335a | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2667 | acbba3f2 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2666 | 2657114c | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2665 | 2c27f218 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2664 | 0844729d | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2663 | c57576fb | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2662 | bca2fba7 | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2661 | 7759480a | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2660 | baadfede | MaxED | 27.12.2016, 14:51
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2659 | e695f296 | MaxED | 27.12.2016, 14:50
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2658 | b87ecfcf | MaxED | 27.12.2016, 14:48
--------------------------------------------------------------------------------
Obligatory commit count matching procedure. Sorry for inconvenience...


R2657 | 84886d10 | MaxED | 27.12.2016, 13:12
--------------------------------------------------------------------------------
Internal: more updates to the build toolchain...


R2656 | ed323373 | MaxED | 27.12.2016, 11:12
--------------------------------------------------------------------------------
Internal: updated the manual ("Compiling GZDoom Builder" page) and UI to reference GitHub/Git instead of SourceForge/SVN.
Internal: post build event in Builder.csproj worked only when compiling using batch files.
Internal: updated README.md.


R2655 | f9c2bbe4 | MaxED | 27.12.2016, 00:05
--------------------------------------------------------------------------------
Internal: updated build tools and scripts to work with Git instead of SVN.


R2654 | 9e056d80 | MaxED | 26.12.2016, 15:44
--------------------------------------------------------------------------------
Create README.md


R2653 | a8f4f67f | MaxED | 26.12.2016, 14:37
--------------------------------------------------------------------------------
Internal: rewritten part of NodesViewerMode to use iteration instead of recursion.
Internal: post build event in Builder.csproj worked only in VS 2008.


R2652 | b37bc84f | MaxED | 25.12.2016, 22:00
--------------------------------------------------------------------------------
Fixed, Script Editor: fixed incorrect function calltip position when the cursor was positioned in a wrapped part of a wrapped line.
Updated ZDoom_DECORATE.cfg.


R2651 | 26687a2e | MaxED | 24.12.2016, 22:52
--------------------------------------------------------------------------------
Added, Textures Browser: "[All]" folder is now added to each map resource. It holds all textures found in that resource.
Fixed, Textures Browser: only name filtering is now applied to folder-type image items, filtering is never applied to "go to parent folder" image items.
Fixed, Textures Browser: in some cases "Backspace" key was ignored by the Filter textbox.
Fixed, Textures Browser: "Ctrl-Backspace" key combo now clears Filter textbox instead of adding an unknown char to it.


R2650 | f2db0e1d | MaxED | 23.12.2016, 13:39
--------------------------------------------------------------------------------
Changed, Textures Browser: frames/names of used textures are now drawn using a different color.
Changed, Textures Browser: the browser now toggles between showing used textures on the top of the list and showing textures in alphabetical order instead of toggling between showing all textures and used textures.


R2649 | 447851e4 | MaxED | 22.12.2016, 16:04
--------------------------------------------------------------------------------
Added, Textures Browser: redesigned textures list. Textures preview size can now be changed from the Textures Browser window. Folders are now shown in the textures list.
Fixed, Script Editor: Find and Replace window now sets keyboard focus to the input textbox when opening the window/switching between tabs.
Fixed, Nodes Viewer mode: SEGS overflows were not handled, causing a crash. Also extended SEGS limit is now used.
Updated ZDoom_DECORATE.cfg (A_SetSize).


R2648 | d73ea867 | MaxED | 22.12.2016, 01:03
--------------------------------------------------------------------------------
Fixed, Script Editor: MD5 hash of text files stored in PK3 was calculated incorrectly, resulting in false warning messages when saving.


R2647 | cfc92d90 | MaxED | 16.12.2016, 22:23
--------------------------------------------------------------------------------
Added, Draw Lines mode: added "Remove First Vertex" action (Ctrl-Backspace). It removes the first drawn vertex from the drawing session. Renamed "Remove Previous Vertex" action to "Remove Last Vertex".
Changed, Classic modes: added a limit on how far the view can be scrolled from the editable map area.
Fixed, Drag geometry modes: in some cases incorrect vertices were removed when using "Replace with dragged geometry" drag mode.
Fixed, Game configurations: sector special 195 ("Hidden Sector") was missing from Hexen/UDMF specials list.


R2646 | 45c3cbaa | MaxED | 12.12.2016, 13:35
--------------------------------------------------------------------------------
Added, Script Editor: added script configurations / auto-detection support for GAMEINFO, FONTDEFS and KEYCONF text lumps.
Fixed, "Open Map Options" and "Change Map" windows: fixed incorrect size of the items in the maps list when using high-DPI scaling.
Updated ZDoom_DECORATE.cfg and ZDoom_MAPINFO.cfg.


R2645 | b283fab7 | MaxED | 10.12.2016, 22:33
--------------------------------------------------------------------------------
Fixed, action arguments control: in some cases named script name was not displayed.
Fixed, Script Editor: Delete key was not working in the text editor (because it was hijacked by context menu action, which requires a selection to be active).


R2644 | da024743 | MaxED | 08.12.2016, 14:11
--------------------------------------------------------------------------------
Applied skybox cubemap creation performance increase patch by Xabis.
Added, MAPINFO parser: added support for "Skybox" map block property.


R2643 | 88363a1a | MaxED | 08.12.2016, 13:10
--------------------------------------------------------------------------------
Added, Script Editor: added "Find usages" option (available in the "Search" menu, via text editor context menu, via Ctrl-Shift-F shortcut and in the "Find and Replace" window).
Added, Script Editor: double-clicking text resource tab header now shows the corresponding resource in the Resources tree.
Updated, Game configurations, UDMF: added several missing Thing renderstyles.


R2642 | 5dd45ffd | MaxED | 02.12.2016, 14:45
--------------------------------------------------------------------------------
Updated, Script Editor: redesigned "Find and Replace" window. It can now search/replace in all opened tabs and all detected text resources.
Fixed, Script Editor: resources list control was incorrectly positioned when using DPI scaling.


R2641 | a31c6b66 | MaxED | 30.11.2016, 21:12
--------------------------------------------------------------------------------
Fixed, Script Editor: resources navigator was always loading the first WAD lump with matching name when trying to open any of several WAD lumps with matching names.
Reverted, Visual mode: looks like all additional cases of displaying sky hack added in r2755 were actually undefined engine behaviors, not the "proper" shy hack... Reverted implementation to the wiki definition of the sky hack.


R2640 | 019e26f1 | MaxED | 28.11.2016, 23:17
--------------------------------------------------------------------------------
Fixed, Tag Explorer: in some cases Tag Explorer update logic was switching focus from the Script Editor to the main window.


R2639 | 1523d06e | MaxED | 28.11.2016, 21:01
--------------------------------------------------------------------------------
Updated, Visual mode: some cases when the sky hack must be applied were not handled.
Updated, Script editor: script editor was unable to show error location after double-clicking on it in the Warnings and Errors window when said location was inside of a WAD located in a PK3 file.
Updated, text lumps tracking: already parsed DECORATE/GLDEFS lumps are now added to the text lumps list even when DECORATE/GLDEFS parsing fails, allowing you to fix errors without the need to use external tools.
Fixed: in some cases the editor could stuck in an infinite loop when searching for wad lumps.


R2638 | 18dc8ceb | MaxED | 26.11.2016, 21:03
--------------------------------------------------------------------------------
Fixed: in some cases only the last data (sprite/texture/patch etc.) range was detected in WADs.
Fixed, Script Editor: Cut/Copy/Paste/Undo/Redo keyboard shortcuts were handled incorrectly when quick search textbox was focused.
Fixed, Script Editor: Find next/Find previous quick search button actions were handled incorrectly.
Updated documentation.


R2637 | aecd017b | MaxED | 26.11.2016, 01:02
--------------------------------------------------------------------------------
Added, Errors and Warnings window: most of warnings/errors related to (G)ZDoom text lump parsing can now be double-clicked to show warning/error source in the Script Editor.
Fixed: some map format conversion errors were never displayed, because errors list was cleared after performing map conversion.
Fixed: 3d floor indicators in 2D modes were not updated after leaving Visual mode.
Fixed: some UDMF-only interface buttons were never removed after converting map format from UDMF.


R2636 | 9553042c | MaxED | 24.11.2016, 22:09
--------------------------------------------------------------------------------
Added, Script Editor: unreferenced ACS files are now shown in the Resources list.
Added, Script Editor: MENUDEF and SBARINFO files/lumps are now shown in the Resources list.
Fixed, ACS handling: fixed a crash when trying to parse an #include file, when specified path was absolute.


R2635 | 894279b4 | MaxED | 24.11.2016, 12:55
--------------------------------------------------------------------------------
Added, Script Editor: added "Script Navigator" tab. It shows and allows to open text resources loaded by the editor.
WARNING: because of the large amount of added/modified code, bugs are possible, so backup your resources, save often and report bugs.


R2634 | 36ff694e | MaxED | 22.11.2016, 13:07
--------------------------------------------------------------------------------
Fixed: window size and location was not saved when closing a maximized or minimized window.


R2633 | 21cab1d1 | MaxED | 21.11.2016, 14:03
--------------------------------------------------------------------------------
Added, Game configurations, ZDoom: Ambient sound things (14001 - 14064) were missing arguments definitions.
Fixed, Make Sectors mode: in some cases sector shape detection logic returned incorrect shape, or no shape at all.


R2632 | 0cc53742 | MaxED | 19.11.2016, 21:43
--------------------------------------------------------------------------------
Fixed, Things mode: fixed a crash when deleting Light/Ambient Sound things when "Show Dynamic Light Radii" / "Show Ambient Sound Radii" settings were enabled.
Fixed: WAD lump index was not appended to lump name when reporting errors during ZDoom text lumps parsing.


R2631 | c0b46bc6 | MaxED | 18.11.2016, 18:34
--------------------------------------------------------------------------------
Added, Game configurations, ZDoom: added Line_SetBlocking (55) linedef action.
Fixed, Draw Rectangle mode: fixed a crash caused by incorrectly changing text labels array when accepting the drawing.
Fixed, "Check unknown ACS scripts" error check: named scripts check was performed incorrectly causing it to fail on script names containing uppercase letters.


R2630 | 787b78af | MaxED | 17.11.2016, 01:17
--------------------------------------------------------------------------------
Fixed, Visual mode, UDMF: "lightfloor" sector property was not applied when calculating thing brightness.
Fixed, Directional Shading mode: "lightabsolute" / "lightfloorabsolute" properties were checked incorrectly.


R2629 | 6c38ab26 | MaxED | 16.11.2016, 21:43
--------------------------------------------------------------------------------
This somehow evaded previous commit...


R2628 | fb937b9e | MaxED | 16.11.2016, 21:31
--------------------------------------------------------------------------------
Added "Apply Directional Shading" mode. It can be used to apply directional colored flat shading to sloped terrain sectors (line and vertex slopes are supported) and sidedefs.
Updated ZDoom ACC.
Updated ZDoom_ACS.cfg.


R2627 | 7d3a0c77 | MaxED | 14.11.2016, 11:22
--------------------------------------------------------------------------------
Changed, Game configurations: "default" property is no longer mandatory for universal field definitions.
Fixed, Game Configurations window: map resources were not marked for reloading after pasting resources to currently used game configuration.
Fixed, Game configurations: "Platform Generic Change" action's arg2 value must be in octics.


R2626 | 83493928 | MaxED | 11.11.2016, 13:54
--------------------------------------------------------------------------------
Fixed: copied sidedef settings were not applied when using "Paste properties" and "Paste properties special" actions in Doom/Hexen map formats.


R2625 | 4306e277 | MaxED | 10.11.2016, 20:18
--------------------------------------------------------------------------------
Fixed map lumps duplication when saving the map several times after converting the map from/to UDMF map format by changing it in the Map Options window.
Fixed, cosmetic: in some cases incorrect resource loading time was displayed after saving the map.


R2624 | 0a6a6bbd | MaxED | 10.11.2016, 13:07
--------------------------------------------------------------------------------
Restored the ability to paste map elements copied in DB2/DB64.


R2623 | c2ef0802 | MaxED | 10.11.2016, 01:35
--------------------------------------------------------------------------------
Changed, Sector drawing: sector height is set to 0 when the nearest sector's height is &lt; 0 (previously default sector height was used when the nearest sector's height was &lt;= 0).


R2622 | 437fe9ce | MaxED | 09.11.2016, 11:07
--------------------------------------------------------------------------------
Updated, GLDEFS parser: updated glowing texture parsing logic to better match GZDoom logic.
Removed, GLDEFS parser: removed GLOOME glow definitions support code.


R2621 | fc9d18b9 | MaxED | 08.11.2016, 10:09
--------------------------------------------------------------------------------
Added high-DPI support to Updater.


R2620 | aa7abbf6 | MaxED | 04.11.2016, 13:41
--------------------------------------------------------------------------------
Updater: replaced "The editor needs to be closed" message with a custom window.


R2619 | 5f245423 | MaxED | 04.11.2016, 10:48
--------------------------------------------------------------------------------
Added script editor configurations for the most of ZDoom text lumps.
A minor code refactoring.


R2618 | e7769524 | MaxED | 01.11.2016, 21:44
--------------------------------------------------------------------------------
Updated, Curve Linedefs mode: distance/angle are now changed using bigger increments when being modified by mouse-dragging. You can hold Shift to enable increments by 1 unit.
Updated, Curve Linedefs mode: changing angle by mouse-dragging when "Fixed circular curve" option is enabled is now performed in a more predictable way.
Updated, Curve Linedefs mode: generated geometry is now merged with existing geometry.
Added, Curve Linedefs mode: a hint label is now displayed when modifying settings using mouse-dragging.
Added, Curve Linedefs mode: number of curve vertices can now be changed using LMB+RMB-drag.


R2617 | 9534a20e | MaxED | 31.10.2016, 19:52
--------------------------------------------------------------------------------
Optimized map geometry merging performance when creating drawn lines.
Optimized map geometry merging performance when pasting map geometry.
Added, Curve Linedefs mode: added "Flip Curve" button.
Updater: partially rewrote fix from the previous commit.


R2616 | 80761dbc | MaxED | 31.10.2016, 15:49
--------------------------------------------------------------------------------
Updater: fixed a crash when trying to set taskbar progress on Windows XP.


R2615 | 4c2b6092 | MaxED | 28.10.2016, 23:32
--------------------------------------------------------------------------------
Silenced some compiler warnings...


R2614 | a70d9d00 | MaxED | 28.10.2016, 23:08
--------------------------------------------------------------------------------
Fixed the editor crashing/locking up when trying to read TEXTUREX patch containing invalid data.


R2613 | 8570922d | MaxED | 28.10.2016, 23:07
--------------------------------------------------------------------------------
Fixed the editor crashing/locking up when trying to read TEXTUREX patch containing invalid data.


R2612 | 3e132f1c | MaxED | 27.10.2016, 00:33
--------------------------------------------------------------------------------
Changed, Curve Linedefs mode: re-designed the mode UI. Alternative control options are now available (check Help tab while the mode is active).
Changed, Curve Linedefs mode: changed curve generation logic. Setting Distance to 0 will now divide selected linedefs into equal parts.
Changed, Curve Linedefs mode: curve vertices are now drawn.
Updated ZDoom_DECORATE.cfg.


R2611 | a6351a9d | MaxED | 25.10.2016, 01:30
--------------------------------------------------------------------------------
Updated: sector triangulation logic now works ~50% faster than DB2 implementation.


R2610 | 9908e411 | MaxED | 24.10.2016, 21:19
--------------------------------------------------------------------------------
Added, Game configurations: added "ignoreddirectories" parameter. It lists directory names to be ignored when loading PK3/PK7/Directory resources.
Added, Game configurations: added "ignoredextensions" parameter. It lists file extensions to be ignored when loading PK3/PK7/Directory resources.
Updated: sector triangulation logic now works ~20% faster.
Changed: a case when a pk3/pk7 archive contains several entries with identical filename is now treated as a warning, not as an error.
Fixed, Visual mode: absolute floor/ceiling brightness should not be affected by brightness transfer effects (like 3d floors).
Fixed, Draw Lines mode: in some cases unclosed sectors were created when several points were successively drawn at the same location.
Updated documentation.


R2609 | 0b853c9d | MaxED | 14.10.2016, 20:08
--------------------------------------------------------------------------------
Actually, removing Updater.exe from version control was not such a bright idea...


R2608 | ebb372bc | MaxED | 14.10.2016, 20:01
--------------------------------------------------------------------------------
Updater: moved SharpCompress code into a separate embedded library. Seems to stop some anti-viruses detecting it as a trojan/virus.
Updated ZDoom_DECORATE.cfg (A_SetInventory).


R2607 | 70d35bf1 | MaxED | 11.10.2016, 14:58
--------------------------------------------------------------------------------
Added, Edit Sectors window: added UI for floor/ceiling portals.
Updated ZDoom_DECORATE.cfg.
Updated documentation ("Game Configuration - Sectors Settings" page).


R2606 | 908f5d4c | MaxED | 10.10.2016, 16:45
--------------------------------------------------------------------------------
Internal, tools: added VersionFromSVN and ChangelogMaker sources.


R2605 | 100c4ae9 | MaxED | 10.10.2016, 16:14
--------------------------------------------------------------------------------
Added: some numeric text inputs now support expressions (e.g. (23+15)*1.5). - inspired by https://www.doomworld.com/vb/doom-editing/91089-gzdoombuilder-patch-expression-evaluation-for-sector-heights/
Fixed, Game Configurations window: fixed a crash when switching to a game engine without the file path using the "Engine" drop-down.


R2604 | fe5302c7 | MaxED | 08.10.2016, 23:36
--------------------------------------------------------------------------------
Updater was using incorrect icon...


R2603 | 2c0f530b | MaxED | 08.10.2016, 23:09
--------------------------------------------------------------------------------
Fixed a crash when changing Custom Field type to Sector/Linedef/Thing Tag.
Changed the way editor is closed during the update process (updater now asks to close the editor after downloading the update package).
Added write access check before performing the update.
The editor can now update the updater.
Updater: merged relevant parts of SharpCompress into the updater source, reducing updater file size from 900 kb to 150 kb.
Updated ZDoom_DECORATE.cfg.


R2602 | a716d295 | MaxED | 06.10.2016, 16:30
--------------------------------------------------------------------------------
Updater: added write access check/warning.
Updater: error messages now display more info.
Updater: editor closing step is now performed after downloading the update.
Updater: added taskbar progress indication.
NOTICE: to obtain the updated updater, you'll need to download GZDB manually from http://devbuilds.drdteam.org/doombuilder2-gzdb/, because the updater can't update itself.
Added Updater source.


R2601 | 91e7809f | MaxED | 05.10.2016, 22:15
--------------------------------------------------------------------------------
Added, Things mode: sound radii are now shown for "Custom Ambient Sound" and "Custom Ambient Sound (no gravity)" things.


R2600 | 5ece55a6 | MaxED | 04.10.2016, 23:02
--------------------------------------------------------------------------------
Updated, Visual mode: WALLSPRITEs and FLATSPRITEs support rolling without the ROLLSPRITE flag.
Updated, Visual mode: unflipped FLATSPRITEs.
Updated, DECORATE parser: added duplicate actor definition check.


R2599 | 53a317c0 | MaxED | 04.10.2016, 11:53
--------------------------------------------------------------------------------
Updated, Visual mode: updated FLATSPRITE support to match the current GZDoom implementation.
Fixed, Visual mode: things in sectors affected by line slope effect were not updated when sector height was indirectly changed.
Game configurations: added "internalsoundnames" property.
Updated documentation ("Game Configuration - Basic Settings" page).


R2598 | 07db2506 | MaxED | 03.10.2016, 13:42
--------------------------------------------------------------------------------
Added, Things mode: minimum/maximum sound radii can now be displayed for ZDoom's Ambient Sound things.
Added, Things mode: added "Show Light Radii" and "Show Sound Radii" main toolbar and View menu buttons.
Fixed, Action arguments control: invisible splitter between args1-3 and args4-5 is no longer draggable.
Updated ZDoom ACC (SetTranslation).
Updated ZDoom_ACS.cfg (SetTranslation).


R2597 | 8c6971a4 | MaxED | 27.09.2016, 21:39
--------------------------------------------------------------------------------
Changed, Vertices/Linedefs/Sectors/Things modes: selected map element is no longer deselected after accepting Edit window when it was the only selected map element when the Edit window was opening.


R2596 | 8cc47ee1 | MaxED | 26.09.2016, 14:53
--------------------------------------------------------------------------------
Added: guidelines color is now configurable.
Added: guidelines can now be enabled in Draw Rectangle/Ellipse/Grid modes.
Changed, Draw Lines mode: perpendicular guidelines are now drawn for horizontal/vertical lines.
Updated, Draw Ellipse mode: the shape now always touches all sides of the bounding box.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom ACC.


R2595 | 9c4969cc | MaxED | 22.09.2016, 22:24
--------------------------------------------------------------------------------
Changed, Visplane Explorer mode: calculated data is now fully reset when toggling "Open doors" option.
Changed, Visplane Explorer mode: vpo.dll is now initialized when entering the mode instead of after opening a map.
Fixed inconsistent Hexen Puzzle Gears names between game configuration and spawn numbers list.
Updated ZDoom_DECORATE.cfg (GetMissileDamage).


R2594 | 94030289 | MaxED | 19.09.2016, 01:46
--------------------------------------------------------------------------------
Fixed, Linedefs mode: linedef selection labels must be updated when performing undo/redo.
Fixed, Things mode: thing selection labels must be updated when performing undo/redo.
Fixed another case of invalid sectors being created after dragging map elements when using "Merge Dragged Geometry" and "Replace with Dragged Geometry" drag modes.


R2593 | 794ecdea | MaxED | 17.09.2016, 23:45
--------------------------------------------------------------------------------
Fixed: some stored window settings were incorrectly restored from the program configuration.


R2592 | bfd57379 | MaxED | 12.09.2016, 16:08
--------------------------------------------------------------------------------
Added, Map Analysis mode: added "Check unknown ACS scripts" error check.
Added, Map Analysis mode: added "Edit Thing..." option to "Unknown Thing" and "Obsolete Thing" error check results.
Added: a warning is now displayed when a thing has both voxel and model attached.
Changed, Thing/Linedef Info panels: unknown ACS script names/numbers are now shown in red.
Fixed, Edit Things window, UDMF: unneeded undo was created when opening the window.
Re-fixed: in some cases invalid sectors were created after dragging map elements when using "Merge Dragged Geometry" and "Replace with Dragged Geometry" drag modes, when at least one of dragged linedef was facing into an enclosed void area (previous fix entirely disabled the associated logic).


R2591 | 1e7f0e6b | MaxED | 11.09.2016, 21:27
--------------------------------------------------------------------------------
Fixed: added more sprite name sanity checks to MODELDF parser.


R2590 | c4518c60 | MaxED | 10.09.2016, 22:57
--------------------------------------------------------------------------------
Fixed a typo (Stalagtite - &gt; Stalagmite).
Updated ZDoom ACC (SetActorFlag).
Updated ZDoom_ACS.cfg (SetActorFlag).


R2589 | b1776155 | MaxED | 10.09.2016, 22:45
--------------------------------------------------------------------------------
Fixed: in some cases lines with only back side were created after dragging map elements when using "Merge Dragger Vertices Only" drag mode.
Fixed: in some cases invalid sectors were created after dragging map elements when using "Merge Dragged Geometry" and "Replace with Dragged Geometry" drag modes, when at least one of dragged linedef was facing into an enclosed void area.
Fixed a crash after drawing lines over a sector with unclosed/invalid boundaries.
Fixed(?): probably fixed a crash when closing Script Editor with an unsaved file during program termination.


R2588 | 8aa355ba | MaxED | 10.09.2016, 13:24
--------------------------------------------------------------------------------
Changed: position/size/state of the editor windows are now stored/applied in a uniform fashion.
Fixed: stored windows positions were not checked against current screen bounds, which may have resulted in windows being shown off-screen.


R2587 | 7e622fa2 | MaxED | 08.09.2016, 21:28
--------------------------------------------------------------------------------
Fixed, Visual mode, UDMF: only the clicked floor/ceiling surface was dynamically updated when changing texture offsets of multiple floors/ceilings by mouse-dragging.


R2586 | 314f4db4 | MaxED | 07.09.2016, 19:46
--------------------------------------------------------------------------------
Fixed: angle clamping logic was partially broken.


R2585 | c9f125aa | MaxED | 07.09.2016, 17:15
--------------------------------------------------------------------------------
Added Rendering toolbar items to the View menu.
Merged "Toggle models, dynamic lights and fog rendering" and "Toggle Geometry Effects" actions into "Toggle Enhanced Rendering Effects" action.
Removed "Dynamic light size" and "Dynamic light intensity" settings.
Updated documentation ("Rendering toolbar" page).


R2584 | 8333cab7 | MaxED | 06.09.2016, 21:14
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases mouse cursor movement was not clipped to the render area when focusing the editor after Alt-Tabbing from the Visual mode.
Addressed, Line drawing: in some cases extra vertices were created when drawing lines on top of nearly parallel non-cardinal lines.


R2583 | 6faa88f9 | MaxED | 06.09.2016, 14:05
--------------------------------------------------------------------------------
Updated, Visual mode, UDMF: "Change Texture Scale" actions now take camera and texture angles into account when used on floors/ceilings.
Changed: "+++" and "---" prefixes are now incremented on the first step instead of the second when used in any numeric inputs, which support prefixes, except action arguments.
Fixed, Visual mode, UDMF: texture offset/scale/rotation changes were applied several times when used on several 3d-floor floors/ceilings linked to the same control sector, when using "Move Texture Offsets" / "Change Texture Scale" / "Rotate Texture CW/CCW" actions.
Updated ZDoom ACC (DamageActor).
Updated ZDoom_ACS.cfg (DamageActor).


R2582 | 5baa770d | MaxED | 05.09.2016, 20:36
--------------------------------------------------------------------------------
Added "localsidedeftextureoffsets" Game configuration setting. When set to true, enables in-editor support for individual offsets of upper/middle/lower sidedef textures. Affects UDMF map format only. - based on diff patch by Altazimuth.


R2581 | f9b55979 | MaxED | 02.09.2016, 21:18
--------------------------------------------------------------------------------
Fixed several cases when certain texture manipulation-related actions caused a crash when performed on not-yet-loaded textures.


R2580 | 2d249748 | MaxED | 31.08.2016, 17:14
--------------------------------------------------------------------------------
Fixed, text parser: fixed a case when the parser tried to rewind before beginning of the stream when parsing unknown #block, when it was the first token of the file.


R2579 | f8cab5b1 | MaxED | 30.08.2016, 15:37
--------------------------------------------------------------------------------
Added more checks to TGA file format detection logic.


R2578 | 9db82d57 | MaxED | 30.08.2016, 11:00
--------------------------------------------------------------------------------
Fixed, updater: fixed "Unable to locate updater.ini" error when the editor was launched using "Open with..." shell command.


R2577 | 9e2e2221 | MaxED | 29.08.2016, 23:44
--------------------------------------------------------------------------------
Fixed, Randomize things mode: fixed a crash when trying to move things, which were initially outside of sector boundary when using Hexen or UDMF map format.


R2576 | fbca0922 | MaxED | 29.08.2016, 13:32
--------------------------------------------------------------------------------
Added, action argument inputs: added "&lt;" and "&gt;" prefixes. These decrement/increment given value by selected map element number.
Changed, action argument inputs: "+++" and "---" prefixes now do the same thing as they do in other numeric controls (e.g. add/subtract given value multiplied by selected map element number to/from initial value).
Changed, action argument inputs: changed value colors, added tooltips.


R2575 | ea57d45e | MaxED | 29.08.2016, 12:06
--------------------------------------------------------------------------------
Added: action argument inputs now support incremental increase/decrease prefixes (+++ and ---).
Probably fixed probable I/O race condition when loading images.
Fixed Visual mode stuttering due to floating point precision degradation when running the editor for several days without restarting (internal timer is now reset when saving the map or creating a new one).
Fixed, Nodes Viewer, cosmetic: Nodes Viewer window position was reset after pressing the "Rebuild Nodes" button.
Added Eternity Game configurations by printz.
Updated ZDoom_ACS.cfg (CheckClass).
Updated ZDoom ACC (CheckClass).


R2574 | fb97d6fb | MaxED | 23.08.2016, 10:07
--------------------------------------------------------------------------------
Added more sanity checks to GLDEFS light parsing logic.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom_ACS.cfg.
Updated ZDoom ACC.


R2573 | dbe05d59 | MaxED | 14.08.2016, 18:59
--------------------------------------------------------------------------------
Fixed: in some cases dragging lines shorter than 1 mu or vertices belonging to such lines resulted in an infinite loop.


R2572 | 7641b581 | MaxED | 05.08.2016, 16:30
--------------------------------------------------------------------------------
Fixed, map element dragging: in some cases sector properties copied from incorrect sectors were assigned to new sectors when using "Merge Dragged Geometry" mode.


R2571 | 158df426 | MaxED | 01.08.2016, 10:08
--------------------------------------------------------------------------------
Fixed, Visual mode: thing argument helper shapes were rendered at incorrect height.


R2570 | 2351922b | MaxED | 31.07.2016, 00:23
--------------------------------------------------------------------------------
Fixed: rearranging resources by dragging them in the Game Configurations window was not processed.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom_ACS.cfg.
Updated ZDoom ACC.


R2569 | 14fa9951 | MaxED | 20.07.2016, 23:04
--------------------------------------------------------------------------------
Fixed, MODELDEF parser: fixed a crash when model definition didn't contain the "Path" property.
Fixed, MODELDEF parser: forward slash in Model/Skin/SurfaceSkin paths wasn't supported.


R2568 | 2ea72437 | MaxED | 20.07.2016, 21:17
--------------------------------------------------------------------------------
Added, Visual mode: added support for "Change Floor Brightness to this Brightness" and "Change Ceiling Brightness to this Brightness" Boom actions.
Changed, Sectors mode: "Flip Linedefs" and "Align Linedefs" actions will no longer flip single-sided linedefs with only front side.
Fixed, Script Editor: fixed a crash when trying to update script navigator combo box when switching to a never saved ACS script.


R2567 | 3a77e6bc | MaxED | 19.07.2016, 21:47
--------------------------------------------------------------------------------
Fixed, Visual mode: "Transfer Floor/Ceiling Brightness" actions were resetting sector color on target surfaces.
Updated ZDoom_DECORATE.cfg.


R2566 | a8c23266 | MaxED | 19.07.2016, 01:41
--------------------------------------------------------------------------------
Changed: optimized generated voxel mesh size. Pro: they occupy ~50% less memory. Con: voxel loading takes ~30% more time.
Changed, Browse Textures window: several textures with the same name were displayed in "All" texture set when overriding WAD textures by Folder/PK3 textures.


R2565 | 3f93525e | MaxED | 18.07.2016, 14:05
--------------------------------------------------------------------------------
Added support for SurfaceSkin MODELDEF property.
Changed, Visual mode: increased maximum rendreable dynamic lights count to 64.


R2564 | 68c5ed17 | MaxED | 18.07.2016, 01:07
--------------------------------------------------------------------------------
Fixed a crash when trying to set pitch of a non-model thing (was introduced in R2678).


R2563 | 7772ebbb | MaxED | 17.07.2016, 23:38
--------------------------------------------------------------------------------
Fixed: voxels were incorrectly loaded from WADs.
Fixed, Draw Geometry modes: fixed a crash when moving the mouse cursor over a vertex while holding Alt-Shift keys when there were no new points drawn in current mode.


R2562 | 94dedf9a | MaxED | 17.07.2016, 02:00
--------------------------------------------------------------------------------
Added support for USEACTORPITCH and USEACTORROLL MODELDEF flags.
Changed: LOKCDEFS keys are now sorted alphabetically.
Fixed, MAPINFO parser: blocks inside map definition block were parsed incorrectly when using new MAPINFO format.
Fixed, rendering: custom MODELDEF scale was applied incorrectly when "Stretched view in visual modes" option was enabled.
Updated ZDoom_DECORATE.cfg.
Updated GZDoom_MODELDEF.cfg.


R2561 | 988ef7de | MaxED | 15.07.2016, 16:07
--------------------------------------------------------------------------------
Added "flagsrename" Game configurations property. It allows to override Thing flag names for specific things.
Added, Automap mode: added "Show locks" button (available in Hexen and UDMF map formats only).
Updated documentation.


R2560 | 09e1eef9 | MaxED | 15.07.2016, 01:39
--------------------------------------------------------------------------------
Added LOCKDEFS parser.
Changed, Game Configurations: changed "basegame" value type from int to string.
Updated documentation.


R2559 | baa30326 | MaxED | 14.07.2016, 16:28
--------------------------------------------------------------------------------
Fixed, DECORATE parser: the parser was unable to process several quoted strings not separated by at least one space/tab char.
Fixed: the editor was unable to find actor sprites defined in TEXTURES.


R2558 | 9a6d3ea8 | MaxED | 14.07.2016, 14:42
--------------------------------------------------------------------------------
Added, DECORATE: added "//$ArgNRenderStyle" special comment. It allows to specify a rendering shape to display the value of given argument. Supported values are "circle" and "rectangle".
Added, DECORATE: added "//$ArgNRenderColor" special comment. It allows to specify a color used by the rendering shape.
Updated documentation.


R2557 | 66272509 | MaxED | 14.07.2016, 01:28
--------------------------------------------------------------------------------
Fixed a crash when using "Open map in current WAD" action in Visual mode.


R2556 | 13068b11 | MaxED | 13.07.2016, 23:53
--------------------------------------------------------------------------------
Added, Visual mode: added support for ROLLCENTER sprite rendering flag, updated ROLLSPRITE implementation.
Fixed, DECORATE support: the editor was unable to determine actor sprite when the actor itself had no sprites defined and the actor it inherited from was only defined in the game configuration.
Fixed, Drag geometry modes: linedefs without both sides were removed after dragging them when "Replace with Dragged Geometry" mode was active.
Updated ZDoom_DECORATE.cfg.


R2555 | ec9c3a71 | MaxED | 12.07.2016, 00:13
--------------------------------------------------------------------------------
Added: preview sprites are now generated from voxels. Those are used as previews and when model rendering is disabled.
Fixed: voxel support logic was outdated, which in some cases resulted in voxels not being loaded and in some weird behaviour when trying to change pitch/roll of associated things.
Updated sprites lookup logic. Now it correctly handles sprites named like NNNNA0B0.
Fixed: in some cases DECORATE parser was unable to correctly detect sprite name & frame(s) block.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.


R2554 | 3677221e | MaxED | 07.07.2016, 13:20
--------------------------------------------------------------------------------
On second thought, previous fix should be applied more selectively.


R2553 | c0e6f14c | MaxED | 07.07.2016, 12:59
--------------------------------------------------------------------------------
Fixed, Edit Selection mode, DB2 bug: in some cases "Flip Selection Horizontally" / "Flip Selection Vertically" actions were incorrectly flipping linedefs, resulting in broken sector geometry.


R2552 | ba80c7d1 | MaxED | 06.07.2016, 02:15
--------------------------------------------------------------------------------
Fixed several cases when sector/linedef tag changes were incorrectly recorded by undo system.


R2551 | 02e5996b | MaxED | 04.07.2016, 23:13
--------------------------------------------------------------------------------
Visual mode: modified sidedef texture UV calculations to use integral linedef length to match (G)ZDoom way of rendering them.
Visual mode, UDMF: "Auto-align textures" actions now use integral linedef length when calculating texture offsets.


R2550 | 04de976a | MaxED | 04.07.2016, 20:25
--------------------------------------------------------------------------------
Added, Visual mode: added support for FLATSPRITE, ROLLSPRITE, WALLSPRITE and DONTFLIP sprite rendering flags. Removed the older GLOOME-specific implementation.
Changed, "Align Things to Nearest Linedef" action: the action can now also align things with FLATSPRITE and WALLSPRITE flags (previously only things with attached models were aligned).
Changed, "Align Things to Nearest Linedef" action: the action can now align things to the middle part of double-sided linedef, if it has a middle texture assigned.


R2549 | 7ab0a86a | MaxED | 03.07.2016, 00:27
--------------------------------------------------------------------------------
Added, Find & Replace mode, UDMF: added Linedef activation flags to the "Find Linedef flags" search mode flags list.
Changed, Sound Propagation mode: all sound zones are now shown when no sector is highlighted.
Changed, Sound Environments mode: the mode is now available only in UDMF map format.
Changed, Color Picker plugin: the plugin functionality is no longer available in Doom map format.
Restored the ability to create superimposed lines by dragging them with "Snap to Geometry" mode disabled.
Fixed, Sound Propagation mode: fixed a crash when a single-sided linedef had "Block Sound" flag.
Fixed, Find & Replace mode: in some cases "Find Sector/Sidedef/Linedef/Thing flags" search modes failed to find map elements with required flags.
Fixed, Edit Selection mode: in some cases incorrect geometry was created after applying multipart sector edit when "Replace with Dragged Geometry" mode was enabled.
Fixed a crash caused by eventual GDI font objects overflow.


R2548 | 4f764834 | MaxED | 30.06.2016, 19:57
--------------------------------------------------------------------------------
Fixed, DB2 bug: temporary map file was growing in size after every map save/test, which eventually resulted in integer overflow exception when the file size reached ~2Gb.
Fixed, Draw Geometry modes: fixed a crash when moving the mouse cursor over a linedef while holding Alt-Shift keys when there were no new points drawn in current mode.


R2547 | 7b54c014 | MaxED | 27.06.2016, 00:42
--------------------------------------------------------------------------------
Changed: single-sided linedefs with only back sidedef present are now automatically flipped when loading a map.
Changed, "Flip Linedefs" action: the action will no longer flip single-sided linedefs with only front side.
Fixed a crash when trying to determine sprite angles when images with non-sprite names, starting with expected characters, were present in the Sprites namespace.


R2546 | 7524cf67 | MaxED | 26.06.2016, 02:48
--------------------------------------------------------------------------------
Fixed: added some additional boilerplate to FileLockChecker.CheckFile.


R2545 | ea81ad80 | MaxED | 25.06.2016, 16:09
--------------------------------------------------------------------------------
Added, Search and Replace mode: "Find Sector Brightness" search mode now supports "&lt;=", "&lt;", "&gt;=" and "&gt;" prefixes.
Fixed, Sound Environment mode: fixed several cases when single-sided lines with only back side could cause either logic errors or crashes.
Fixed, Automap mode: fixed several cases when single-sided lines with only back side could cause logic errors.
Debug: added some debug code to WAD.Insert() to investigate the issue when lumpoffset could become negative.


R2544 | 3c62e89d | MaxED | 25.06.2016, 00:25
--------------------------------------------------------------------------------
Reverted some older changes to Linedef.Join(), which were made for older version of "enhanced" map element merging logic and in some cases were causing incorrect geometry to be created when using current merging logic.


R2543 | 9147c312 | MaxED | 22.06.2016, 16:27
--------------------------------------------------------------------------------
Fixed: in some cases incorrect Script Configuration was used to compile scripts when performing "Save Map" / "Test Map" actions.


R2542 | 6296ef86 | MaxED | 22.06.2016, 15:38
--------------------------------------------------------------------------------
Fixed, Find & Replace mode: fixed a bug when "Find Sector Effect" search mode returned all map sectors when the effect to find was not generalized.
Updated ZDoom_DECORATE.cfg.


R2541 | 364b3c11 | MaxED | 20.06.2016, 15:36
--------------------------------------------------------------------------------
Changed: "Selection Options" window is now resized automatically.
Fixed: parts of UniFileds.UniValuesMatch() logic were inverted. In some cases this resulted in incorrect behavior of "Select Similar" action in UDMF map format.
Fixed, UDMF: alpha should be ignored when applying sector fade/light color gradients.
Ported eevee's fix for incorrect sector geometry occasionally created after dragging map elements (more info: https://github.com/sirjuddington/SLADE/issues/542).


R2540 | 2627a5bb | MaxED | 19.06.2016, 23:17
--------------------------------------------------------------------------------
Added partial "LightMode" MAPINFO property support. Currently only "Standard" and "Doom" light modes are supported.
Updated Zandronum acc.
Updated Zandronum_ACS.cfg.


R2539 | cb1eb1de | MaxED | 19.06.2016, 02:09
--------------------------------------------------------------------------------
Changed, Visual mode: "Paste Selection" action (Ctrl-V) can now paste both copied textures and things, based on what was copied last.
Changed, Map Analysis mode: the view is now much more zoomed after clocking on a "Check very short linedefs" error check result.
Removed single testing engine launchable by the editor at once limitation (it worked properly only when using Test map actions anyway).
Fixed: re-did the fix for invalid geometry created when drawing very large grids from R2653, because it caused other issues.


R2538 | af4f4038 | MaxED | 18.06.2016, 02:10
--------------------------------------------------------------------------------
Added, Automap mode: added "Show hidden lines" top menu button.
Added, Automap mode: added "Show secrets" top menu button.
Added, Automap mode: added "Color preset" top menu drop-down.


R2537 | ac68ec0b | MaxED | 17.06.2016, 22:44
--------------------------------------------------------------------------------
Changed: "Unable to save the map: there are too many unique sidedefs!" error message now displays info about sidedefs counts before and after sidedef compression.
Fixed, Draw Grid mode: in some cases invalid geometry was created when drawing very large grids.
Fixed, Things mode, "Rotate Clockwise" action: fixed inability to change thing angle from 0 to 315 when "doomthingrotationangles" Game Configuration property was set to true.
Updated ZDoom_DECORATE.cfg.


R2536 | f7a1a64d | MaxED | 17.06.2016, 00:57
--------------------------------------------------------------------------------
Added, UDMF: Lock number is now displayed in Linedef info panel.
Fixed, Edit Linedefs / Edit Things windows: ACS script number/name was applied only when the form was accepted while displaying a tab with Action controls.


R2535 | 25947e59 | MaxED | 17.06.2016, 00:05
--------------------------------------------------------------------------------
Added "Automap Mode" plugin by Boris Iwansky.


R2534 | 8f446bbc | MaxED | 16.06.2016, 00:57
--------------------------------------------------------------------------------
Fixed, "Select Similar" action: in some cases map elements flags were incorrectly compared resulting in map elements not being selected when they should have been.


R2533 | 59c4a75b | MaxED | 16.06.2016, 00:02
--------------------------------------------------------------------------------
Added "Split Joined Sectors" Edit menu item and toolbar button. When enabled, joined sectors adjacent to drawn lines will be split.
Added "doomthingrotationangles" Game Configuration property. When enabled, editor actions related to changing thing angle will snap the resulting angle to 45 degree increments. This property is set to true for vanilla game configurations.
Fixed a crash when changing game configuration from one without Thing actions support to one with them while in Things mode.
Fixed, cosmetic, DB2 bug: current editing mode button was deselected after reloading resources.
Updated documentation ("Game Configuration - Basic Settings" page).


R2532 | 07c2b3a8 | MaxED | 15.06.2016, 16:48
--------------------------------------------------------------------------------
Added "WorldPanning" TEXTUREx flag support.


R2531 | 6ff0a322 | MaxED | 14.06.2016, 22:39
--------------------------------------------------------------------------------
Fixed, Thing/Linedef/Sector info panels: in some cases map element flags were cut off by the control border.


R2530 | a8527190 | MaxED | 14.06.2016, 01:37
--------------------------------------------------------------------------------
Added, Visual mode: added "Toggle Alpha-based Texture Highlighting" action. When enabled, 3d floor textures and middle textures on double-sided lines will be highlighted only when the crosshair points at a non-transparent pixel.
Changed: multi-part sectors are now better preserved after drawing new lines.
Changed, TEXTURES parser: patch loading errors are now ignored for textures with "NullTexture" option.
Changed, Game configurations: changed default door action arguments to better match vanilla ones.
Fixed, Actions: in some cases keyboard shortcuts involving Ctrl/Alt/Shift modifier keys were displayed incorrectly.
Fixed(?): probably fixed inability to save map wad in Slade 3.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom ACC.


R2529 | 14887bfb | MaxED | 08.06.2016, 02:06
--------------------------------------------------------------------------------
Added, Find and Replace mode: you can now search (and replace) unset sidedef/linedef/thing/sector flags.
Changed, TEXTURES parser: patch loading errors are now treated as warnings for optional textures.
Changed, TEXTURES parser: patch loading is now skipped for textures with "NullTexture" option.


R2528 | bb289132 | MaxED | 06.06.2016, 23:06
--------------------------------------------------------------------------------
Added Preferences -&gt; Editing -&gt; "Switch view modes when switching to the same Classic Mode" option (disabled by default). When enabled, view mode will be switched between "view floor textures" and "view ceiling textures" when activating the same 2D mode repeatedly.


R2527 | 5212079f | MaxED | 06.06.2016, 00:06
--------------------------------------------------------------------------------
Removed: activating the same 2D mode repeatedly no longer toggles View modes.
Added "Next View Mode" and "Previous View Mode" actions.
Removed "Replace unused textures" checkboxes from Edit Linedefs window.
Fixed, SNDINFO parser: commented $ambient sound definitions were treated as editor comments (and still processed).


R2526 | 3d2d9e21 | MaxED | 03.06.2016, 22:22
--------------------------------------------------------------------------------
Changed, Classic modes: displayed mouse map position coordinates are now snapped to current grid size.
Updated model pitch handling to match current GZDoom implementation.
Fixed imprecise vertex coordinates generated by Draw Ellipse mode.
Fixed a resource loading exception when opened map file wad was located in the root of a Directory resource.
Internal: changed output of all InterpolationTools methods from int to float.
Fixed, Internal: InterpolationTools.InterpolateColor() delta usage was inverted.


R2525 | 3bef7dbf | MaxED | 02.06.2016, 11:55
--------------------------------------------------------------------------------
Added 3 map geometry dragging modes (used when applying Drag Vertices/Linedefs/Sectors modes and Edit Selection mode):
- "Merge Dragged Vertices Only". Only vertex-line intersections will be processed (DB2 mode).
- "Merge Dragged Geometry". Geometry merging will be performed.
- "Replace with Dragged Geometry". Dragged geometry will replace underlaying geometry.
You can switch between these using 3 new actions, top toolbar buttons and Edit menu buttons.
Changed: activating the same 2D mode repeatedly now toggles View modes.
Renamed "Merge Geometry" action/menu item to "Snap to Geometry".
More fixes to vertex/linedef/sector dragging logic.
Updated ZDoom_DECORATE.cfg.


R2524 | 52871962 | MaxED | 01.06.2016, 01:57
--------------------------------------------------------------------------------
Fixed, ACC compiler: in some cases compilation errors contained map file path as error source instead of lump name when compiling SCRIPTS lump.
Fixed, ACC compiler: in some cases includes were processed incorrectly when compiling external acs files.


R2523 | bc4f65e4 | MaxED | 30.05.2016, 02:18
--------------------------------------------------------------------------------
Fixed, vertex/linedef/sector dragging: in some cases middle textures were removed from dragged double-sided lines.
Fixed, ACC compiler: fixed a crash when trying to compile SCRIPTS lump of a new map, which wasn't ever saved.


R2522 | 34703ce8 | MaxED | 29.05.2016, 02:38
--------------------------------------------------------------------------------
Rewritten vertex/linedef/sector dragging logic. Now it processes line-line intersections. And handles more corner cases. And has less bugs. Probably.
Fixed, Edit Selection mode: texture scale was flipped when "Floor/Ceiling Transform" -&gt; "Scale" was enabled.
Changed: a warning is no longer displayed when trying to compile an empty SCRIPTS lump.
Updated ZDoom_DECORATE.cfg.


R2521 | 578135ca | MaxED | 25.05.2016, 00:11
--------------------------------------------------------------------------------
Added SNDINFO parser. Currently only the "$ambient" command is parsed. The values are used to update the titles of "Ambient Sound NN" things and to populate "ambient_sounds" Game Configuration enum.
Fixed, DECORATE parser: actors, which used "replaces" keyword and didn't have DoomEdNum were ignored.
Updated documentation ("(G)ZDoom text lumps support" page).


R2520 | 082a718b | MaxED | 22.05.2016, 23:22
--------------------------------------------------------------------------------
Fixed, Script Editor: in some cases the editor was unable to restore saved script file settings.
Fixed, Drag Linedefs, Drag Vertices, Edit Selection modes: in some cases sidedefs were incorrectly removed when modifying a closed section of a multi-part sector.
Fixed, Drag Linedefs, Drag Vertices, Drag Sectors, Edit Selection modes: in some cases sidedef textures were not adjusted after applying the modes, leaving middle textures on double-sided lines.


R2519 | 8ff50ac1 | MaxED | 20.05.2016, 23:40
--------------------------------------------------------------------------------
Fixed, Edit Selection mode: "Adjust Height" drop-down was accidentally disabled in non-UDMF maps.


R2518 | 5e71585c | MaxED | 20.05.2016, 17:04
--------------------------------------------------------------------------------
Added, Edit Selection mode: Added "Adjust height" setting. It can be used to adjust floor/ceiling height of selected sectors based on the sector selection was in and the sector selection was moved into.
Removed "Adjust heights to match relatively with surrounding sector" option from Preferences -&gt; Pasting, because sector height adjustments are now handled by Edit Selection mode.
Fixed, Sector info panel: in some cases 0 deg. floor/ceiling texture rotation was triggering texture offset/scale/rotation UI parts to be shown.
Fixed even more cases when sidedefs belonging to linedefs, which were moved on top of existing linedefs, were incorrectly reassigned when applying Edit Selection and Drag Geometry modes.
Fixed, Bridge mode: in some cases calculated floor/ceiling heights were not applied to the sectors created by the mode.
Changed, internal: changed program's CurrentCulture to InvariantCulture.


R2517 | 2458ea3d | MaxED | 19.05.2016, 23:44
--------------------------------------------------------------------------------
Changed, internal, UDMF: local texture offsets and scale are now copied when merging sidedefs.
Changed, internal: made TextLabel and IRenderer2D public properties compatible with DB2 implementation.
Fixed some more cases when sidedefs belonging to linedefs, which were moved on top of existing linedefs, were incorrectly reassigned when applying Edit Selection and Drag Geometry modes.
Fixed, Map Analysis mode: error checks must be updated after switching map format.


R2516 | ecb65025 | MaxED | 19.05.2016, 01:31
--------------------------------------------------------------------------------
Added "safeboundary" game configuration property. The value determines the maximum map bounding box size considered to be safe by "Check map size" error check.
Changed, Map Analysis mode: some checks are now available only under certain conditions (for example, "Check polyobjects" is now available only when the map is in Hexen or UDMF map format).
Updated documentation ("Game Configuration - Basic Settings" page).


R2515 | 77611bd8 | MaxED | 18.05.2016, 22:31
--------------------------------------------------------------------------------
Added: sectors are now split into multiple sectors when their shape is divided into several closed shapes by drawing new geometry or dragging existing geometry using Edit Selection and Drag Geometry modes.
Fixed: in some cases sidedefs belonging to linedefs, which were moved on top of existing linedefs, were incorrectly reassigned when applying Edit Selection and Drag Geometry modes.
Fixed: Tag Explorer update fix from R2630 was accidentally placed in an UDMF-only if-block.
Updated ZDoom_DECORATE.cfg (A_WeaponOffset).
Updated documentation ("(G)ZDoom text lumps support" page).


R2514 | 8ee504f9 | MaxED | 16.05.2016, 16:04
--------------------------------------------------------------------------------
Fixed, Tag Explorer: in some cases (for example, when geometry was removed implicitly by dragging geometry) the list was not updated.
Fixed: in some cases generalized sector effect detection logic failed to detect a valid generalized effect.
Fixed, Action selector control: action label was not updated when changing action number from one generalized effect to another.


R2513 | 701468fc | MaxED | 16.05.2016, 15:04
--------------------------------------------------------------------------------
Added: angle selector button used in arguments custom fields controls now shows angle value.
Fixed a crash when trying to store a custom field with "Byte Angle" type.
Fixed: in some cases custom field types stored in the map's .dbs file were not applied when loading a map.


R2512 | 5f13fa1d | MaxED | 15.05.2016, 02:38
--------------------------------------------------------------------------------
Fixed, Visual mode: texture offsets were updated multiple times when moving texture offsets of several extrafloor sides linked to the same control sidedef.
Fixed, Visual mode: sidedef geometry of sectors affected by "Copy Slope" effect was not updated when the source slope was modified.


R2511 | b84e36b5 | MaxED | 14.05.2016, 03:26
--------------------------------------------------------------------------------
Fixed a crash when saving a map with changed, but not recompiled SCRIPTS lump.


R2510 | c06443c7 | MaxED | 14.05.2016, 01:01
--------------------------------------------------------------------------------
Fixed inability to load resources from the map wad when it had read-only flag set.


R2509 | 2499a215 | MaxED | 13.05.2016, 16:42
--------------------------------------------------------------------------------
Added, Map Analysis mode: added "Check unknown actions and effects" check.


R2508 | 74f749fd | MaxED | 13.05.2016, 15:41
--------------------------------------------------------------------------------
Added, DECORATE support: #region blocks are now used as thing categories ("//$Category" actor block definition overrides these). Additional category-wide special comments are now available (see documentation).
Updated documentation ("DECORATE keys" page).


R2507 | b1e5d8b5 | MaxED | 13.05.2016, 00:35
--------------------------------------------------------------------------------
Added, Sound Environments mode: sound environments of the same type are now colored using the same color.
Added, Sound Environments mode: current sound environment is now highlighted (can be toggled using "Toggle Highlight" action).
Added: Tag selectors now have up/down buttons.
Fixed, Sound Environments mode: sound environments were not updated after performing Undo/Redo actions.
Fixed, Sound Propagation mode: sound zones were not updated after performing Undo/Redo actions.
Internal: moved "Toggle Highlight" action to the core, also changed it's category to "View".
Internal: "Toggle Highlight" action state is now saved in the Program configuration.
Updated ZDoom_DECORATE.cfg (GetZAt).
Updated ZDoom_linedefs.cfg (Sector_SetPortal args).


R2506 | 65861d1e | MaxED | 12.05.2016, 15:56
--------------------------------------------------------------------------------
Internal: moved script compilation logic to appropriate DataReaders.


R2505 | b67ecc63 | MaxED | 12.05.2016, 13:32
--------------------------------------------------------------------------------
Changed, Visual mode: "Auto-align textures" and "Paste Textures Floodfill" actions now use visual mode geometry to determine whether a sidedef part should be processed. This fixes inability to apply said actions to sidedef parts only visible because of slopes.
Fixed, Visual mode: both "With same texture" and "With same height" Select modifiers are now checked when both of them are used at once (previously a sidedef part/floor/ceiling was selected when any of those matched).


R2504 | 5d5e8cec | MaxED | 12.05.2016, 01:26
--------------------------------------------------------------------------------
Fixed, all drawing modes: in some cases incorrect sector shape was constructed when updating sector shapes after drawing new lines, which resulted in nearby sectors being merged into sector(s) affected by linedefs drawing.


R2503 | 7059d26c | MaxED | 11.05.2016, 01:22
--------------------------------------------------------------------------------
Added: when "sidedefcompressionignoresaction" property is set to false, sidedefs, which belong to a line with a non-zero action or tag, will be skipped when compressing sidedefs.


R2502 | a87a7c68 | MaxED | 10.05.2016, 20:36
--------------------------------------------------------------------------------
Fixed, Find and Replace mode: fixed an exception when trying to assemble search result label for a named script without arguments.


R2501 | 56fec9eb | MaxED | 09.05.2016, 22:34
--------------------------------------------------------------------------------
Added, Find and Replace mode: action arguments are now displayed in "Linedef Action and Arguments" and "Thing Action and Arguments" search results.


R2500 | a61f02f7 | MaxED | 08.05.2016, 20:45
--------------------------------------------------------------------------------
Fixed, Linedefs mode: fixed inability to highlight linedefs when "Stitch geometry within" setting was set to 0.
Fixed, Visual mode: fixed a crash when performing "Auto-align textures" actions on selected sidedefs when there were also floors/ceilings selected.


R2499 | 95db4cc7 | MaxED | 07.05.2016, 22:21
--------------------------------------------------------------------------------
Game configurations: added "sidedefcompressionignoresaction" property. When set to true, sidedefs will be compressed regardless of linedef action (DB2 behaviour). When set to false, sidedefs, which belong to a line with an action, will be skipped when compressing sidedefs. Default value is false.


R2498 | 751e2dd3 | MaxED | 06.05.2016, 10:47
--------------------------------------------------------------------------------
Added some boilerplate to clipboard operations.


R2497 | 133c2fce | MaxED | 04.05.2016, 16:02
--------------------------------------------------------------------------------
Fixed a bunch of typos.


R2496 | 895a7bb7 | MaxED | 04.05.2016, 13:16
--------------------------------------------------------------------------------
Fixed, MODELDEF parser: negative frame number of FrameIndex definition should be treated as "skip model rendering". Also added some more corner case handling.
Fixed, Sound Environment mode: in some cases the view was not updated after updating sound environments.
Added, Sound Environment mode: Sound environment things of currently highlighted sound environment are now highlighted.


R2495 | 68db725c | MaxED | 03.05.2016, 15:51
--------------------------------------------------------------------------------
Fixed: in some cases sidedefs were incorrectly reassigned when applying Edit Selection and Drag Geometry modes.


R2494 | 7fef84fb | MaxED | 02.05.2016, 21:16
--------------------------------------------------------------------------------
Fixed, DECORATE parser: editor comments caused the parser to skip next actor definition when used in incorrect scope.


R2493 | a57dce9b | MaxED | 02.05.2016, 20:36
--------------------------------------------------------------------------------
Fixed, Visual mode: rendering effects of "Slope floor/ceiling to here" things (9500/9501) should not be applied when their arg0 is 0.


R2492 | f66521e7 | MaxED | 02.05.2016, 17:01
--------------------------------------------------------------------------------
Fixed, Visual mode: "Rotate CW"/"Rotate CCW" actions should update thing-based effects when used on Things.
Added/restored, Visual mode: restored "Move Texture Left/Right/Up/Down by 8" actions, added "Move Texture Left/Right/Up/Down by Grid Size" actions (default keys are Ctrl+arrow keys).
Fixed, Game configurations: Hexen's Bell actor was missing "hangs" flag.


R2491 | 7ab53d7e | MaxED | 01.05.2016, 00:46
--------------------------------------------------------------------------------
Fixed, Script Editor: rewritten keyboard shortcut handling logic. Now it's (hopefully) no longer possible to insert unrelated characters when using keyboard shortcuts. Also "Duplicate line" (Ctrl-D) command was disabled for no reason.


R2490 | 5a8c6342 | MaxED | 30.04.2016, 21:27
--------------------------------------------------------------------------------
Fixed, Script Editor: fixed a crash triggered by creating a new tab, then closing script editor.
Fixed, Sectors mode: tags and effect labels were displayed instead of selection number labels after disabling, then enabling selection numbers when there were sectors with tags or effects selected.


R2489 | 4b45b4fd | MaxED | 30.04.2016, 01:19
--------------------------------------------------------------------------------
Fixed, Things mode: fixed a crash when switching to Things mode when more than 256 things were selected.


R2488 | 977adb47 | MaxED | 29.04.2016, 23:38
--------------------------------------------------------------------------------
Added: holding Control key while switching to/from Visual mode will now temporarily disable position synchronization (works only when 'Synchronize camera position between 2D and 3D modes' Preferences option is enabled).
Fixed severe lock-up after finishing dragging many vertices/linedefs/sectors in Classic modes.
Updated documentation ("Synchronizing camera position").


R2487 | 6e4540b3 | MaxED | 29.04.2016, 15:42
--------------------------------------------------------------------------------
Internal: some DataReaders refactoring.
Updated ZDoom_DECORATE.cfg (ALLOWTHRUFLAGS flag).


R2486 | 70586e35 | MaxED | 28.04.2016, 22:41
--------------------------------------------------------------------------------
Fixed, Classic modes: fixed excessive redraws and text label / sector highlight flickering when using rectangular selection with modifier keys.


R2485 | 41136830 | MaxED | 28.04.2016, 16:02
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases translucency was ignored on inner top sides of translucent 3d floors.
Internal, Script Editor: moved some setup/auto-completion logic to separate classes.
Updated ZDoom_DECORATE.cfg (A_QuakeEx).


R2484 | 24439cd1 | MaxED | 27.04.2016, 12:10
--------------------------------------------------------------------------------
Fixed, Visual mode: 3d floor outer sides were not updated after toggling rendering effects off, then on.
Updated ZDoom_DECORATE.cfg (GetAngle function).


R2483 | 6b250867 | MaxED | 27.04.2016, 11:13
--------------------------------------------------------------------------------
Internal: did some refactoring.


R2482 | 7667f14c | MaxED | 27.04.2016, 00:28
--------------------------------------------------------------------------------
Fixed, Game configurations window: new test engine entry was still added when pressing "New Test Engine" button, then canceling the browse dialog.
Fixed, general interface: in some cases opening "Test Map" drop-down resulted in an exception when trying to access a disposed/non-existing test engine icon.


R2481 | 13aabd42 | MaxED | 25.04.2016, 16:48
--------------------------------------------------------------------------------
Added, Drag Vertices\Linedefs\Sectors\Edit Selection modes: sidedefs facing outside of current selection are now reattached/added/removed after moving the selection.
Currently this will work as intended only if the selection ends up either completely inside a single sector or completely outside of any sector. Also this logic won't be applied if the selection contains the lines with only start or end vertex selected.
Internal: some TextLabel refactoring.


R2480 | 5ab50fc9 | MaxED | 24.04.2016, 01:15
--------------------------------------------------------------------------------
Fixed: added a simple extension-based filtering to Folder/PK3/PK7 resources to prevent loading data from unrelated resources.
Fixed: there can be several entries of the most ZDoom text lumps in WADs. Previously only the first one was processed.
Internal: rewritten DirectoryFilesList to use one collection instead of two.


R2479 | b1ac7034 | MaxED | 22.04.2016, 22:17
--------------------------------------------------------------------------------
Added, Sectors, Linedefs, Things modes: map element selection order of rectangular selection is now direction-dependent.


R2478 | e03936a0 | MaxED | 22.04.2016, 15:28
--------------------------------------------------------------------------------
Fixed, Visual mode, UDMF: in some cases Fade color was not applied to floor and ceiling surfaces of 3d floors.
Fixed, Visual mode: in some cases not all sidedef geometry was updated when updating sectors with Plane Align (181) action. Also fixed some more unnecessary geometry updates.
Fixed, Linedefs mode, Things mode: in some cases deleting linedefs/things caused a crash when trying to update text labels.
Fixed, Draw Lines mode: in some cases the drawing was prematurely finished when "Auto-finish drawing" option was enabled.


R2477 | d888e57c | MaxED | 21.04.2016, 23:00
--------------------------------------------------------------------------------
Added, Draw Lines mode: additional guidelines and horizontal/vertical line lengths can now be displayed for currently drawn line using "Show guidelines" top menu button.
Changed, Draw Lines mode: line angles are now shown only when "Show guidelines" mode is enabled.
Fixed, Draw Lines mode: in some cases "Snap to cardinal directions" mode was snapping only to diagonals.
Fixed, Draw Lines mode: snap to geometry behaved incorrectly when "Snap to cardinal directions" mode was enabled.
Changed, Things mode: dynamic light shape is now drawn using highlight color when a dynamic light thing is highlighted.
Added more sanity checks to MODELDEFS parser.


R2476 | c2618179 | MaxED | 20.04.2016, 23:55
--------------------------------------------------------------------------------
Added support for "Light()" DECORATE state expression.


R2475 | a4885bf9 | MaxED | 20.04.2016, 22:06
--------------------------------------------------------------------------------
Added support for "Bright" DECORATE state keyword.


R2474 | 44496c32 | MaxED | 20.04.2016, 01:20
--------------------------------------------------------------------------------
Visual mode: fixed a crash when trying to render a thing after resetting D3D device.


R2473 | 3eb05509 | MaxED | 19.04.2016, 22:40
--------------------------------------------------------------------------------
Added, Visual mode: "Increase/Decrease Scale", "Reset Texture Offsets" and "Reset Local Texture Offsets" actions now work when used on 3d floor sides.
Fixed: CVARINFO parser was unable to parse negative int/float values.
Fixed: in some cases TextLabel text size was checked before it was calculated. 
Internal, Visual mode: reduced the number of unnecessary geometry updates when changing map geometry.
Updated ZDoom_DECORATE.cfg (atan2 and VectorAngle).


R2472 | 38105c4b | MaxED | 18.04.2016, 15:58
--------------------------------------------------------------------------------
Added, Find and Replace mode: added usage hints to some search modes.


R2471 | 5121619d | MaxED | 18.04.2016, 10:10
--------------------------------------------------------------------------------
Fixed, Linedefs mode: fixed a crash on undoing linedef draw when trying to update a text label for disposed linedef.


R2470 | da3fde9a | MaxED | 18.04.2016, 00:52
--------------------------------------------------------------------------------
Fixed, Tag Statistics window: fixed a crash when applying changes after deleting a tag label.
Fixed, Script Editor: fixed infinite loop when trying to search for empty string.
Changed, Linedefs mode: selection labels are now positioned in a less line angle obscuring way.
Changed, Draw Lines mode: text label background alpha didn't match the alpha of the labels used in other classic modes.
Updated ZDoom_ACS.cfg (SetMusicVolume).
Updated ZDoom ACC (SetMusicVolume).


R2469 | 806e60bb | MaxED | 15.04.2016, 16:24
--------------------------------------------------------------------------------
Added: dynamically added side panel tabs now play notify animation when the side panel is collapsed.
Added, Game configurations, ZDoom: added Sector effect 90 (Skybox sector).


R2468 | 952e895a | MaxED | 13.04.2016, 16:11
--------------------------------------------------------------------------------
Fixed, DECORATE support: "DistanceCheck" value is a CVAR name, not an actual value.
Internal: added CVARINFO parser.


R2467 | fd0e1c75 | MaxED | 13.04.2016, 12:07
--------------------------------------------------------------------------------
Visual mode: added support for DistanceCheck DECORATE property.
Updated ZDoom_DECORATE.cfg.


R2466 | c3392f83 | MaxED | 12.04.2016, 01:05
--------------------------------------------------------------------------------
Added, Visual mode: thing sprites are now angle-dependent.


R2465 | c861f8ec | MaxED | 11.04.2016, 14:05
--------------------------------------------------------------------------------
Added, Game configurations: added "Enum option + enum bits":26 action argument type. It can be used when an argument combines both exclusive and bit flag values.
Updated, Game configurations: some linedef action arguments now use type 26.
Updated documentation ("Game Configuration - Action Argument Settings").
Updated ZDoom ACC (APROP_MaxStepHeight and APROP_MaxDropOffHeight).


R2464 | fd2aae74 | MaxED | 10.04.2016, 23:16
--------------------------------------------------------------------------------
Re-fixed: fixed a crash when determining sprite angles when there was more than one sprite for the same frame and angle.


R2463 | 8bac02ed | MaxED | 10.04.2016, 23:04
--------------------------------------------------------------------------------
Fixed: fixed a crash when determining sprite angles when there was more than one sprite for the same frame and angle.


R2462 | 06d72098 | MaxED | 10.04.2016, 01:18
--------------------------------------------------------------------------------
Fixed: fixed a crash when determining sprite angles when there were sprites for both rotated (like TESTA2A8) and non-rotated (like TESTA0) versions of the same frame.
Fixed, Tags Selector control, UDMF: in some cases tags adding/removing worked unreliably when mixed tag values were used.
Fixed, Arguments control: in some cases ending colon was not appended to argument names.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.


R2461 | 42607f70 | MaxED | 08.04.2016, 16:02
--------------------------------------------------------------------------------
Added, Classic modes: thing sprites are now angle-dependent.


R2460 | a06f44ce | MaxED | 07.04.2016, 22:01
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases "Flood-fill textures" actions were not working when "use long texture names" Map Options setting was enabled.


R2459 | 1636be7b | MaxED | 07.04.2016, 10:40
--------------------------------------------------------------------------------
Added, Game configurations: added "Polyobject number":25 argument type. When set, used polyobject numbers will be displayed in the action argument dropdown.
Added, Map Analysis mode: Polyobj_ExplicitLine action was not checked by "Check polyobjects" check. 
Updated ZDoom_linedefs.cfg and Hexen_linedefs.cfg (polyobject number linedef args now have type 25).
Updated documentation ("Game Configuration - Action Argument Settings").


R2458 | 23e4a86a | MaxED | 07.04.2016, 00:54
--------------------------------------------------------------------------------
Re-added, MODELDEF parser: actor classname can have spaces, so it can be quoted...
Added, GLDEFS parser: light name can have spaces too, so it also can be quoted...
Removed some excessive quote stripping from most of the ZDoom-related text parsers.
Some parsing error reporting improvements in MODELDEF and GLDEFS parsers.
Added a special warning when a texture/flat is overridden by a cameratexture.


R2457 | 580f7d44 | MaxED | 06.04.2016, 13:44
--------------------------------------------------------------------------------
Classic modes: further text label rendering optimization.
MODELDEF parser: rewrote most of the parser logic. Now it picks actor model(s) based on Frame / FrameName properties.


R2456 | ee12da96 | MaxED | 06.04.2016, 00:24
--------------------------------------------------------------------------------
Sectors, Linedefs, Things modes: optimized text label rendering.
Fixed, Things mode: in some cases selection labels were not updated after editing a thing.
Fixed, Things mode: selection labels were positioned incorrectly on things with FixedSize setting.
Fixed, Sectors mode: fixed a crash when selecting self-referencing sector when selection labels were enabled.
Fixed, Visual mode: in some cases Auto-align texture actions were not working when "use long texture names" Map Options setting was enabled.
Fixed, MD2/MD3 loader: available animation frames upper bound check was performed incorrectly, which would cause a crash in some very special cases.
Fixed, Game configurations: most Hexen/ZDoom teleport actions use TeleportDests as teleport targets, not MapSpots.


R2455 | a4428cf2 | MaxED | 05.04.2016, 00:20
--------------------------------------------------------------------------------
Added, Linedefs mode, Things mode: selection numbers can now be displayed and can be toggled using the "View Selection Numbering" mode toolbar button.
Added, Linedefs mode, Things mode: sector tags can now be displayed and can be toggled using the "View Sector Tags" mode toolbar button.
Fixed, Classic modes, DB2 bug: in some cases text label size was queried before it was calculated, resulting in text labels being rendered when they shouldn't.
Updated ZDoom_DECORATE.cfg (A_LogFloat).


R2454 | dddb1bbf | MaxED | 04.04.2016, 14:09
--------------------------------------------------------------------------------
Added, Game configurations: added "targetclasses" argument property. Can be used with argument type 14 (Thing Tag). When set, only things of given classes will be shown in the argument dropdown list in Edit Things window.
Changed, Classic modes: when "Fixed Things Scale" option is enabled, things will now switch to fixed size rendering mode when their visible size is less than 48 pixels.
Changed, Classic modes: changed the fixed size of things with FixedSize setting to 28 pixels.
Updated documentation ("targetclasses" argument property).


R2453 | 6cb9f96a | MaxED | 02.04.2016, 00:23
--------------------------------------------------------------------------------
Fixed, Classic modes: thing sprite should always be rendered when it's size is affected by "Fixed Things Scale" option or FixedSize setting.
MAPINFO parser: removed a misleading warning.


R2452 | f6b444a4 | MaxED | 01.04.2016, 16:32
--------------------------------------------------------------------------------
Added text label font settings (Preferences -&gt; Interface tab).
Rearranged some settings in the Preferences window.


R2451 | 94732775 | MaxED | 01.04.2016, 15:00
--------------------------------------------------------------------------------
Cosmetic: updated ColorControl appearance.


R2450 | a9c64fe5 | MaxED | 01.04.2016, 12:49
--------------------------------------------------------------------------------
Changed, Texture Browser window: "All" textures group is now saved/reselected like the rest of the texture groups when closing/opening the window.
Changed, Classic modes: bigger Thing arrows are now rendered when thing sprite rendering is skipped.
Changed, Classic modes: when "Fixed Things Scale" option is enabled, thing size stays at 2x scale instead of 1x when extra bounding box is rendered.
Added Preferences -&gt; Appearance -&gt; "Things transparency (Things mode)" slider.
Renamed Preferences -&gt; Appearance -&gt; "Things transparency" to "Things transparency (other modes)".
Externalized thing bounding box and arrow texture, used to render things in Classic modes (Textures/ThingTexture2D.png).
Updated ZDoom_DECORATE.cfg (A_SetUserVarFloat, A_SetUserArrayFloat).


R2449 | f646dd7a | MaxED | 31.03.2016, 01:25
--------------------------------------------------------------------------------
Classic modes: rewritten and optimized some parts of text label rendering logic.
Internal, API: TextLabels can now display multi-line text, their font can be changed, they can have a background.


R2448 | a5fffa9c | MaxED | 30.03.2016, 13:29
--------------------------------------------------------------------------------
Added Preferences -&gt; Appearance -&gt; "Things transparency" slider. It controls Things transparency in all classic modes except Things mode.
Added Preferences -&gt; Appearance -&gt; "Hidden Things transparency" slider. It controls transparency of Things hidden by Things filter in Things mode, of all things :)


R2447 | 2b570752 | MaxED | 29.03.2016, 17:07
--------------------------------------------------------------------------------
Fixed, Script Editor: in some cases unwanted characters were inserted when using keyboard shortcuts.
Fixed, Script Editor: auto-completion was not invokable when typing ACS directives.


R2446 | 002d6e9c | MaxED | 29.03.2016, 16:38
--------------------------------------------------------------------------------
Fixed inability to disable bilinear filtering in Visual mode some users experienced.
Fixed occasional TreeView flickering in Edit Things window, Browse Action window and Tag Explorer panel.
Updated Thing category icons in the Edit Things window. They now have "opened" and "closed" states.
Internal: added BufferedTreeView to the core controls.
Updated ZDoom game configurations (sector crush mode).
Updated ZDoom ACC.


R2445 | abfcd8e5 | MaxED | 25.03.2016, 15:06
--------------------------------------------------------------------------------
Added, Preferences -&gt; Appearance: added "Anisotropic filtering" and "Edge Antialiasing" settings. Also regrouped some settings.
Added, "Check polyobjects" error check: added a check for matching Polyobject and Mirror Polyobject numbers of Polyobj_StartLine action.
Changed, Visual mode: anisotropic filtering is now always applied (previously it was applied only when bilinear filtering was enabled).
Fixed, Visual mode: in some cases light values were incorrectly transferred between 3d floors and regular floors/ceilings.
Fixed, ACS parser: includes for each library must be stored separately (fixes inability to compile a script with an included library, which in turn includes files already included by the script).


R2444 | 0ed9c06f | MaxED | 25.03.2016, 00:09
--------------------------------------------------------------------------------
Fixed, Map Analysis mode, DB2 bug: "Flip Linedef" fix for "Check line references" check was applied incorrectly.


R2443 | 5fd79cd7 | MaxED | 24.03.2016, 10:25
--------------------------------------------------------------------------------
Fixed, "Check Polyobjects" error check: an error is no longer added when "Mirror Polyobject Number" of "Polyobj_Startline" is 0.
Fixed, "Find and Replace" mode: "Find and Replace" window no longer closes when no results are found and Replace mode is enabled.
Changed, "Find and Replace" mode: renamed some search modes for better grouping.


R2442 | cc9d118f | MaxED | 23.03.2016, 22:26
--------------------------------------------------------------------------------
Changed, Visual mode: adjusted fog density calculation to better match with GZDoom.
Fixed, Visual mode: alpha-based texture picking didn't work correctly on HiRes images.
Fixed, Visual mode: fog density was calculated incorrectly for things lit by dynamic lights.
Fixed, Edit Sector window, UDMF: "Fade" and "Light" color pickers initial values were incorrect when displaying mixed values.
Fixed, Edit Thing window, UDMF: "Color" color picker initial value was incorrect when displaying mixed values.


R2441 | db9de0d3 | MaxED | 23.03.2016, 15:52
--------------------------------------------------------------------------------
Fixed: HiRes images should not be used on surfaces with long texture names.
Changed, Draw Lines and Draw Curve modes: "Auto-finish drawing" option now works regardless of "Continuous drawing" option (previously it worked only when the latter was enabled). 
Changed: position and size of the "Errors and Warnings" window is now stored while the editor is running.
Internal: rewritten parts of long texture names support code. It now involves much less special handling.
Updated ZDoom_DECORATE.cfg (A_QuakeEx, A_CheckBlock).
Updated ZDoom_ACS.cfg (QuakeEx).
Updated ZDoom ACC (QuakeEx).


R2440 | 6b4dc3a2 | MaxED | 22.03.2016, 23:24
--------------------------------------------------------------------------------
Added: HiRes images are now also applied to sprites.
Fixed: HiRes images should be loaded from subdirectories too.
Fixed: in some cases the editor was unable to locate existing "LoRes" images when loading HiRes images.
Disabled some HiRes-related warnings, because the editor doesn't track all sprites or graphics.


R2439 | 07a4c5c5 | MaxED | 21.03.2016, 19:25
--------------------------------------------------------------------------------
Added "Sidedef Lower Texture", "Sidedef Middle Texture" and "Sidedef Upper Texture" Find and Replace modes.


R2438 | a75555dd | MaxED | 21.03.2016, 18:48
--------------------------------------------------------------------------------
Fixed, Game configurations: some Generic_Floor:200 and Generic_Ceiling:201 parameters were named incorrectly.


R2437 | 0e78e6d3 | MaxED | 21.03.2016, 16:19
--------------------------------------------------------------------------------
Changed, Select Similar Sectors action: when "Effect" option is enabled, all sectors with at least one matching generalized/predefined effect will be selected.
Added, Tag Explorer plugin: a separate category for each generalized/predefined effect is now created when "Sort by action special" sort mode is used.
Added, Edit Effect window: normal and generalized effects can now be set at the same time.
Fixed, Edit Action window: in some cases Generalized actions were incorrectly processed.
Fixed, Edit Effect window: in some cases Generalized effects were incorrectly processed.
Fixed, Select Similar window: Tab control was incorrectly anchored.
Fixed, Nodes Viewer mode, cosmetic: segs angles were calculated incorrectly when showing nodes in classic format.
Fixed: HiRes textures, which didn't override any texture or flat were not loaded. 
Fixed, Tag Explorer plugin: linedef action categories were missing title when "Sort by action special" sort mode was used.
Cosmetic: renamed "Grid Setup" action to "Grid and Backdrop Setup".


R2436 | dd26c3de | MaxED | 18.03.2016, 13:52
--------------------------------------------------------------------------------
Internal: removed some duplicate casts, marked some classes is IDisposable, some streams were disposed more than once.


R2435 | 0cc1cc60 | MaxED | 18.03.2016, 12:28
--------------------------------------------------------------------------------
Added duplicates check to the map resources list.
A warning is now displayed when map uses more than one official IWAD as a resource.


R2434 | 476ccb55 | MaxED | 18.03.2016, 00:58
--------------------------------------------------------------------------------
Map saving: map lumps position in the wad is now kept persistent when saving it (previously / in DB2 map lumps were always pushed to the end of the wad when saving it). 
Internal: added NeutralResourcesLanguageAttribute to all assemblies. Theoretically this should result in a bit better performance when accessing embedded resources.
Updated ZDoom_DECORATE.cfg (A_Chase flags).


R2433 | adadca9d | MaxED | 17.03.2016, 00:26
--------------------------------------------------------------------------------
TEXTURES support: both patch Blend syntaxes are now supported (previously only "Blend &lt;string color&gt;[,&lt;float alpha&gt;]" was supported).
Added X11R6RGB parser.
Rewritten parts of unhandled exceptions handling to reduce the chance of additional exceptions happening after the first one.


R2432 | 1703af1c | MaxED | 15.03.2016, 23:01
--------------------------------------------------------------------------------
Fixed: alpha-based texture picking wasn't implemented for 3d floor inner sides.
Game configurations: added 2 secret Sector_Set3dFloor flags. Shhh! Don't tell anybody!


R2431 | 4aefe789 | MaxED | 14.03.2016, 22:53
--------------------------------------------------------------------------------
Fixed source window freezing while Open Map window was open when opening a wad by dragging & dropping it on the editor's main window.
Image loading-related warnings and errors now display more information about the image resource.


R2430 | 8924f62d | MaxED | 14.03.2016, 14:41
--------------------------------------------------------------------------------
Fixed, Script Editor: in some cases "[EP]" (Entry Position) markers were processed incorrectly when inserting a snippet.
Updated SharpCompress library to 0.11.5.
Updated ScintillaNET library to 3.6.3.


R2429 | 23d2a27d | MaxED | 14.03.2016, 11:25
--------------------------------------------------------------------------------
Added, Draw Ellipse mode: angle setting can now be changed using "Rotate Clockwise" and "Rotate Counterclockwise" actions.
Added, Draw Line and Draw Curve modes: added "Auto-finish drawing" setting. When enabled, the modes will automatically finish drawing when currently drawn lines and already existing level geometry form a closed shape.
Changed: sector-wise linedef flipping is now done using the new "Align Linedefs" action. "Flip Linedefs" action works the same as in DB2 again.
Changed: when a map was already loaded, using "Open Map" action will use that map's directory as the starting directory.
Changed: official IWADs can no longer be saved.
Changed: disabled lump ranges/duplicate entries checks for official IWADs.
Changed: wad type is now preserved when saving a map (previously all wads were saved as PWADs).
Changed: moved Updater.exe launch much closer to the editor termination point to avoid any chance of it closing the editor before it properly closes itself.
Updated ZDoom_DECORATE.cfg (A_Blast).
Updated documentation.


R2428 | 5fde78a2 | MaxED | 14.03.2016, 01:01
--------------------------------------------------------------------------------
Added, Tag Explorer plugin, UDMF: added multiple tags support.
Changed, cosmetic: elapsed time is now displayed after resources loading finishes.
Changed, internal: changed Clock.CurrentTime type to long.
Fixed, Tag Statistics window: in some cases the map view was not updated after selecting items in Sectors/Linedefs/Things columns. 
Fixed, cosmetic: Draw Curve mode icon was missing a shadow.


R2427 | 96fa507e | MaxED | 09.03.2016, 20:36
--------------------------------------------------------------------------------
Fixed, Map Analysis mode: fixed a crash when running "Check Polyobjects" check on a map without lines using "Polyobj_StartLine" action.
Updated ZDoom_linedefs.cfg (Line_SetPortalTarget).
Updated ZDoom_ACS.cfg (Line_SetPortalTarget).


R2426 | 7446c576 | MaxED | 09.03.2016, 15:52
--------------------------------------------------------------------------------
Added, Map Analysis mode: added "Check Polyobjects" checker.
Changed, Game configurations: "Polyobject Anchor" things should not trigger "Thing outside the map geometry" error in the Map Analysis mode.
Updated ZDoom_DECORATE.cfg (A_SetScale).


R2425 | 53a23448 | MaxED | 09.03.2016, 00:31
--------------------------------------------------------------------------------
Added, Visual mode: both Sky1 and Sky2 MAPINFO properties are now used when creating classic skybox texture.


R2424 | e561d130 | MaxED | 08.03.2016, 22:14
--------------------------------------------------------------------------------
Fixed, ACS parser: the names of include files bundled with acc compiler should be also checked for duplicate includes from user scripts, unless those user scripts are libraries.


R2423 | 49525177 | MaxED | 08.03.2016, 21:41
--------------------------------------------------------------------------------
Cosmetic: changed ' to " in some more Error and Warning messages.


R2422 | 09b32eba | MaxED | 08.03.2016, 21:37
--------------------------------------------------------------------------------
Fixed, Visual mode: GLDEFS glow color was incorrectly interpolated on sidedefs.
Fixed, Visual mode: in some cases GLDEFS glow effect was not updated after changing floor/ceiling texture.
Fixed, Draw Rectangle and Draw Ellipse modes: in some cases pressing "Reset" button did not update the shape preview.
Fixed, DB2 bug: sector geometry was not updated after undoing "Flip Sidedefs" action.


R2421 | 68182de3 | MaxED | 07.03.2016, 22:18
--------------------------------------------------------------------------------
Fixed, Game configurations: Point Pusher (5001) and Point Puller (5002) things were missing from Boom configs.


R2420 | d44fccfe | MaxED | 07.03.2016, 21:01
--------------------------------------------------------------------------------
Fixed, ACS parser: the names of include files bundled with acc compiler should be also checked for duplicate includes from user scripts.
Fixed, Script Editor: fixed another case when clicking a script error item didn't open/switch to the error source file.
Fixed, Update checker: fixed a crash when trying to check for update without active Internet connection.


R2419 | b7b00413 | MaxED | 06.03.2016, 21:52
--------------------------------------------------------------------------------
Added, Draw Ellipse mode: added "Angle" parameter. Can be used to rotate the shape.
Changed, Draw Ellipse mode: lowered minimum subdivisions to 3.
Fixed, Browse Action and Browse Effect windows: first option was always selected for any generalized action/effect parameter during generalized action/effect setup.


R2418 | 831cff45 | MaxED | 04.03.2016, 22:21
--------------------------------------------------------------------------------
Changed, Draw Ellipse mode: lowered minimum subdivisions to 4.
Changed, Draw Ellipse mode: Increase/Decrease bevel actions now always increase (and decrease) to the next even number.
Changed, Test Map drop-down: warning icon is now displayed when associated test engine executable can not be located, question icon is now displayed when the editor is unable to get the icon from the associated test engine executable.


R2417 | b44023ab | MaxED | 04.03.2016, 14:41
--------------------------------------------------------------------------------
Added, Draw Grid mode: "Lock slices to grid" now operates in 4 modes: "None", "Horizontal", "Vertical" and "Both". Can be helpful when drawing ladders and such.
Changed, all drawing modes: changeable drawing mode settings are now persistent.
Changed: "Dynamic grid size" mode is now disabled when changing grid size manually.
Documentation: "Command Line Parameters" topic contained a lot of incorrect information...
Updated ZDoom_DECORATE.cfg.


R2416 | 87a54b1e | MaxED | 04.03.2016, 09:10
--------------------------------------------------------------------------------
Added HiRes textures support.
Fixed, Script Editor: fixed a crash when trying to open Script Editor in a Doom map format map.


R2415 | 9a10ef9b | MaxED | 02.03.2016, 22:55
--------------------------------------------------------------------------------
Added float user var support (DECORATE parser and Custom Fields UI).
Fixed, Custom Fields UI: in some cases mixed user var values were displayed incorrectly.


R2414 | 3c72392f | MaxED | 02.03.2016, 00:24
--------------------------------------------------------------------------------
Fixed, Edit Linedefs window: textures on selected sidedefs must be updated when toggling "Replace unused textures" setting.
Fixed, Texture Selector control: in some cases actual textures were never loaded/displayed when "Replace unused textures" setting was disabled.
Fixed, Script Editor: auto-completion list is no longed displayed when editing comments, includes or strings.


R2413 | 2b5397f6 | MaxED | 29.02.2016, 09:10
--------------------------------------------------------------------------------
Fixed, Edit Things window: thing type validation when editing multiple thing types was broken in r2527.


R2412 | 4586c209 | MaxED | 28.02.2016, 23:15
--------------------------------------------------------------------------------
ACC support: fixed a crash when trying to load non-existent include file.


R2411 | 95e28518 | MaxED | 28.02.2016, 22:21
--------------------------------------------------------------------------------
DECORATE and MAPINFO parsers: added editor number range check.


R2410 | e70c4368 | MaxED | 27.02.2016, 00:35
--------------------------------------------------------------------------------
Fixed: DECORATE includes were incorrectly loaded from WADs.


R2409 | 80fc47f2 | MaxED | 26.02.2016, 23:06
--------------------------------------------------------------------------------
Fixed, DECORATE parser: quoted actor string properties (like RenderStyle) were processed incorrectly.
Fixed(?), Update checker: in some cases incorrect update check result was displayed.


R2408 | e0208a38 | MaxED | 26.02.2016, 13:46
--------------------------------------------------------------------------------
Added, Linedef Edit window: added "Replace unused textures" checkbox. When disabled, textures on unused sidedef parts won't be replaced when changing textures. For example, you can now replace sidedef textures of the whole map at once without assigning middle textures to all double-sided sidedefs.
Updated documentation ("Compiling GZDoom Builder" - added "Quick start guide" section).
Updated ZDoom_DECORATE.cfg.


R2407 | 85a817f6 | MaxED | 25.02.2016, 20:24
--------------------------------------------------------------------------------
Fixed, Sector Edit and Linedef Edit windows: "Clear" button behavior was broken in r2515.
+A couple of cosmetic tweaks and fixes.
Updated ZDoom_DECORATE.cfg.


R2406 | bef6165e | MaxED | 24.02.2016, 15:36
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed a crash, which happened after these steps: delete things in Classic mode -&gt; undo things deletion in Visual mode -&gt; redo things deletion in Visual mode.


R2405 | b193fa9e | MaxED | 24.02.2016, 13:25
--------------------------------------------------------------------------------
Fixed: checking read-only flag of non-existing files is not a good idea... (fixes a bug introduced in r2520).
Updated ZDoom_DECORATE.cfg (min/max).
Documentation: fixed cosmetic formatting issues in "DECORATE keys" page.


R2404 | 8ad4290b | MaxED | 24.02.2016, 12:34
--------------------------------------------------------------------------------
Fixed a crash when trying to save the map when the target wad file was read-only.


R2403 | 468e895e | MaxED | 23.02.2016, 20:22
--------------------------------------------------------------------------------
Changed, Action arguments control: arguments are no longer reset to default values when changing action/thing type when old and new argument types and names are the same.


R2402 | 2064b425 | MaxED | 23.02.2016, 19:28
--------------------------------------------------------------------------------
DECORATE: added "//$IgnoreRenderstyle" special comment.
Updated ZDoom_DECORATE.cfg.
Updated documentation ("DECORATE keys" page).


R2401 | b5577ed4 | MaxED | 23.02.2016, 14:55
--------------------------------------------------------------------------------
Changed the way filtering in the Edit Things, Browse Action and Browse Effect windows work: items, which names start with filter text are now displayed first.
Cosmetic tweaks to the way thing bounding boxes are rendered in Things mode when "Fixed Things Scale" option is enabled (bounding boxes of highlighted/selected things are now more opaque than the ones of unselected things).
Changed, Preferences form: action selected in the actions list is now stays selected when applying the filtering (unless it's no longer valid).


R2400 | b2900488 | MaxED | 23.02.2016, 08:39
--------------------------------------------------------------------------------
Fixed, DB2 bug, Visual mode: in some cases (sidedef's sector ceiling lower than other side's sector floor) higher/lower sidedef picking was behaving incorrectly.


R2399 | 80861be6 | MaxED | 22.02.2016, 16:20
--------------------------------------------------------------------------------
Added "Fixed Things Scale" setting (available in the View menu, as a button on the View toolbar and as the "Toggle Fixed Things Scale" action). When enabled, Things will no longer be scaled based on current zoom level in Classic modes, instead, thing bounding box will be drawn when appropriate (this option mimics DB1 things rendering style).
Internal: removed some remnants of fixed rendering pipeline from Renderer2D and Renderer3D.


R2398 | f228648b | MaxED | 22.02.2016, 14:04
--------------------------------------------------------------------------------
Fixed, Visual mode: sector geometry was not updated after changing sector brightness under a 3D floor.


R2397 | 0f7aa9f8 | MaxED | 22.02.2016, 13:33
--------------------------------------------------------------------------------
Added, Sector Edit window, UDMF: added UI for sector damage-realted properties.
Added, DECORATE parser: damage types are now parsed.
Added: the editor now reports duplicate textures/flats/patches/sprites/colormaps/voxels in the loaded wads.
Added, all text parsers: added #region/#endregion support.
Added TERRAIN parser.
Added, Script Editor: added special handling for DECORATE special comments.
Added, Sector Edit window, UDMF: Soundsequence value was setup incorrectly when showing the window for multiple sectors with mixed Soundsequence value. 
Fixed, Map Options window: "Strictly load patches between P_START and P_END" was not applied when applying the changes.
Fixed, MAPINFO parser: MapInfo should be treated as defined when a map MAPINFO block corresponding to current map is encountered even if it doesn't define any properties recognized by the editor.
Fixed, all text parsers: in some cases error line was calculated incorrectly when reporting an error detected by a text parser.
Cosmetic: changed ' to " in the rest of Error and Warning messages.
Internal: added text resource tracking.
Updated ZDoom_DECORATE.cfg.
Updated documentation ("Game Configuration - Basic Settings" page).


R2396 | 324a7461 | MaxED | 22.02.2016, 09:20
--------------------------------------------------------------------------------
Changed, Copy/Paste: the whole pasting operation is now aborted if the resulting number of sectors, linedefs, vertices or things exceeds map format's maximum.


R2395 | ce7d9d84 | MaxED | 22.02.2016, 09:09
--------------------------------------------------------------------------------
Fixed, Map Options window: game configurations were checked in incorrect order when opening a map without a .dbs file.


R2394 | 74015b1b | MaxED | 22.02.2016, 09:04
--------------------------------------------------------------------------------
Cosmetic: changed ' to " in the most of Error and Warning messages.


R2393 | a006a3cb | MaxED | 22.02.2016, 00:07
--------------------------------------------------------------------------------
Added, "Find Thing Action and Arguments" search mode: "Any action" (-1) can now be used as a search input.
Fixed, "Find Linedef Action and Arguments" and "Find Sector Effect" search modes: in some cases action/effect was checked incorrectly when performing a search.


R2392 | 27f497bf | MaxED | 21.02.2016, 01:11
--------------------------------------------------------------------------------
Added, "Find Linedef Action and Arguments" search mode: "Any action" (-1) can now be used as a search input.
Added, "Find Sector Effect" search mode: "Any effect" (-1) can now be used as a search input.
Fixed, "Find Linedef Action and Arguments" search mode: generalized actions search was broken.
Fixed, General interface: in some cases the placeholder test engine was displayed in the "Test Map" drop-down.


R2391 | 9632ecd0 | MaxED | 17.02.2016, 23:23
--------------------------------------------------------------------------------
Added, all drawing modes: added "Continuous drawing" option (available in the top mode menu / Draw Grid panel for the Draw Grid mode). When enabled, drawing mode will not be switched to previously active mode after finishing drawing a shape.
Fixed, general interlace: in some cases "Show Editable Vertices in Visual Mode" top toolbar button showed up when using Doom/Hexen map formats.
Fixed(?), Classic modes: probably fixed an rare issue when map element dragging was not starting when supposed to.


R2390 | 4666f549 | MaxED | 15.02.2016, 19:53
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed another case of sector effects over-updating each other.


R2389 | 4ec6aa28 | MaxED | 15.02.2016, 16:08
--------------------------------------------------------------------------------
Fixed, General interface, Statistics control: map elements count was displayed incorrectly when the number of map elements was greater than 99999.


R2388 | 6177c9cc | MaxED | 15.02.2016, 15:06
--------------------------------------------------------------------------------
Fixed, Texture Browser window: in some cases navigating the textures list using up/down arrows caused an exception.
Fixed, Map Analysis window: fixed an exception on copying warnings to clipboard when the clipboard was used by other application.
Fixed, TEXTURES parser: added special handling for "TNT1A0" sprite name so a texture with this sprite as a single patch is no longer treated as failed loading.
Fixed, Visual mode: in some cases (like line slopes used in several adjacent sectors) sector effect updates were triggered multiple times for the same sector, resulting in noticeable slowdowns and in some cases in infinite recursion.
Updated ZDoom ACC.


R2387 | f711a643 | MaxED | 11.02.2016, 00:40
--------------------------------------------------------------------------------
Added Preferences -&gt; Interface -&gt; "Keep Filter input focused when image browser is open" option. When enabled, all key presses in image browsers will be redirected to the Filter textbox.
Fixed, Texture Browser: it was impossible to scroll the textures list when selecting textures using the arrow keys.
Fixed, Texture Browser: selecting textures in the textures list using the arrow keys worked differently depending on whether the Filter textbox was focused.
Changed, Texture Browser: the control now tries to select the same item / an item close to the previously selected one when applying filtering to the textures list.


R2386 | edcfbb06 | MaxED | 08.02.2016, 22:51
--------------------------------------------------------------------------------
Added, Edit Things window, UDMF: added basic User Variable support. User variables are now automatically shown in the "Custom" tab, are marked with different color and are applied only to actors, which define them.
Fixed, Script Editor: auto-complete can now show the same term several times when it's case is different (like DECORATE's "Bright" keyword and "BRIGHT" flag).
Game configurations, ZDoom: updated "Scroll_Floor" and "Scroll_Ceiling" linedef action argument definitions.
Updated ZDoom_ACS.cfg (Ceiling_CrushAndRaiseSilentDist).
Updated ZDoom_DECORATE.cfg (A_SetChaseThreshold).


R2385 | bd56f1db | MaxED | 08.02.2016, 00:04
--------------------------------------------------------------------------------
Fixed, Sector Edit window, UDMF: sector brightness was applied twice.
Fixed, Tags selector, UDMF: tags from sector with the longest array of tags was applied to sectors with shorter arrays of tags.
Fixed, Draw Settings panel: sidedef texture overrides were not applied when "Auto-clear sidedef textures" setting was enabled.
Added, Thing Edit window, UDMF: added "Show user-added custom fields only" checkbox.


R2384 | db42e17a | MaxED | 07.02.2016, 00:54
--------------------------------------------------------------------------------
Fixed a case when TEXTRES image was trying to load itself as a patch, which resulted in an infinite loop.
Cosmetic: standardized the way resource names are displayed in warning/error messages in the Errors and Warnings window.


R2383 | 4c606623 | MaxED | 06.02.2016, 22:23
--------------------------------------------------------------------------------
Script Editor, Script Editor configurations: added additional keywords category for properties/operators. Added a separate color for those as well.
Fixed, Script Editor: auto-completion and syntax highlighting now works for properties with dots (like "Powerup.Color") and colon (like "See:").
Fixed, Linedef info panel, Hexen map format, cosmetic: activation type should be enabled when the line has an action assigned, even if it's default activation.
Updated ZDoom_linedefs.cfg (Line_SetPortal).


R2382 | 3b90d100 | MaxED | 06.02.2016, 01:04
--------------------------------------------------------------------------------
Re-fixed, Visual mode: in some cases some D3D textures were not disposed after closing a map, eventually resulting in E_OUTOFMEMORY crash.
Fixed, Preferences window: some folding settings were not applied in the Script Editor preview control.
Changed, Visual mode: increased z-buffer depth to 24 bits. Z-fighting among far away but close to each other surfaces should be less noticeable now.


R2381 | 7691ec08 | MaxED | 05.02.2016, 16:21
--------------------------------------------------------------------------------
Added, Script Editor: caret position, scroll amount and fold state are now saved for every opened file when closing the Script Editor. Currently selected tab is saved as well.


R2380 | 839bb52c | MaxED | 02.02.2016, 22:07
--------------------------------------------------------------------------------
Fixed, Things mode: Undo for things cloning by Shift-dragging them was created incorrectly (cloned things were moved to their initial position, but not removed).
Fixed, Visual mode: fixed Classic sky texture generation artifact when Bilinear filtering was enabled in Visual mode.
Fixed, Visual mode: fixed Classic sky texture generation artifact when non-power-of-2 Sky textures were used.
Fixed, Visual mode: dynamic lights flickering on surfaces nearly-perpendicular to lights centers should be much harder to trigger now.


R2379 | acdcd819 | MaxED | 02.02.2016, 15:29
--------------------------------------------------------------------------------
Fixed a crash when using "Open map in current WAD" action when trying to reload any ZDoom text lump (as it turned out, implementing IDisposable in ZDTextParser was not such a bright idea...).


R2378 | a1f85071 | MaxED | 02.02.2016, 13:35
--------------------------------------------------------------------------------
Added, Script Editor, ACC: block comments and #region / #endregion blocks are now foldable.
Fixed, Script Editor, ACC: auto completion for keywords starting with "#" char was not handled properly.
Fixed, Script Editor: replaced the native Scintilla library with the one supplied with SciTE 3.6.2. The Script Editor should now work on Windows XP.
Changed, Script Editor, search: all fold blocks are now unfolded when search result is inside a folded block.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom ACC to git rev. 6bb023d.


R2377 | 139c2971 | MaxED | 01.02.2016, 23:04
--------------------------------------------------------------------------------
Fixed, Visual mode: some video memory was not released after closing a map if the Visual mode was enabled at least once during the editing session, eventually resulting in E_OUTOFMEMORY crash.
Fixed, General interface, cosmetic: in some cases the warnings label was disabled in a flashing state (e.g. with red background).
Internal: moved some older GZDB actions form GZGeneral to MapManager. They can no longer be toggled when no map is loaded (which is probably for the best).
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.


R2376 | 68ad4fdd | MaxED | 29.01.2016, 21:51
--------------------------------------------------------------------------------
Fixed, Script Editor: Cyrillic characters were saved as "?" becuse of incorrect encoding.
Fixed, Script Editor: "Save screenshot" action were processed twice when the Script Editor window was open.


R2375 | 0bb521cc | MaxED | 29.01.2016, 15:54
--------------------------------------------------------------------------------
Preferences: added 2 Script Editor color presets.


R2374 | e29eef32 | MaxED | 29.01.2016, 14:05
--------------------------------------------------------------------------------
Preferences: moved Script Editor settings to a separate page, added a bunch of new Script Editor settings.
Changed: Script Editor no longer converts typed constants to uppercase.
Changed: when "Auto indent" is enabled, Script Editor no longer adds additional indentation to a line after closing brace.


R2373 | 91acd2b6 | MaxED | 28.01.2016, 10:34
--------------------------------------------------------------------------------
Fixed, Script Editor: I forgot to embed the native Scintilla library into the ScintillaNET.dll...
Fixed, Script Editor: text styling was not applied to existing text after changing script configuration.


R2372 | 5fd02a60 | MaxED | 27.01.2016, 15:08
--------------------------------------------------------------------------------
Updated Scintilla control to ScintillaNET 3.5.6 (https://github.com/jacobslusser/ScintillaNET). Scintilla.dll is no longer used by GZDB and can be safely removed.
Changed, Script Editor: pressing Ctrl-S when fixed compilable script tab (like SCRIPTS tab) is selected now compiles the script.
Fixed, Error Logger: fixed slowdowns when adding lots of errors and "Errors and Warnings" window was opened.
Fixed, Script Editor: text caret was incorrectly positioned after selecting a function in the navigator dropdown.
Fixed, Script Editor: incorrect ACS configuration was used for SCRIPTS lump for maps in Hexen map format for ZDoom-based engines.
Internal, rendering: added more error reporing-related code to D3DShader.LoadEffect().
Updated ZDoom_DECORATE.cfg.


R2371 | f9a7c22e | MaxED | 26.01.2016, 23:29
--------------------------------------------------------------------------------
Added, Visual mode: "Raise/Lower Floor/Ceiling to adjacent Sector" actions now take surrounding 3d floors into account.
Added, Visual mode: highlight/selection based on texture alpha now works on 3d floors.
Changed, Game configurations, TranslucentLine:208 action: renamed the second argument from "Translucency Amount" to "Opacity".
Internal, documentation: updated udmf_zdoom.txt.


R2370 | 5d47e331 | MaxED | 26.01.2016, 09:00
--------------------------------------------------------------------------------
Fixed, DB2 bug: hlsl effect stream was not rewound when trying to compile it in debug mode, which resulted in always receiving IndexOutOfRangeException when trying to do it.
Fixed, Visual mode: textures on floors, ceilings and single-sided wall parts are now rendered ignoring texture alpha.
Changed, Game configurations, Sector_Set3dFloor:160 action: renamed the fourth argument from "Alpha" to "Opacity".


R2369 | 1479e23e | MaxED | 25.01.2016, 15:39
--------------------------------------------------------------------------------
Merged changes from DB2 R2482.


R2368 | 2cbe6640 | MaxED | 25.01.2016, 14:42
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases ceiling glow effect was interfering with Transfer Brightness effect resulting in incorrectly lit sidedef geometry.
Fixed, Visual mode: UDMF sidedef brightness should be ignored when a wall section is affected by Transfer Brightness effect.
Fixed, Visual mode: any custom fog should be rendered regardless of sector brightness. 
Fixed, Visual mode: "fogdensity" and "outsidefogdensity" MAPINFO values were processed incorrectly.
Fixed, Visual mode: in some cases Things were rendered twice during a render pass.
Fixed, Visual mode: floor glow effect should affect thing brightness only when applied to floor of the sector thing is in.
Fixed, TEXTURES parser: TEXTURES group was named incorrectly in the Textures Browser window when parsed from a WAD file.
Fixed, MAPINFO, GLDEFS, DECORATE parsers: "//$GZDB_SKIP" special comment was processed incorrectly.
Fixed, MAPINFO parser: "fogdensity" and "outsidefogdensity" properties are now initialized using GZDoom default value (255) instead of 0.


R2367 | 864053c0 | MaxED | 22.01.2016, 13:21
--------------------------------------------------------------------------------
Fixed, Vertex Edit form: relative X/Y position values were applied incorrectly.
Updated ZDoom ACC.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.


R2366 | a1c290d4 | MaxED | 20.01.2016, 18:54
--------------------------------------------------------------------------------
Fixed a crash when trying to parse an empty TEXTURES lump (probably covers some other empty text lumps as well).
Added strict revision checking to BuilderModes.dll (this plugin must always stay in sync with the core).


R2365 | 8ac4189c | MaxED | 18.01.2016, 21:37
--------------------------------------------------------------------------------
Changed, Visual mode: reduced dynamic lights intensity to better match with GZDoom.
Fixed, Map conversion: game mode flags were ignored when converting from Doom map format to UDMF.
Fixed, Edit Selection mode: when "Drag selection automatically on paste" setting was enabled, it was possible to start rotating/scaling map elements instead of dragging them after pasting.


R2364 | fbb30f6f | MaxED | 18.01.2016, 12:39
--------------------------------------------------------------------------------
Fixed, "Open map in current wad" action: MAPINFO data must be updated when using the action.
Changed, "Open map in current wad" action: current map resources are now carried over to the map being switched to.


R2363 | 48373850 | MaxED | 18.01.2016, 12:02
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed a crash when creating classic skybox texture when sky texture's height was less than 28 pixels.


R2362 | 0e718c97 | MaxED | 18.01.2016, 00:50
--------------------------------------------------------------------------------
DECORATE support: added a warning when a sprite assigned using "$sprite" special comment does not exist.


R2361 | c11d5302 | MaxED | 17.01.2016, 22:53
--------------------------------------------------------------------------------
Fixed, Edit Thing window: fixed a crash when entering thing type in the Type field when a filter was applied to the things list.
Fixed, MAPINFO parser: in some cases the parser was skipping the whole file instead of current map block while parsing classic map definition.
Fixed, Visual mode: classic sky model had incorrect rotation.


R2360 | 0258cf10 | MaxED | 16.01.2016, 13:46
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed inability to drag auto-selected sidedef parts using mouse when "Synchronize selection between Visual and Classic modes" setting was enabled.
Fixed, Visual mode: fixed incorrect auto-selected sidedefs texture offset clamping when "Synchronize selection between Visual and Classic modes" setting was enabled.


R2359 | fd008a96 | MaxED | 15.01.2016, 23:27
--------------------------------------------------------------------------------
Fixed a crash when pasting sectors, linedefs and sidedefs introduced in R2471.


R2358 | 0beb3eb9 | MaxED | 15.01.2016, 23:19
--------------------------------------------------------------------------------
Fixed a crash during skybox textures search when searching for any image and not finding it in the first PK3 or Directory resource.
Fixed: TGA image detection required a special approach...
Fixed, Visual mode: built-in sky texture should not be mirrored like the classic ones.


R2357 | 998ec3bc | MaxED | 15.01.2016, 19:20
--------------------------------------------------------------------------------
Added "Sector Floor Flat" and "Sector Ceiling Flat" Find and Replace modes.
Updated skybox model to better match GZDoom's skybox. Also the sky texture was flipped horizontally.
Fixed, Visual mode: "Select with the same texture" action is now able to select sidedef parts only visible because of slopes.
Fixed, Visual mode: skybox texture was not updated after using "Open map in current wad" action.
Fixed, Visual mode: in some cases Visual camera was placed below sector's floor when "Sync camera position between 2D and 3D modes" setting was enabled.
Fixed: numeric thing flags with inverted UDMF flag defined in "thingflagstranslation" Game configuration block were lost when copy-pasting a thing.
Fixed, command line arguments: fixed a crash when loading a map from a wad with existing .dbs file.


R2356 | ada38c44 | MaxED | 14.01.2016, 23:15
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed D3DERR_INVALIDCALL error caused by a bug in classic skybox texture creation.
Fixed, Visual mode: aspect ratio was not updated when render area was resized.
Fixed, Visual mode: vertex handles were disappearing after using Reload Resources (F8) action.
Changed, internal: removed most of the fixed pipeline rendering code. The editor can no longer be used on a video card without Shader Model 2.0 support.


R2355 | f0643cbd | MaxED | 14.01.2016, 12:39
--------------------------------------------------------------------------------
Updated, Visual mode: classic skies are now rendered much closer to the way GZDoom renders them.
Fixed, Visual mode: "Select with the same texture" action should not select invisible geometry (like sidedef parts hidden by slopes).
Changed, Sector drawing: default sector height is now used when the nearest sector's height is &lt;= 0.


R2354 | 75b107ef | MaxED | 13.01.2016, 10:34
--------------------------------------------------------------------------------
Updated: any graphic can be used as a skybox texture.
Fixed a crash when trying to get map title after closing Map options window.
Updated game configurations (Sector_SetPortal).


R2353 | a4699e15 | MaxED | 12.01.2016, 23:56
--------------------------------------------------------------------------------
Fixed, Visual mode: "render as sky" flag was not updated for upper wall geometry when pasting textures (and in some other cases).


R2352 | 5eb5ffbc | MaxED | 11.01.2016, 15:27
--------------------------------------------------------------------------------
Fixed, Updater window: "Ignore this update" checkbox was incorrectly anchored.


R2351 | 37feaa5d | MaxED | 11.01.2016, 14:00
--------------------------------------------------------------------------------
Added, Visual mode: sky rendering. Currently classic skies and GLDEFS Skyboxes are supported.
Added "Toggle sky rendering" action and toolbar button.
Added, MAPINFO parser: the editor now recognizes map number from classic map definition format. Hexen MAPINFO is now properly parsed.
Added, MAPINFO support: if current map definition contains map name as a text string, it will be shown in the editor's header.
Changed: "Toggle dynamic lights rendering" now toggles between "Don't show dynamic lights" and "Show dynamic lights" when used in Classic modes. 
Changed, Things mode: lowered the opacity of dynamic light radii.
Changed, (G)ZDoom text parsers: empty include files now trigger a warning instead of an error and no longer abort parsing.
Fixed, Game configurations: moved Stalagmite:5050 thing to Doom block (so the editor no longer tries to load it for non-Doom game configurations).
Fixed(?), Visual mode: probably fixed a hard-to-trigger exception when sorting translucent geometry.
Fixed, Visual mode: floor glow effect was incorrectly applied to walls (was broken in R2452).
Internal: restructured most of MAPINFO and GLDEFS parsers. Should be more maintainable now.  
Updated ZDoom ACC.
Updated zdbsp to 1.19.
Updated documentation.


R2350 | eb35bccd | MaxED | 02.01.2016, 19:26
--------------------------------------------------------------------------------
Fixed, Game configurations: ZDoom things 9994 and 9995 had the same title.
Updated ZDoom_DECORATE.cfg.


R2349 | 59da0cf2 | MaxED | 01.01.2016, 19:10
--------------------------------------------------------------------------------
MODELDEF, DECORATE, GLDEFS parsers: fixed a crash when checking a file path when said path contained unsupported characters.


R2348 | 0ecd5285 | MaxED | 30.12.2015, 14:58
--------------------------------------------------------------------------------
Externalized most of the editor's built-in textures. You can find (and replace) them in the "[GZDB]\Textures" folder.


R2347 | 64b822b9 | MaxED | 30.12.2015, 12:53
--------------------------------------------------------------------------------
Implemented, TEXTURES: ZDoom can use any graphic as a texture patch.
Fixed a typo.


R2346 | 0c8b91f4 | MaxED | 29.12.2015, 19:22
--------------------------------------------------------------------------------
Fixed a crash when trying to create a texture from an unnamed TEXTURE1/2 entry.


R2345 | 703343c0 | MaxED | 29.12.2015, 13:45
--------------------------------------------------------------------------------
Fixed, Things mode: light radius for SectorPointLight was calculated incorrectly.


R2344 | 4920091e | MaxED | 29.12.2015, 12:44
--------------------------------------------------------------------------------
Fixed a crash after pressing "Edit Selection" button in the Find and Replace window when several instances of the same map element were selected.
Redesigned the Test Map button's drop-down: test engines are now shown and behave the same way as skills and also have appropriate icons.


R2343 | 0998da45 | MaxED | 28.12.2015, 22:56
--------------------------------------------------------------------------------
Fixed, Thing/Linedef edit forms: fixed a crash during form setup when Action was either unknown or generalized.
Fixed, ANIMDEFS parser: in some cases the parser was unable to read camera texture name.


R2342 | 4c794ad0 | MaxED | 28.12.2015, 19:19
--------------------------------------------------------------------------------
Fixed, Classic modes: text labels positioning logic was accidentally broken in R2455.


R2341 | 3a35b760 | MaxED | 28.12.2015, 16:01
--------------------------------------------------------------------------------
Fixed, Map Analysis mode, "Check stuck things" check: rewritten parts of the flags checking logic to allow more accurate flag checks.
Fixed, Map Analysis mode: fixed a crash when trying to dissolve an invalid sector when one of it's linedefs referenced it on the both sides.
Fixed, Sectors mode: fixed incorrect undo description when deleting sectors.
Internal: joined declaration and assignment of some more variables.


R2340 | f6f27706 | MaxED | 27.12.2015, 22:54
--------------------------------------------------------------------------------
ACS parser: fixed several cases when #include and #import directives were processed incorrectly.
Internal: joined declaration and assignment of some variables.


R2339 | f86bc370 | MaxED | 27.12.2015, 01:13
--------------------------------------------------------------------------------
Fixed, GLDEFS parser: in some cases the parser was unable to detect the end of "Glow" block, which resulted in skipping the rest of the file.


R2338 | dc3d4064 | MaxED | 24.12.2015, 12:59
--------------------------------------------------------------------------------
Fixed, Visual mode: GLDEFS glow effects should not affect 3d floor brightness.
Updated ZDoom ACC and ZDoom_ACS.cfg (added GetInventoryMax()).


R2337 | f3fbf241 | MaxED | 21.12.2015, 15:17
--------------------------------------------------------------------------------
Fixed, text parsers: in some cases include directives were processed differently from ZDoom.
Fixed, ACS parser: absolute and relative include paths handling was broken in R2448.


R2336 | 3621ff78 | MaxED | 19.12.2015, 01:05
--------------------------------------------------------------------------------
Fixed, UDMF parser: property names must be case-insensitive.
Fixed, ANIMDEFS parser: camera texture names are limited to 8 chars in ZDoom.
Fixed, Game configurations: Stalagtite:47 thing was named Stalagmite.
Changed, Game configurations: moved Stalagmite:5050 thing to the "Obstacles" category.


R2335 | b9eba267 | MaxED | 18.12.2015, 11:16
--------------------------------------------------------------------------------
Added ANIMDEFS CAMERATEXTURE support.
Some internal changes in text parsers logic.


R2334 | dbcc57b7 | MaxED | 17.12.2015, 11:07
--------------------------------------------------------------------------------
Fixed, Script Editor: file was marked as changed when changing script configurations.
Fixed, Script Editor: in some cases clicking on an error in the errors list didn't navigate to the error location.
Fixed, Script Editor: in some cases incorrect error line number was shown.
Fixed, Text lump parsers: fixed a crash when trying to get a filename from a quoted string with missing closing quote.
Fixed, Text lump parsers: in several cases parsing errors were ignored by overlaying data structures.
Fixed: in some cases Thing Filter thing flags were cleared when switching game configurations in the "Game Configurations" window.
Changed, PK3 reader: loading of files with invalid path chars is now skipped instead of skipping loading of the whole resource. Also more helpful warning message is now displayed.
Updated SharpCompress library to v.0.11.2.0.


R2333 | a35a3365 | MaxED | 14.12.2015, 13:34
--------------------------------------------------------------------------------
Added, Things mode: dynamic light things light radii are now rendered (can be disabled by setting "Dynamic light mode" to "Don't show dynamic lights" on the top toolbar).
Internal, Renderer2D.RenderArrows(): only visible lines are now rendered.
Internal, API: renamed public Line3D properties: v1 to Start, v2 to End, color to Color, renderarrowhead to RenderArrowhead.


R2332 | b35684e1 | MaxED | 13.12.2015, 23:14
--------------------------------------------------------------------------------
Changed, Renderer2D: StartOverlay() now works the same way as StartPlotter() and StartThings() (e.g. returns false when unable to render instead of throwing an Exception. Should prevent crashes for people with slow GPUs / very complex maps).


R2331 | e44b918b | MaxED | 13.12.2015, 20:18
--------------------------------------------------------------------------------
Changed, "Select Similar", "Paste Properties Special" actions properties windows, Linedefs: removed "Sidedef Properties" from Linedef flags tab.
Fixed several issues with "Synchronized Things Selection" setting:
- Things were not deselected after dragging a single sector.
- Things were not deselected after editing properties of a single sector.
- Things sector references were not updated after using "Join Sectors" and "Merge Sectors" actions.
- Things (de)selection is now applied to all things, instead of only the ones visible using current Things Filter.


R2330 | 56baafe1 | MaxED | 10.12.2015, 19:07
--------------------------------------------------------------------------------
Fixed, "Select Similar Map Elements" action: Sector/Linedef tag matching logic was inverted.


R2329 | 2ea51d23 | MaxED | 10.12.2015, 15:34
--------------------------------------------------------------------------------
Cosmetic, actions: renamed "Lower Floor/Ceiling by 8 mp" to "Lower Floor/Ceiling/Thing by 8 mp", "Raise Floor/Ceiling by 8 mp" to "Raise Floor/Ceiling/Thing by 8 mp", "Lower Floor/Ceiling by 1 mp" to "Lower Floor/Ceiling/Thing by 1 mp", "Raise Floor/Ceiling by 1 mp" to "Raise Floor/Ceiling/Thing by 1 mp", "Lower Floor/Ceiling to adjacent sector" to "Lower Floor/Ceiling/Thing to adjacent Sector/Thing", "Raise Floor/Ceiling to adjacent sector" to "Raise Floor/Ceiling/Thing to adjacent Sector/Thing".
Updated, Visual mode, "Raise Floor/Ceiling/Thing to adjacent Sector/Thing" / "Lower Floor/Ceiling/Thing to adjacent Sector/Thing" actions: sectors across targeted sectors are now taken into account when determining target height.
Updated, Visual mode, "Raise Floor/Ceiling/Thing to adjacent Sector/Thing" / "Lower Floor/Ceiling/Thing to adjacent Sector/Thing" actions: the actions can now stack things on top of other things when their bounding boxes intersect. 
Internal: cosmetic changes to shader update logic.
Internal: thing bounding box is now used when adding a thing to VisualBlockMap.


R2328 | 44b5c60b | MaxED | 09.12.2015, 22:17
--------------------------------------------------------------------------------
Fixed, Doom -&gt; Hexen map format conversion: SP/Coop/MP flags were lost during Thing flags conversion resulting in Things not showing in any game mode.


R2327 | dd869a23 | MaxED | 09.12.2015, 20:55
--------------------------------------------------------------------------------
Fixed, Visual mode: "Same texture" check for "Select" action is now case-insensitive.


R2326 | fd9b8628 | MaxED | 09.12.2015, 20:10
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed a crash when showing Edit Vertex window when several selected vertices belonged to the same sector.


R2325 | 82699503 | MaxED | 07.12.2015, 22:57
--------------------------------------------------------------------------------
Fixed, Texture browser: "Show textures in subdirectories" setting was not applied to the root directory.
Changed, Image formats: GIF images will no longer be loaded, because (G)ZDoom doesn't support them.
Updated ZDoom_DECORATE.cfg.
Updated ZDoom_ACS.cfg.
Updated ZDoom ACC.


R2324 | db48ce4b | MaxED | 04.12.2015, 13:29
--------------------------------------------------------------------------------
Added, Visual mode: fog boundaries are now rendered.
Fixed, Visual mode: in some cases fog density of 3d floor floors/ceilings was calculated incorrectly.


R2323 | e4d2019d | MaxED | 02.12.2015, 14:55
--------------------------------------------------------------------------------
Fixed, Visual mode, "Auto-align textures" actions, UDMF: vertical offsets of non-wrapped middle textures should not be clamped.
Fixed, Visual mode: brightness of 3d floors with "disable lighting" flag was calculated incorrectly.
Fixed, Sectors mode: 3d floor linedef indicators were not updated after using "Join Sectors" and "Merge Sectors" actions.


R2322 | e1f7bd96 | MaxED | 01.12.2015, 15:51
--------------------------------------------------------------------------------
Added, Visual mode: "Translucent" / "Additive" renderstyles support for models. 
Fixed, Visual mode, fog rendering: things with Bright setting should still be affected by custom fade.
Updated ZDoom_DECORATE.cfg.


R2321 | e8cda3c9 | MaxED | 30.11.2015, 15:18
--------------------------------------------------------------------------------
Script Editor:
Added: Tab text now looks differently when appropriate script was changed.
Added: Script Editor now has it's own status bar.
Added: several files can now be opened at once when using "Open File" command.
Added: ACS scripts navigator now shows script and function arguments.
Changed: when closing a tab, previous tab is selected instead of the first tab.
Changed: SCRIPTS lump can't be compiled as a library.
Changed: external acs files can only be compiled as libraries.
Changed: when an external acs file is marked as #library, it will be saved as [library name].o alongside [filename].acs.
Fixed: files opened using "Open File" command were immediately flagged as changed.
Fixed: Script Editor was unable to navigate to error location after clicking on the error description when the error was in include file.
Updated ZDoom ACC.


R2320 | 16da2531 | MaxED | 29.11.2015, 19:50
--------------------------------------------------------------------------------
Things Edit window, UDMF: added control for "floatbobphase" property.


R2319 | e3cbe791 | MaxED | 29.11.2015, 00:31
--------------------------------------------------------------------------------
Fixed, ACS parser: fixed another crash when trying to load zero-length acs lump/file.


R2318 | 6d0823b9 | MaxED | 28.11.2015, 21:59
--------------------------------------------------------------------------------
Fixed, ACS parser: fixed a crash when trying to load zero-length acs lump/file.
Fixed, Visual mode: fixed incorrect GLDEFS glow brightness calculation for Things.
Updated ZDoom_DECORATE.cfg.


R2317 | 295c9bc3 | MaxED | 24.11.2015, 11:46
--------------------------------------------------------------------------------
Fixed, ACC compiler: in some cases ACC errors were ignored.
Fixed, Script Editor, cosmetic: we should not show error line number when we don't have one.
ZDoom acc.exe: several error types now output more detailed info.
Fixed, Visual mode: UDMF thing alpha property was applied only when UDMF renderstyle property was also set (should also be applied when renderstyle property is set in the DECORATE actor definition).
Game configurations, ZDoom family: Pistol and Gold Wand actors now use internal sprites.
Updated ZDoom ACC and ZDoom_ACS.cfg (PickActor flags).


R2316 | 098e9724 | MaxED | 20.11.2015, 15:31
--------------------------------------------------------------------------------
Visual mode: rewritten most of the 3d floor clipping and light/color assignment logic. As a result, 3d floors should look much closer to what's seen in GZDoom.
Fixed, Visual mode: glow effect was not updated when changing sector textures using the "Select Texture" action.
Browse Textures/Flats window: when textures list is focused, you can now start typing to change the Filter.


R2315 | b7ebde6b | MaxED | 17.11.2015, 18:50
--------------------------------------------------------------------------------
Fixed, Visual mode, UDMF: incorrect texture name was copied when using "Copy Texture" action when copying a texture stored in a folder resource when "Use long texture names" settings was enabled.


R2314 | dfdcaaf6 | MaxED | 17.11.2015, 13:22
--------------------------------------------------------------------------------
MODELDEF support: model frame number is now taken into account when loading MD3 models.
MODELDEF support: model frame number / frame name are now taken into account when loading MD2 models.
Compiling: changed the way /LARGEADDRESSAWARE flag is applied so it works when building using VS and batch files.


R2313 | fc30082d | MaxED | 16.11.2015, 22:10
--------------------------------------------------------------------------------
Thing Browser Control: fixed cosmetic focusing issue. When Things list is focused, you can now start typing to change the Filter.
Edit Action window: Actions list is now automatically focused on mouse over. When Actions list is focused, you can now start typing to change the Filter.
Edit Effect window: Effects list is now automatically focused on mouse over. When Effects list is focused, you can now start typing to change the Filter.
Game Configurations: added "Gold Wand" to all ZDoom-based Heretic configurations (also a couple of cosmetic tweaks).
Game Configurations: changed "Pistol" display sprite to the one provided with (G)ZDoom.


R2312 | e62da4e6 | MaxED | 16.11.2015, 09:14
--------------------------------------------------------------------------------
Fixed, Linedef Color Presets window: Linedef Actions and Linedef Activations lists were accidentally modified during window initialization.


R2311 | f452fca5 | MaxED | 13.11.2015, 22:42
--------------------------------------------------------------------------------
Fixed, Script Editor: in some cases includes list was not updated before trying to compile the script leading to compilation failure.
Changed, ACC compiler: when building includes list, the compiler no longer tries to find/copy include files defined in current script configuration (previously it was hardcoded to skip "zcommon.acs" and "common.acs" only).
Fixed, Visual mode: things with Additive RenderStyle were rendered as additive only when their alpha was less than 1.0.


R2310 | 9b87dc71 | MaxED | 11.11.2015, 23:22
--------------------------------------------------------------------------------
Fixed: in some cases the editor was unable to determine which sector a Thing is located in when such thing was placed on top of a linedef between 2 rectangular sectors.


R2309 | afbcac30 | MaxED | 09.11.2015, 13:20
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed a crash when trying to render a Thing with translucent or additive renderstyle outside of any sector.
Fixed, Classic modes: 3d floor linedef indicators shown in Classic modes were not updated after finishing sector drawing.
Updated ZDoom ACC to git rev. f92fbb9.
Updated ZDoom_ACS.cfg.


R2308 | ff40bdc5 | MaxED | 08.11.2015, 21:20
--------------------------------------------------------------------------------
Fixed, Visual mode: fixed a crash when undoing 3d floor creation.
Fixed: 3d floor linedef indicators shown in Classic modes were not updated when 3d floor creation was undone in Visual mode.
Performance optimization when selecting sectors in Sectors mode with "Synchronized Things selection" setting enabled.


R2307 | 17ac1c6d | MaxED | 03.11.2015, 09:54
--------------------------------------------------------------------------------
Sectors/Linedefs modes: removed "Select Things in Selected Sectors" action.
Sectors mode: removed "Move Things in Selected Sectors" toolbar button.
Sectors mode: added "Synchronized Things Editing" menu item, action and toolbar button. When enabled, things dragging will be synchronized to sector dragging. Regular, Paint and Rectangular selection will also select things (holding Alt while selecting inverts this behavior). Deleting sectors will also delete selected things.
Linedefs mode: added "Synchronized Things Editing" menu item, action and toolbar button. When enabled, selected things will be dragged when dragging linedefs. Rectangular selection will also select things (holding Alt while selecting inverts this behavior).
Changed: selection info now always displays info about all types of map elements.
Fixed: .dbs containing only current map settings was created when trying to save unchanged map. 
Fixed, Visual mode, "Copy Texture" action: when "Use long texture names" option is disabled, texture name as stored in Sidedef should be used, not the 8-char texture name.
Updated documentation.


R2306 | 217ca837 | MaxED | 28.10.2015, 13:08
--------------------------------------------------------------------------------
Fixed, Visual mode: size override thing argument types were not taken into account when creating thing bounding box geometry.


R2305 | 958bc4de | MaxED | 26.10.2015, 20:58
--------------------------------------------------------------------------------
Fixed, Visual mode, DB2 bug: Visual Camera Thing's (32000) vertical position was always set to -41 when switching from Visual mode if the camera was not inside a sector.


R2304 | 19c84692 | MaxED | 26.10.2015, 12:58
--------------------------------------------------------------------------------
Fixed, Map Analysis mode: in some cases "Check stuck things" check didn't work properly.
Fixed: only one test engine should be launched from the editor at any given time.
Changed: SVN builds now include debug symbols.
Internal: VersionFromSVN.exe can now work from a network drive.
Updated ZDoom ACC to git rev. 3071c32.
Updated ZDoom_DECORATE.cfg ("A_Warp").


R2303 | 375f857e | MaxED | 23.10.2015, 16:51
--------------------------------------------------------------------------------
Changed: the editor will now show more detailed messages when unable to initialize DirectX 9.
Updated Inno Setup file.


R2302 | b68ecf50 | MaxED | 23.10.2015, 14:29
--------------------------------------------------------------------------------
Irrelevant menu items are no longer shown in the "File" and "Help" menus when no map is open.
Some cosmetic tweaks to GZBuilder.default.cfg.


R2301 | 3fb5679a | MaxED | 23.10.2015, 14:01
--------------------------------------------------------------------------------
Fixed: "Sectors -&gt; Select Things in Selected Sectors" menu item was not triggering the appropriate action.
Fixed: "Select Things in Selected Sectors" action was clearing selected sectors without updating the display.
Changed, Sectors mode: number of selected things is now displayed in the info panel.
Changed, Game Configurations window, "Testing" tab: game engine executable browser now opens up when clicking the "Add game engine" button.
Changed, Game Configurations window, "Testing" tab: default game engine display name is now generated from the folder name game engine executable is in.
Changed, Visual mode: Sector_Outside (87) sector effect is now taken into account when determining sector fog color.
Game configurations: added "defaultwalltexture", "defaultfloortexture" and "defaultceilingtexture" parameters. These define textures used when drawing a sector (usually the first sector of a map only).
Game configurations: classic game configurations now use "-warp" command to load the map.
Game configurations: factorized testing parameters into "Includes\Test_params.cfg".
Added internal functions to Hexen acs scripting configuration.
Updated documentation ("Game Configuration - Basic Settings" topic).


R2300 | a182a509 | MaxED | 21.10.2015, 15:35
--------------------------------------------------------------------------------
Game Configurations: added Vanilla Strife, Vanilla Heretic and Vanilla Hexen game configurations.
Added "makedoorceil" game configuration property. Works the same way as "makedoortrack" and "makedoordoor", but for ceilings of door sectors. 
Changed, Game configurations: the editor no longer tries to load DECORATE/MODELDEF/VOXELDEF/GLDEFS/REVERBS lumps when "decorategames" setting is not specified / is set to empty string.
Changed, General interface: "Tools -&gt; Reload MODELDEF/VOXELDEF" and "Tools -&gt; Reload GLDEFS" menu items are no longer shown when current game configuration doesn't support DECORATE. 
Fixed a crash when pasting linedef/thing properties in Hexen map format.
Fixed, Visual mode: Visual Thing resources were not fully unloaded when resetting D3D device leading to crash when switching to the editor from a DX-using game engine (like ZDoom) running in fullscreen.
Fixed: in some cases, when current game configuration supported multiple script compilers, it was possible to open/create a map or change map options without selecting any script compiler.
Fixed, New Map Options window: default map name was not updated when switching game configurations.
Fixed: copied map element properties were not reset after switching to another map.
Fixed: stored textures for "Make Door" action were not reset after switching to another map.
Fixed, Game Configurations window: currently selected test engine name was not updated when pasting test engines from another configuration. 
Fixed, Game Configurations: all "Heretic in Doom map format" configurations were using Doom sector effects list.
Fixed, Game Configurations: all "Strife in Doom map format" configurations were using Doom sector effects list.


R2299 | 027df506 | MaxED | 16.10.2015, 10:32
--------------------------------------------------------------------------------
Fixed, DB2 bug: scaled size of a texture is an integer value in ZDoom, so we should also treat it as such.


R2298 | 7febb243 | MaxED | 15.10.2015, 17:16
--------------------------------------------------------------------------------
Fixed, Visual mode: horizontal sprite offset was applied incorrectly.
DECORATE: added "$obsolete" special comment. When present, it marks the thing as obsolete. It will be detected by "Check obsolete thing" Map Analysis Mode check and will be marked in the Thing Properties Window and the Thing Info panel.
Map Analysis mode: added "Check obsolete things" check.
Updated documentation ("DECORATE keys" page).
Updated ZDoom_DECORATE.cfg.


R2297 | 77d2a15f | MaxED | 09.10.2015, 23:57
--------------------------------------------------------------------------------
Changed: when entering Visual mode, the camera is no longer positioned at "Visual Mode camera" thing when "Sync camera position between 2D and 3D mode" setting is enabled.
Changed: Visplane Explorer plugin is now initialized only in Doom/Hexen map formats.
Fixed, Visual mode: thing cages were not rendered when things didn't have a sprite.
Fixed, Internal, DB2 bug: Plug.Dispose() was never called.


R2296 | 13c3155d | MaxED | 09.10.2015, 14:38
--------------------------------------------------------------------------------
Removed "Paste Properties Options" action.
Added "Paste Properties Special" actions in "Classic" and "Visual" categories. They work the same way as "Paste Special" action.
Added: "Copy Properties", "Paste Properties" and "Paste Properties Special" options are now shown in the Edit menu if current classic mode supports them.
Changed, Paste Properties Special window: only options relevant to current map format are now displayed.
Changed, Paste Properties Special window, UDMF: all UI-managed options are now available.
Fixed: MAPINFO parser was unable to process "include" directives.
Fixed, General interface: selection info was reset to "Nothing selected" after few seconds regardless of current selection.
Fixed, Visual mode: thing bounding boxes were not updated when changing things positions using Randomize mode.
Fixed, Visual mode: event lines were displayed at incorrect height when entering Visual mode for the first time.
Fixed, Texture Browser window: when MixTexturesFlats Game Configuration option is disabled, textures/flats are no longer shown in the Used group when flats/textures with the same names are used in the map. 
Fixed(?): probably fixed an exception some users reported when trying to initialize a Classic mode after switching from Visual mode with "Sync cameras" option enabled.
Changed, Game configurations, Thing Categories: a block must have at least one thing category property to be recognized as a thing category.
Changed, Visplane Explorer: the plugin now outputs more info when it fails to initialize vpo.dll.
Cosmetic, Thing Edit window, Doom/Hexen map format: adjusted UI layout so thing flags control no longer displays scrollbars in Hexen map format.
Internal: merged methods from UDMFTools into UniFields, removed UDMFTools. 
Updated Inno Setup script (added VC++ 2008 SP1 distributive). 
Updated ZDoom_DECORATE.cfg (A_CheckBlock).
Updated documentation (added "System Requirements" page).


R2295 | 9253788c | MaxED | 03.10.2015, 01:15
--------------------------------------------------------------------------------
Fixed, DB2 bug: we should not switch to a new editing mode if it fails to initialize.
More detailed info is now saved to the log file (GZBuilder.log) when an editing mode fails to initialize.
General interface: added "Help -&gt; Program Configuration Folder" menu item.


R2294 | 283c6c22 | MaxED | 02.10.2015, 16:47
--------------------------------------------------------------------------------
Visual mode: noticeable performance boost (rendering now works ~40% faster).
Visual mode: fog distance calculation is now much closer to GZDoom one.
Visual mode: thing brightness calculation when a thing is affected by floor glow is now much closer to GZDoom one.
Linedef edit window, UDMF: added "Reset front/back brightness" buttons.
Sector edit window, UDMF: added "Reset ceiling/floor brightness" buttons.
Internal, Visual mode, Things mode: persistent event lines are now updated only when map objects are changed instead of doing it on every display redraw.
Internal: improved Dictionary lookup times when using map objects and textures as keys.
Internal: added "Release + Profiler" solution configuration.
Updated ZDoom_ACS.cfg (Warp).


R2293 | 942c8a32 | MaxED | 01.10.2015, 23:35
--------------------------------------------------------------------------------
Fixed, UDMF: we should fail map loading if there were TEXTMAP parsing errors.
Fixed, UDMF parser: parser failed to parse decimals stored using scientific notation (like "1E-06").
Fixed, UDMF parser: incorrect line numbers were shown when displaying errors.
Changed, UDMF parser: many error descriptions are now more detailed.
Updated ZDoom ACC to Git rev. ae5f036.


R2292 | 439d9adc | MaxED | 28.09.2015, 21:49
--------------------------------------------------------------------------------
"Fixed", DECORATE parser: looks like treating missing parent class as an error was way too overwhelming to some users, so parsing is no longer aborted and a warning is added instead of an error.


R2291 | 07b4a7a9 | MaxED | 28.09.2015, 16:57
--------------------------------------------------------------------------------
Added, Visual mode, DECORATE: "Alpha" and "DefaultAlpha" properties are now supported.
Added, Visual mode, DECORATE: "RenderStyle" property is now partially supported.
Added, Visual mode, DECORATE: +BRIGHT flag is now supported.
Added, Visual mode, UDMF: "Alpha" thing property is now supported.
Added, Visual mode, UDMF: "RenderStyle" thing property is now partially supported.
Added, Visual mode, Hexen map format and UDMF: "Translucent" and "Invisible" thing flags are now supported.
Added, Game Configurations: added "alpha" and "renderstyle" Thing and Thing Category properties.
Fixed, Visual mode: blockmap was not updated when moving things using "Move Thing Left/Right/Forward/Backward" and "Move Thing to Cursor Location" actions.
DECORATE parser: added a warning when unable to find actor's parent class.
Internal: current map format can now be checked using "General.Map.UDMF", "General.Map.HEXEN" and "General.Map.DOOM" properties.
Updated documentation ("Game Configuration - Things Settings" page).


R2290 | f729c811 | MaxED | 27.09.2015, 23:09
--------------------------------------------------------------------------------
Added, Visual mode: translucent/additive geometry is now rendered properly.
Fixed: "Open map in current wad" action was accidentally broken in R2403.


R2289 | dc840605 | MaxED | 25.09.2015, 15:20
--------------------------------------------------------------------------------
Added emergency map backup system (EMBS). When the editor crashes, it will try to export a backup copy of the map structures. When the same map is loaded again, it will ask the user if he wants to restore the map.
High-DPI: fixed many issues with incorrect controls size (Tag selector width, Comment Editor size, icons size, tabs size etc.).
Cosmetic: changed map geometry dragging undo messages to more descriptive ones.
Fixed, Textures Browser, cosmetic: "Show textures in subdirectories" checkbox should be repositioned when "Long texture names" one is invisible.
Updated ZDoom_DECORATE.cfg (added A_SetFloatSpeed + a couple of fixes).


R2288 | c3800fcf | MaxED | 23.09.2015, 13:04
--------------------------------------------------------------------------------
Fixed, Visual mode, Auto-align actions: incorrect texture was used when clamping texture offsets of 3D floor sides.
Fixed, Numeric textbox: incorrect character was treated as decimal separator character was used when using certain Windows regional settings.
Changed, Edit Things window: when applicable, the "Filter" textbox is now focused when opening the window.
Changed, Sector Effects browser window: when applicable, the "Filter" textbox is now focused when opening the window.
Changed, Edit Things window: when the "Filter" textbox is focused, pressing the "Down" key will now switch focus to the Things list.
Changed, Sector Effects Browser window: when the "Filter" textbox is focused, pressing the "Down" key will now switch focus to the Effects list.
Changed, Linedef Action Browser window: when the "Filter" textbox is focused, pressing the "Down" key will now switch focus to the Actions list.
Configurations, Doom map format thing flags: changed "Multiplayer" flag name to "Multiplayer only".


R2287 | ff265d87 | MaxED | 17.09.2015, 14:02
--------------------------------------------------------------------------------
Added some boilerplate to the rendering system. It's now impossible to start new rendering cycle if the previous one hasn't finished yet.
Changed: OS name, GPU name and GZDB revision info are now added to the exception text and GZCrash.log.
Fixed, cosmetic: toolstrip separators visibility must be updated when resizing the main window.
Internal: removed Plug.DisplaySize, Plug.DisplayLocationAbs and Renderer.ViewportSize. The same data can be accessed from anywhere using General.Interface.Display.Size and General.Interface.Display.LocationAbs. Also Plug.DisplayLocationAbs returned incorrect coordinates...


R2286 | 118bda42 | MaxED | 16.09.2015, 22:22
--------------------------------------------------------------------------------
Changed, Drag Things mode: things position is now snapped to integers after finishing dragging. Also removed some unneeded update code.
Fixed a crash when deleting sectors (introduced in R2399).


R2285 | 25b3bf22 | MaxED | 16.09.2015, 14:10
--------------------------------------------------------------------------------
Added, Texture Browser: added "Show textures in subdirectories" checkbox (enabled by default). When enabled, textures from current PK3/PK7/Directory resource directory and it's subdirectories will be shown. Otherwise, only textures from current directory will be shown.
Removed, Texture Browser: removed "Show image sizes" checkbox. "Show texture and flat sizes in browsers" preferences setting is now used instead.
Fixed, Things mode: event line between pre-last and the last PatrolPoint was not drawn.
Fixed, Things mode: highlight range for sizeless things (things with "fixedsize" game configuration property) was calculated incorrectly.
Fixed: fixed a crash when opening Script Editor after using "Open map in current wad" command to switch to UDMF map with SCRIPTS lump when current script configuration was not saved in the wad's .dbs file.
Fixed: map closing events were not triggered when using "Open map in current wad" command, which could potentially result in plugin crashes/incorrect behavior.
Fixed: Sector Drawing overrides panel could trigger an exception when closing the map during resource loading.
Internal: added "Debug + Profiler" solution configuration, added 2 profiling methods to DebugConsole.
Internal: rewrote MainForm.DisplayStatus() / StatusInfo to handle selection info in a more structured way.
Fixed, internal: some destructors could potentially be executed more than once potentially leading to exceptions. Other destructors were not called at all.
Updated ZDoom_DECORATE.cfg.


R2284 | 6ac256eb | MaxED | 12.09.2015, 23:05
--------------------------------------------------------------------------------
Fixed: map file lock check was performed in incorrect place leading to always reporting the map file as locked on Windows XP.
Fixed, DB2 bug (partially): 4 settings were reset to the state saved in the program configuration after applying the changes made in the Preferences window.
Fixed: several Brushes were not disposed in ImageBrowserItem (DB2 bug) and ColoredComboBox, resulting in a very slow memory leak.
Fixed, Linedefs Mode, cosmetic: incorrect distance was used when calculating vertex insert preview opacity.
Changed, Script Editor: disabled indentation guides.


R2283 | b0d68674 | MaxED | 10.09.2015, 19:38
--------------------------------------------------------------------------------
Fixed, "Synchronize selection between Visual and Classic modes" setting: vertex selection synchronization was not working when switching from Visual to Classic mode. Also fixed a typo in the setting's name.
Fixed, StairSectorBuilder mode: settings form still used "Cancel OK" button order.


R2282 | fe38d591 | MaxED | 08.09.2015, 16:54
--------------------------------------------------------------------------------
Added, Classic modes: default thing arguments are now taken into account when highlighting related map elements.
Probably fixed an exception when trying to check which program(s) lock the map file on Windows XP.
Changed: added an option to try to close all programs, which lock the map file when saving the map and the map file is locked (requires Windows Vista or newer).
Fixed, Preferences window: some trackbars had incorrect background color.
Fixed, General interface: in some cases status messages were almost immediately replaced by selection info messages.


R2281 | 6dc10032 | MaxED | 07.09.2015, 00:15
--------------------------------------------------------------------------------
Changed: when the editor is unable to save the map, it will now display the list of processes, which lock the map file.
Fixed, Update Checker: the existence of Updater.exe and Updater.ini was not checked when using Help -&gt; Check for updates command.


R2280 | 00884653 | MaxED | 04.09.2015, 14:44
--------------------------------------------------------------------------------
Added: Auto-updater window now has "Ignore this revision" checkbox. If enabled, the window will show up only if a newer update is available. 
Fixed, Edit Selection mode: sector highlight was not updated when switching from Edit Selection to Sectors mode.
Fixed, Edit Selection mode, UDMF: in some cases texture scale Y was flipped when applying/canceling changes made in the mode.
Probably fixed a crash caused by uninitialized Association when highlighting map elements.
Fixed, Comments Panel plugin: selection info was not updated when selecting map elements in the side panel.
Fixed, Tag Explorer plugin: selection info was not updated when selecting map elements in the side panel.
Fixed a typo in Hexen_things.cfg.


R2279 | df90ef56 | MaxED | 02.09.2015, 13:28
--------------------------------------------------------------------------------
Fixed, Thing info panel: fixed KeyNotFoundException when highlighted thing had unknown action.
Fixed: in some cases the number of generalized sector effects displayed in Sector info panel and action selector control was calculated incorrectly.


R2278 | dc29b59f | MaxED | 01.09.2015, 21:44
--------------------------------------------------------------------------------
Fixed, Visual mode: double-sided middle texture highlighting transparency check didn't take TEXTURES scaling into account.
Fixed, long texture names: textures located in a directory/pk3/pk7 root can't have long texture names.
Fixed, texture selector controls, long texture names: both long and short texture names should be added to texture name auto-completion list. 
Changed: "Grid Increase" and "Grid Decrease" actions can now be bound to mouse wheel.


R2277 | c407c8c3 | MaxED | 01.09.2015, 00:06
--------------------------------------------------------------------------------
Fixed, DB2 bug: side panel's tabs were drawn incorrectly when panel's height was lower than cumulative tabs height.
Visual mode, GLOOME: wall/floor/ceiling sprites are now rendered closer to the way it's done in GLOOME.
Sectors mode, UDMF: some cosmetic tweaks to comment icons rendering.
Classic modes: linedef rendering is now skipped when it's visible length is very short.
General interface: fixed a possible crash when clicking on the warnings count label when it was updated from the background thread.


R2276 | ee719bd9 | MaxED | 28.08.2015, 21:22
--------------------------------------------------------------------------------
Fixed, Visual mode: texture coordinate generated to test if double-sided middle texture is transparent was shifted 1 pixel up.
Fixed, Visual mode: offsets of GLDEFS lights were not affected by thing's angle.
Updated SharpCompress (0.10.3 -&gt; 0.11.1).
Updated ZDoom_DECORATE.cfg.


R2275 | 54bf4afd | MaxED | 28.08.2015, 15:36
--------------------------------------------------------------------------------
Fixed, text parsers: the parser could stuck in infinite loop when trying to skip an unclosed block comment.


R2274 | 03265d7d | MaxED | 28.08.2015, 00:55
--------------------------------------------------------------------------------
Replaced Dotnetrix.TrackBar with the built-in version. No change in functionality.
Removed Trackbar.dll.


R2273 | deb65258 | MaxED | 27.08.2015, 22:46
--------------------------------------------------------------------------------
Added, Visual mode, GLDEFS, GLOOME: subtractive glow is now supported.
Changed, Visual mode: changed thing fog calculation logic. Should be closer to GZDoom now.
Fixed, GLDEFS parser: "height" texture parameter was not treated as optional.
Fixed, text lump parsers: in some cases incorrect line number was displayed in error and warning messages.
Fixed, Visual mode: glow effect was not applied to sectors with 3 sidedefs.
Fixed, Visual mode: in some cases glow effect was not updated when replacing textures. 
Fixed, general interface: "Full Brightness" button state was not updated during map loading.
Fixed, Drag Linedefs/Vertices/Sectors/Things modes: positions of line length labels were not updated while panning the view.
Cosmetic: added a bunch of new icons.
Cosmetic: changed Visual mode crosshair.


R2272 | c7696b04 | MaxED | 26.08.2015, 00:05
--------------------------------------------------------------------------------
Fixed, Draw Lines/Rectangle/Circle/Curve modes: line length labels displayed incorrect length.
Changed, Drag Linedefs/Vertices/Sectors/Things modes: line length labels are now displayed the same way as in Draw modes.
Changed, Drag Linedefs/Vertices/Sectors/Things modes: "lock movement to cardinal directions" mode (Alt-Shift-Drag) now locks movement in 4 directions instead of 8 and doesn't snap map elements to nearest grid intersections when they are not aligned to it. 
Added, Visual mode, GZDoom, DECORATE: FORCEXYBILLBOARD flag is now supported.
Added, Visual mode, GLOOME, DECORATE: FLOORSPRITE, CEILSPRITE, WALLSPRITE, ROLLSPRITE and STICKTOPLANE flags are now supported (implementation is somewhat broken ATM and probably doesn't work the same way as in GLOOME, because Windows build with most these features is nowhere to be found...).
Fixed, Visual mode: in some cases Thing brightness was calculated incorrectly.
Updated ZDoom_DECORATE.cfg.


R2271 | b3b72e6b | MaxED | 24.08.2015, 23:58
--------------------------------------------------------------------------------
Some unrelated stuff slipped into previous commit...


R2270 | b37457db | MaxED | 24.08.2015, 23:49
--------------------------------------------------------------------------------
Changed, Draw Lines/Rectangle/Circle/Curve modes: line length labels are now repositioned to stay on screen when line's start or end is not visible.
Added, Map Analysis mode: added "Check map size" check. It will generate a warning when map's width or height is larger than 32767 m.u.


R2269 | c0fbf5e7 | MaxED | 24.08.2015, 01:32
--------------------------------------------------------------------------------
Fixed, MAPINFO parser: map/defaultmap/adddefaultmap sub-blocks were not skipped properly.
Changed, General interface: all main menu toolbars are now visible when starting the editor for the first time.
Changed, General interface: "Prefabs" and "Edit" menus are now hidden when no map is loaded.
Changed, General interface: moved "Dynamic Grid Size" menu item to the "Edit" menu, also moved the button to the matching position on the toolbar.
Changed, General interface: changed "Show Comments" menu item position in the "View" menu, also moved the button to the matching position on the toolbar.
Game configurations: removed "gamedetect" block, because it was unused by the editor.
Updated documentation ("Map Format Settings" page).


R2268 | 980fc2f4 | MaxED | 20.08.2015, 16:09
--------------------------------------------------------------------------------
Classic modes: added "Dynamic grid size" option (available in the View menu and on the main toolbar). When enabled, grid size will be automatically adjusted based on current zoom level.
Updated ZDoom ACC to rev. 19995bb.
Updated ZDoom_ACS.cfg and ZDoom_DECORATE.cfg.


R2267 | 415a3644 | MaxED | 17.08.2015, 01:42
--------------------------------------------------------------------------------
Changed, curved event lines, Visual mode: associated lines were not rendered as curved when the control object was not on screen [Xabis' patch #3].
Game configurations: removed "GZDoom only" from FraggleScript actions (because FraggleScript can be used in ZDoon).
Internal: fixed a couple of bugs in DebugConsole.StopTimer();


R2266 | 1b26fa35 | MaxED | 10.08.2015, 20:31
--------------------------------------------------------------------------------
Fixed, Things mode, curved event lines: in some cases IsCurved property was not applied to all InterpolationPoints in a path.


R2265 | 527d3cf5 | MaxED | 08.08.2015, 23:56
--------------------------------------------------------------------------------
Added, Things mode, Visual mode: event lines for InterpolationPoints are now curved when appropriate setting is enabled in the control thing (PathFollower/ActorMover/MovingCamera) [heavily inspired by Xabis' patch].
Added, Things mode: the editor will try to reconnect the path when deleting InterpolationPoints and PatrolPoints.
Internal: RenderArrows method now works the same way in Renderer2D and Renderer3D.
Internal: Line3D now has "renderarrowhead" property.


R2264 | a98eea64 | MaxED | 07.08.2015, 23:32
--------------------------------------------------------------------------------
Fixed, UDMF: the implementation of "moreids" property was different from UDMF standard. This issue affected only linedefs and sectors with more than 2 tags.


R2263 | 1d6cbb70 | MaxED | 07.08.2015, 00:16
--------------------------------------------------------------------------------
Previous Things mode highlight fix was a bit rushed...


R2262 | 18af297d | MaxED | 06.08.2015, 23:54
--------------------------------------------------------------------------------
Added, Things mode: target tags are now automatically assigned when duplicating (shift-dragging) PatrolPoints and InterpolationPoints.
Fixed, ThingsMode: fixed highlighted thing disappearing when using paste action while highlighting a thing.


R2261 | b9b5b002 | MaxED | 05.08.2015, 01:28
--------------------------------------------------------------------------------
Classic modes: added "Toggle Grid" action (default key is Alt-G), new menu item in the View menu and new toolbar button.
Changed, Things mode, cosmetic: tweaked thing sprite/bounding box appearance a bit more...
Fixed, Linedefs mode, cosmetic: fixed event lines and sector highlights flickering when view panning was started while displaying action highlight.


R2260 | ce7510c1 | MaxED | 04.08.2015, 00:02
--------------------------------------------------------------------------------
Preferences: removed "Square Things" setting. Square things are now the only option.
Changed, Things mode: things are now rendered with a bit of transparency, so things beneath other things are now visible.
Fixed, Things mode: in some cases it was impossible to highlight a thing beneath other thing when their positions were the same.
Changed, 2D modes: changed thing bounding box and arrow image.
Fixed, cosmetic, 2D modes: in some cases thing arrows were rendered bigger than thing bounding boxes.


R2259 | 39beaf2c | MaxED | 31.07.2015, 01:48
--------------------------------------------------------------------------------
Linedef Color Presets: completely redone Linedef Color Presets UI. Now it's done the same way as Things Filters UI.
Linedef Color Presets: Linedef Color Presets can now be disabled.
Things Filters window: a warning icon is now displayed near the filter name in the filters list when the filter has no usable settings.
Change Map in Current WAD window: keyboard focus was not set to initially selected item.
Changed the default wad filename from "unnamed.wad" to "[map name].wad".
Updated documentation ("Custom linedef colors" page).


R2258 | b3ab9234 | MaxED | 28.07.2015, 17:04
--------------------------------------------------------------------------------
UDMF: most of the code now supports multiple sector/linedef tags ('moreids' UDMF property). The only things left out are Tag Explorer and Tag Range plugins.


R2257 | b6be263a | MaxED | 28.07.2015, 00:14
--------------------------------------------------------------------------------
Fixed, Edit Selection mode: "High precision positioning" setting was set to false after using the mode in non-UDMF map format.


R2256 | 45e303b2 | MaxED | 27.07.2015, 23:35
--------------------------------------------------------------------------------
UDMF: implemented 'moreids' handling. Currently this includes the core stuff, new TagsPicker control in Edit Sector/Linedef windows and updated Sector/Linedef Info panels.


R2255 | 5cd998b1 | MaxED | 27.07.2015, 11:02
--------------------------------------------------------------------------------
Changed, Linedef/Thing Edit windows: when using ACS specials and choosing a script with arguments, appropriate action argument names are replaced with script argument names.
Changed, Linedef/Thing Info panel: when displaying a linedef/thing with an ACS special, which uses a script with arguments, appropriate action argument names are replaced with script argument names.
Changed, Sector/Linedef/Thing Edit windows, Comments tab: window is no longer closed when pressing Enter while editing a comment. Newline is inserted instead.
Changed: Script Editor window is now toggled to normal state when pressing "Show Script Editor" button if said window was already open, but minimized.
Fixed: in some cases action arguments were not cleared during setup when displaying multiple map elements with mixed argument values.
Internal: added ArgumentsControl.


R2254 | cff34897 | MaxED | 27.07.2015, 01:35
--------------------------------------------------------------------------------
Fixed, Classic modes, Visual mode, UDMF: the last argument of Sector_Set3dFloor (160) action must be ignored in UDMF.


R2253 | c6f9146b | MaxED | 27.07.2015, 01:18
--------------------------------------------------------------------------------
Fixed, DECORATE parser: enums were not handled properly.
General interface: selection info is now always displayed.
Visual mode: you can now hold Alt-Shift or Ctrl-Alt while selecting sidedefs to stop selecting connected sidedefs when already (un)selected sidedef is encountered.
Added, Numeric Textbox: you can now use "+++" and "---" prefixes to incrementally increase or decrease result values by given value.
Fixed, Numeric Textbox: fixed a potential divide by zero exception when using "/" prefix in numeric textboxes with decimal input enabled.
Fixed, Thing Info panel: relative z position of things with "+SPAWNCEILING" flag was incorrect.
Changed: Update checker now displays messages using MessageBoxes when called manually.
Map Analysis: changed result descriptions for Unknown Texture and Missing Texture checks.
Doom map format: renamed "Secret" linedef flag to "Shown as 1-sided on automap".
Updated ZDoom_DECORATE.cfg (A_RadiusGive stuff).


R2252 | 1118fd6b | MaxED | 15.07.2015, 11:09
--------------------------------------------------------------------------------
Changed: "Show Comments" option should also control whether comment tooltips are displayed.
Added some boilerplate to CommentsDocker.
Internal: converted a bunch of if-elses to switches.


R2251 | 0d4c2a8f | MaxED | 15.07.2015, 01:34
--------------------------------------------------------------------------------
UDMF: Added "Comment" tab to Edit Sector / Linedef / Thing forms.
Sectors, Linedefs, Things modes: comment icons for appropriate map elements with comments are now rendered in these modes. This can be disabled using either the new "Toggle Comments" action, "View -&gt; Show Comments" menu item, or "Show Comments" button on the main toolbar.


R2250 | 70ea180b | MaxED | 14.07.2015, 11:14
--------------------------------------------------------------------------------
Forgot to update MakeRelease.bat while adding the updater...


R2249 | 1424950d | MaxED | 14.07.2015, 11:02
--------------------------------------------------------------------------------
Things, Sectors, Liedefs mode, UDMF: map element comments are now shown when highlighting them.
Changed, Edit Text window: the form is no longer accepted when pressing the Enter key, so line breaks can now be added easily.
Versioning: GZDB version is now determined by the first 2 revision digits, so now it's GZDB 2.3, not 1.14.


R2248 | 643460ef | MaxED | 13.07.2015, 13:20
--------------------------------------------------------------------------------
Map Analysis mode: added "Check very short linedefs" check (unchecked by default), which finds linedefs shorter than 1 m.u.
Fixed: script editor must be closed during "Open map in current WAD" action.
Added: PNG offsets are now taken into account when loading sprites.


R2247 | 712dbd03 | MaxED | 10.07.2015, 00:32
--------------------------------------------------------------------------------
Cosmetic: renamed Drawing mode to Draw Lines mode.
Changed: current 2D position and zoom is now stored in the .dbs file when saving the map and restored when opening it (should this be turned into toggleable option?).
Draw Lines mode, Draw Curve mode: you can now hold Alt - Shift to snap to 8 cardinal directions.
Draw Rectangle mode, Draw Grid mode: you can now hold Alt - Shift to draw square shapes.
Draw Ellipse mode: you can now hold Alt - Shift to draw circle shapes.
You can now hold Alt - Shift to snap to 8 cardinal directions while dragging map objects.
Fixed, Draw Lines mode: line angle is now displayed in 0..359 range (was -45..314).
Fixed, Linedef info panel: line angle is now displayed in 0..359 range (was -45..314).


R2246 | 66eef441 | MaxED | 07.07.2015, 20:37
--------------------------------------------------------------------------------
Fixed, Texture Browser: in some cases the control was unable to select proper texture by short name when long texture names support was enabled.
Sound Environments mode: sound environments list is now sorted.


R2245 | 3924ae5a | MaxED | 06.07.2015, 09:50
--------------------------------------------------------------------------------
Fixed, Sound Environments mode: "Show nodes with warnings only" logic was broken...
Fixed, Sound Environments mode: fixed an exception when clicking on already selected child node in the sound environments list (I broke this in the previous commit).
Fixed, Sound Environments mode: the view now centers on selected sound environment when clicking on a sound environment in the list (I broke that when I've added proper sound environment names way back when).


R2244 | ef5bd3e5 | MaxED | 06.07.2015, 01:20
--------------------------------------------------------------------------------
Changed, Classic modes: model wireframe is now rendered using Highlight color when corresponding thing is highlighted (and Select color when it's selected).
Sound Environment mode: added "Show nodes with warnings only" checkbox to the panel.
Sound Environment mode: somewhat increased sound environment update speed by updating the list after all sound environments are updated.
Sound Environment mode: the list now scrolls to show highlighted sound environment.
Sound Environment mode: sound environments can now be (de)selected. Selecting a sound environment stops highlighting sound environments / scrolling the list when moving the mouse.


R2243 | 414a18ad | MaxED | 02.07.2015, 12:07
--------------------------------------------------------------------------------
Fixed, Randomize Things window: "Same width and height" scale setting was not applied properly.
Fixed incorrect formatting of changelog messages displayed in the updater window.
Changed, Classic modes: models for things hidden by thing filter are now rendered with much lower alpha than the "regular" ones.


R2242 | 12f53220 | MaxED | 02.07.2015, 01:09
--------------------------------------------------------------------------------
General: added update checking/updater launching logic and interface.
Updater.exe: fixed many bugs.
Tweaked MakeSVNRelease.bat to generate additional file, required by updater.


R2241 | 6072e59a | MaxED | 01.07.2015, 17:06
--------------------------------------------------------------------------------
Added auto-updater (Updater.exe), updated Inno Setup config file.
Preferences: added "Check for updates at startup" setting (no actual updater code yet...).
Cosmetic changes to several action names and descriptions.


R2240 | 2f77560b | MaxED | 30.06.2015, 20:34
--------------------------------------------------------------------------------
Fixed: selected items info was not updated when deleting a map element.
Changed, Sound Environments mode: previously selected sound environment is now automatically selected when inserting a new sound environment item. Also it's now impossible to accept the form without selecting a sound environment.
Changed, Sound Propagation mode: single-sided lines with sound zone boundary flag are now highlightable and clickable.


R2239 | 6732e314 | MaxED | 30.06.2015, 14:16
--------------------------------------------------------------------------------
Fixed, Wavefront .obj Export: long texture names were handled incorrectly causing exceptions during textures export.


R2238 | d5d37583 | MaxED | 29.06.2015, 10:15
--------------------------------------------------------------------------------
Fixed, Visual mode: model visibility filtering was checked incorrectly when using "Show models for current things filter only" model rendering mode.


R2237 | a4049f90 | MaxED | 27.06.2015, 20:55
--------------------------------------------------------------------------------
Things Filters window: added "Mode" setting, which allows to choose whether to apply current filter in Classic modes, Visual mode, or both.


R2236 | 8f2c6e3f | MaxED | 27.06.2015, 11:10
--------------------------------------------------------------------------------
Classic modes: added "Show models for current things filter only" model rendering mode.
Things Filters: things filters can now be inverted (added "Invert Filter" checkbox to the Things Filters window).


R2235 | 6eef13c2 | MaxED | 26.06.2015, 16:44
--------------------------------------------------------------------------------
Fixed: X and Y scale, defined in MODELDEF, were applied incorrectly.


R2234 | 6aedda77 | MaxED | 26.06.2015, 00:44
--------------------------------------------------------------------------------
Fixed, Linedefs mode, since r2346: some event lines were not redrawn when updating insert vertex preview.


R2233 | 7e8fc4c0 | MaxED | 25.06.2015, 20:32
--------------------------------------------------------------------------------
Draw Grid mode: redone the settings panel as a sidebar panel.


R2232 | 540eb2fd | MaxED | 24.06.2015, 23:21
--------------------------------------------------------------------------------
Classic modes: changed the way event lines are rendered. Should work much faster now. Event lines are now displayed while panning the view.


R2231 | 97d54d20 | MaxED | 24.06.2015, 09:46
--------------------------------------------------------------------------------
Fixed, DECORATE parser, DB2 bug: the parser didn't check stream length while skipping block comments, so unclosed ones caused EndOfStreamException.


R2230 | a523f7eb | MaxED | 22.06.2015, 21:52
--------------------------------------------------------------------------------
Changed, Visual mode: models and lights are much less prone to disappear when near the edges of the screen.
Fixed, Classic modes: MODELDEF model scale was not taken into account when calculating model visibility, which resulted in models with increased scaled disappearing when near screen edges.


R2229 | e451d389 | MaxED | 22.06.2015, 11:17
--------------------------------------------------------------------------------
Fixed, Visual mode, "Auto-align textures" actions: auto alignment was applied incorrectly to middle parts of doublesided lines.
Fixed, Visual mode, "Auto-align textures" actions: in some cases generated texture offsets were not rounded to map format decimal number precision.


R2228 | d5613711 | MaxED | 21.06.2015, 23:35
--------------------------------------------------------------------------------
MD3 reader: fixed a crash when trying to load a skin when skin names were used as a relative path in a model with several surfaces (and boy this description is much longer than the fix itself :) ).


R2227 | 463d8af4 | MaxED | 19.06.2015, 21:19
--------------------------------------------------------------------------------
Edit Selection mode, UDMF: added "High precision positioning" setting. When enabled, thing and vertex positions will be set using floating point precision. Otherwise, they will be rounded to the nearest integer.


R2226 | 3e707929 | MaxED | 18.06.2015, 21:45
--------------------------------------------------------------------------------
Changed, Internal: ZDTextParser.ReadToken() now returns empty string instead of null when it's unable to read a token. This fixes many potential crashes when trying to parse malformed data (and hopefully doesn't bring new bugs...).


R2225 | 4c3d17a2 | MaxED | 18.06.2015, 16:01
--------------------------------------------------------------------------------
Fixed, Edit Selection mode: floor/ceiling textures rotation was not converted from radians to degrees when "Transform Texture Rotation" setting was disabled.


R2224 | bb95af22 | MaxED | 15.06.2015, 15:16
--------------------------------------------------------------------------------
Fixed, Visual mode, since r2336: in some cases local vertical texture offset was calculated incorrectly when checking sidedef's texture alpha.


R2223 | 78eeb2ee | MaxED | 15.06.2015, 12:51
--------------------------------------------------------------------------------
Fixed, Visual mode, UDMF: in some cases texture offsets were changed incorrectly while dragging sidedefs with negative texture scale.


R2222 | c500edaf | MaxED | 15.06.2015, 11:50
--------------------------------------------------------------------------------
Changed, Visual mode: texture alpha is now tested when highlighting doublesided linedefs.
Changed, Linedef Edit window, Visual mode, UDMF: when "Edit windows remember selected tabs" setting is enabled and Front or Back tab was previously selected, the tab, which corresponds to the highlighted side will be selected.


R2221 | 35fd6e1d | MaxED | 14.06.2015, 21:29
--------------------------------------------------------------------------------
Fixed, Thig Edit Form, UDMF: Scale x/y linking status was not stored when closing the form.
Fixed, Engine Launcher: "%AP" test parameters placeholder was replaced with "" when current map was newly created and never saved.


R2220 | 487e1478 | MaxED | 08.06.2015, 16:37
--------------------------------------------------------------------------------
Fixed, DECORATE: quoted //$category definitions were processed differently than unquoted ones.
Fixed, Thing Categories: in some cases several subcategories with the same name were created.


R2219 | 9498753c | MaxED | 08.06.2015, 12:09
--------------------------------------------------------------------------------
Visual mode: highlight was nearly invisible in low-brightness areas when fog rendering was enabled.


R2218 | 2945c258 | MaxED | 08.06.2015, 11:48
--------------------------------------------------------------------------------
Visual mode: looks like things lit by dynamic lights are not affected by light fading in GZDoom.


R2217 | 4034bd4c | MaxED | 03.06.2015, 15:20
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases info lines for polyobject setup things were not shown.
Fixed, Visual mode: z position of info lines for polyobject setup things was calculated incorrectly.
Updated ZDoom_DECORATE.cfg.


R2216 | 922404bf | MaxED | 02.06.2015, 00:10
--------------------------------------------------------------------------------
We can use settings from parent when creating a child thing category.


R2215 | 5a7b599a | MaxED | 01.06.2015, 23:46
--------------------------------------------------------------------------------
Added: nested thing categories can now be defined in DECORATE using "//$Category" special comment. Syntax is the same as in SLADE 3.
Added: thing categories defined in Game Configurations can now be nested.
Changed, Thing Edit window: thing categories now use different icons.
Fixed: Thing Edit and Vertex edit windows had incorrect help links.
Fixed: Sound Propagation and Sound Environment modes had incorrect help links.
Documentation: updated "DECORATE keys" and "Things Settings" pages.


R2214 | efd9ba09 | MaxED | 01.06.2015, 12:59
--------------------------------------------------------------------------------
DECORATE: added "//$Angled" and "//$NotAngled" special comments (same usage as in SLADE).
Documentation: updated "DECORATE keys" page.


R2213 | a7ba8055 | MaxED | 01.06.2015, 11:53
--------------------------------------------------------------------------------
Added, Edit Selection mode, UDMF: textures offset, rotation and scale an now be updated while using the mode.
Documentation: updated "DECORATE keys" page.


R2212 | 1843ffc5 | MaxED | 31.05.2015, 23:11
--------------------------------------------------------------------------------
DECORATE: added "//$ArgNDefault" special comment. It can be used to specify the default argument value.
Visual mode, 3d floors: sloped 3d floors are now always rendered as opaque (just like in GZDoom).
Fixed a crash when creating a new unknown thing (introduced in r2324).
Documentation: updated "Action Argument Settings" and "DECORATE keys" pages.


R2211 | f832fb85 | MaxED | 30.05.2015, 14:42
--------------------------------------------------------------------------------
DECORATE: added "//$ArgNType" special comment. It can be used to specify argument type.
DECORATE: added "//$ArgNEnum" special comment. It can be used to specify an enum to use with the argument.
Documentation: updated "Action Argument Settings" and "DECORATE keys" pages.


R2210 | 35cd4068 | MaxED | 30.05.2015, 12:26
--------------------------------------------------------------------------------
Game Configurations: added "Thing Radius" (23) and "Thing Height" (24) action argument types. When non-zero, arguments of these types will affect the size of associated thing in Classic and Visual modes.
Game Configurations: updated things in ZDoom "Bridges" category to use argument types 23 and 24.
Documentation: added "Action Argument Settings" page, updated "Basic Settings", "Map Format Settings", "Linedefs Settings" and "Things Settings" pages in Configurations -&gt; Game Configurations group.
Documentation: updated "DECORATE keys" page.


R2209 | 84059749 | MaxED | 29.05.2015, 21:31
--------------------------------------------------------------------------------
Fixed: looks like manually disposing the brush in ColoredComboBox.OnDrawItem() can cause crashes...
Replaced Hourglass3D.png with the one, which matches the style of MissingTexture3D.png and UnknownTexture3D.png.


R2208 | 4f65588d | MaxED | 28.05.2015, 23:27
--------------------------------------------------------------------------------
Changed, ButtonsNumericTextbox: turns out this problem can be solved without manual focus shifting.


R2207 | 93c23910 | MaxED | 28.05.2015, 17:00
--------------------------------------------------------------------------------
Changed, ButtonsNumericTextbox: made keyboard focus shifting a bit less intrusive.


R2206 | 91e1fbbd | MaxED | 28.05.2015, 15:45
--------------------------------------------------------------------------------
Internal: added SNDSEQ parser.
Sector Edit Form, UDMF: Sound Sequence selector is now a drop-down populated by values parsed from SNDSEQ.
Documentation: updated "(G)ZDoom text lumps support" page.
Updated udmf_zdoom.txt.


R2205 | 118551c7 | MaxED | 28.05.2015, 12:04
--------------------------------------------------------------------------------
Fixed(?), PK3: SharpCompress doesn't like it when several threads try to read PK3 archive entries at the same time.
Fixed, Visual mode, 3d floors: floor and ceiling alpha calculation was broken.


R2204 | eb17a8fe | MaxED | 27.05.2015, 23:55
--------------------------------------------------------------------------------
Fixed several places where KeyNotFoundException can potentially occur in ThingFlagsCompare.Compare().


R2203 | bb8cd761 | MaxED | 27.05.2015, 17:25
--------------------------------------------------------------------------------
Internal: fixed a typo in VisualMiddle3D.
Updated ZDoom_ACS.cfg and ZDoom_DECORATE.cfg.


R2202 | 1b9f94f3 | MaxED | 27.05.2015, 14:38
--------------------------------------------------------------------------------
More code sanity changes (constructors of abstract classes should not be public or internal).


R2201 | 1d988b08 | MaxED | 27.05.2015, 13:05
--------------------------------------------------------------------------------
Fixed, Visual Mode: voxel models were not rendered in full brightness mode.


R2200 | cfae82af | MaxED | 27.05.2015, 12:34
--------------------------------------------------------------------------------
Added some disposers here and there.


R2199 | 28f30648 | MaxED | 26.05.2015, 23:08
--------------------------------------------------------------------------------
Fixed, Game Configurations window: current configuration was not marked as changed when changing nodebuilders or engine test parameters.
Fixed, Game Configurations window: current map is marked as changed when applying changes done in the window.
Changed, UDMF saving: removed extra line break between map elements.


R2198 | d71b5814 | MaxED | 26.05.2015, 22:10
--------------------------------------------------------------------------------
Fixed, "Flip Linedefs" action: in some cases my sector based flipping logic was behaving incorrectly.


R2197 | 42dbec72 | MaxED | 26.05.2015, 00:55
--------------------------------------------------------------------------------
Fixed: we don't need to reload ResourceImages, because they can't be unloaded and reloading them can cause problems when trying to display them in PictureBoxes.
Removed Sector Brightness Mode keyboard binding from the default program configuration file.


R2196 | 8257c686 | MaxED | 23.05.2015, 23:40
--------------------------------------------------------------------------------
Added, MAPINFO parser: we can also get "skyflatname" gameinfo property while we at it.


R2195 | e381ba92 | MaxED | 23.05.2015, 23:01
--------------------------------------------------------------------------------
Added: thing and linedef action arguments can now have tooltips defined in both Game Configuration (using "tooltip" action argument definition property) and DECORATE (using "$argNtooltip" special comment).
Removed "Sectors Brightness Mode" action, because the mode itself was removed long ago...
Documentation: updated "DECORATE keys", "Things Settings" and "Linedefs Settings" pages.


R2194 | 2fe402b1 | MaxED | 18.05.2015, 20:49
--------------------------------------------------------------------------------
Fixed, MAPINFO parser: properties, written like '667=CuteCaco' were not parsed, while '667 = CuteCaco' worked fine.
Changed, Classic modes: increased maximum zoom level to 9000% (was 3000%).
Added, General interface: added "800%" zoom level to the bottom toolbar zoom menu.
Added, General interface: added "400%" and "800%" zoom levels to "View -&gt; Zoom" menu.


R2193 | 981a4f88 | MaxED | 13.05.2015, 01:13
--------------------------------------------------------------------------------
Fixed, ZDoom_things.cfg: most of Bridge actors had incorrect size/missing settings.


R2192 | 930e8f54 | MaxED | 11.05.2015, 22:17
--------------------------------------------------------------------------------
Sectors mode, "Raise/Lower Sector Brightness" actions: we should display the actual increment instead of "8".
UDMF: changed the name of "midtex3dimpassible" flag.
Updated ZDoom_DECORATE.cfg.


R2191 | aa7bfd77 | MaxED | 04.05.2015, 09:19
--------------------------------------------------------------------------------
Applied SoundPropagationMode patch by Boris.


R2190 | f30c1ba0 | MaxED | 29.04.2015, 10:36
--------------------------------------------------------------------------------
Fixed, MAPINFO parser: the parser was unable to handle DoomEdNum block's action special definitions.
Fixed, DoomEdNum handling: in some cases ThingTypeInfo was not assigned a proper DoomEdNum and was not placed in a ThingCategory.


R2189 | 60c4ad7b | MaxED | 28.04.2015, 16:22
--------------------------------------------------------------------------------
Fixed, .obj Terrain Importer mode: the mode was not canceled properly after failing to import a model.
Fixed, .obj Terrain Importer mode: the mode was unable to parse .obj vertex/face definitions generated by some (Cinema4D) modeling programs.
Changed, .obj Terrain Importer mode: vertical (e.g. perpendicular to up axis) polygons are now skipped during model importing.
Changed, Ceiling Align mode, Floor Align mode: changed rotation steps form 45 to 15 deg.


R2188 | c2b3e926 | MaxED | 28.04.2015, 10:31
--------------------------------------------------------------------------------
Fixed, ACS script names parser: we should skip inner scopes of scripts and functions.
Updated ZDoom_DECORATE.cfg.


R2187 | 806a71fe | MaxED | 27.04.2015, 16:56
--------------------------------------------------------------------------------
Game configurations, Strife: added sprites and proper heights to all strife things.
Game configurations, Strife, Doom map format: several thing flags were named incorrectly.
Game configurations, Strife, Doom map format: several linedef flags were listed as "Unknown".
Edit Selection mode: 15-degree rotation steps require more precision...


R2186 | 7de6dcc7 | MaxED | 17.04.2015, 15:46
--------------------------------------------------------------------------------
Fixed, Map Analysis mode, Check Stuck Things: in some cases the check returned false-negative results.


R2185 | 2dff39b8 | MaxED | 16.04.2015, 15:03
--------------------------------------------------------------------------------
Changed, Visual mode, Auto-align textures actions, UDMF: aligned texture coordinates are no longer rounded to integer values.
Changed, Things, Sectors, Linedefs, Vertices modes: we shouldn't select highlighted map element during the copy action when no map elements are selected.
Internal: removed some debug stuff from CheckTextureAlignment and ResultTexturesMisaligned.


R2184 | 210c04ce | MaxED | 15.04.2015, 17:01
--------------------------------------------------------------------------------
Edit Selection mode: changed selection rotation steps form 45 to 15 deg.
Edit Selection mode, UDMF: sector slope offsets are now updated to keep them at the same position when moving or rotating sectors.


R2183 | 84b2fee8 | MaxED | 15.04.2015, 14:49
--------------------------------------------------------------------------------
Changed, Thing Edit Form: floor slopes are now taken into account when changing thing's absolute Z position (currently, only slopes, created using sector planes, vertex height offsets and "Plane_Align" (181) action are supported).
Changed, Thing Info panel: floor slopes are now taken into account when showing thing's Z position (same plane type limitations as above).
Changed, Thing Info panel: thing position is now shown as "X, Y, Z (abs. Z)".


R2182 | 9c959d21 | MaxED | 15.04.2015, 09:41
--------------------------------------------------------------------------------
Edit forms: added Preferences -&gt; Interface -&gt; "Edit windows remember selected tabs" option.


R2181 | aa998c8f | MaxED | 14.04.2015, 21:43
--------------------------------------------------------------------------------
Drag Geometry mode, UDMF: sector slope offsets are now updated to keep them at the same height when moving sectors.


R2180 | 76559ae8 | MaxED | 14.04.2015, 13:33
--------------------------------------------------------------------------------
Added GZDoom's glowing flats (http://www.zdoom.org/wiki/GLDEFS#Glowing_flats) support to Classic and Visual modes.
MAPINFO: added "DoomEdNum" and "SpawnNums" blocks support.
MAPINFO: added "#include" directive support.
MAPINFO: added "$gzdb_skip" special comment support.
DECORATE: "spawnthing" Game Configuration block is now updated using "SpawnID" actor property.
Game configurations: added "class" property to the most of ZDoom things.
Actions: removed "Reload MAPINFO" action.
Documentation: merged "GLDEFS and MODELDEF support", "(Z)MAPINFO support" and "TEXTURES support" topics into "(G)ZDoom text lumps support", added info about the other text lumps GZDB can use.


R2179 | 56f9ad84 | MaxED | 13.04.2015, 12:37
--------------------------------------------------------------------------------
More fixes for MODELDEF fixes from previous commit...
Updated InnoSetup config file.


R2178 | 6565dd93 | MaxED | 13.04.2015, 11:50
--------------------------------------------------------------------------------
MODELDEF parser: a model should be skipped when it's FrameIndex is -1.


R2177 | 45dca2be | MaxED | 13.04.2015, 00:29
--------------------------------------------------------------------------------
Fixed, Thing, Linedef, Sector info panels: flags panel resize logic was a bit incorrect...


R2176 | ddd05795 | MaxED | 12.04.2015, 23:05
--------------------------------------------------------------------------------
Changed, Thing, Linedef, Sector info panels: flags are now shown in the same order as in corresponding Edit forms.
Changed, Linedef info panel: activation flags are now displayed before "regular" flags and using different color.
Added, Linedef info panel: sidedef flags are now displayed.


R2175 | c7d61c22 | MaxED | 10.04.2015, 23:48
--------------------------------------------------------------------------------
Fixed, internal: in some cases it was possible to get incorrect resource when using Plug.GetResourceStream().


R2174 | 70416cd9 | MaxED | 06.04.2015, 21:33
--------------------------------------------------------------------------------
Fixed, Sectors/Linedefs/Vertices modes: 3D floor color indicators should be updated after deleting a map element.
Documentation: added "List of deprecated plugins" topic, slightly changed topics layout.


R2173 | 4aa31a67 | MaxED | 05.04.2015, 23:39
--------------------------------------------------------------------------------
Fixed, Open Map Options window: when everything else fails, we should also check game configurations without resources.
Documentation: fixed a couple of typos.


R2172 | 07525e5e | MaxED | 05.04.2015, 00:36
--------------------------------------------------------------------------------
Game configurations: "Make Door" action's close delay argument had incorrect value (3 -&gt; 34).
Game configurations, Hexen things: added "Spawn Fly" (112) actor definition.


R2171 | 43ff16ca | MaxED | 05.04.2015, 00:11
--------------------------------------------------------------------------------
Linedefs mode, Help panel: replaced info about "Flip Sidedef" action with info about "Flip Linedef" action.
Find and Replace Mode: renamed "Linedef Actions" search mode to "Linedef Action and Arguments".
Find and Replace Mode: renamed "Thing Action" search mode to "Thing Action and Arguments".
Cosmetic layout changes in Find and Replace window.
Updated documentation.

Changes in "Linedef Action and Arguments" and "Thing Action and Arguments" search modes:
Changed arguments search syntax from "action;arg0,arg1,arg2,arg3,arg4" to "action arg0 arg1 arg2 arg3 arg4"
You can now find ACS script actions with named scripts using "action arg0str ..." syntax.
You can now replace arguments using the same syntax as in the "Find what" field.


R2170 | 5668cfec | MaxED | 03.04.2015, 14:05
--------------------------------------------------------------------------------
Fixed, portable mode: fixed a possible crash when trying to check write permissions for GZDB folder.
Fixed, Texture Browser, High-DPI: bottom panel of ImageSelectorControl had incorrect height when using DPI scaling.
Changed, SplitterControl, High-DPI: DPI scaling is now used when drawing expand/collapse area.
Documentation: fixed typos, filled "Compiling GZDoom Builder" page.


R2169 | 5147d0b8 | MaxED | 02.04.2015, 12:57
--------------------------------------------------------------------------------
Added "-portable" command line parameter. With this parameter, the editor will use the "GZBuilder.cfg" located in the program directory to load and save program settings. Log and crash report files will be also created in the program directory.
Renamed the default program configuration file from "GZBuilder.cfg" to "GZBuilder.default.cfg".
Changed the default keys of "Move Thing Left\Right\Forward\Back" actions to arrow keys (was Ctrl + arrow keys).
Updated documentation: added "Command Line Parameters" topic.


R2168 | 5fe89efc | MaxED | 01.04.2015, 14:51
--------------------------------------------------------------------------------
Visual mode: added support for "Transfer Brightness Level" (50) effect type parameter (arg 1).
Visual mode: added support for "Transfer Floor Brightness" (210) effect.
Visual mode: added support for "Transfer Ceiling Brightness" (211) effect.
Visual mode: changed the way thing brightness is calculated. Should be closer to GZDoom now.
Sector Edit Form: you can now enter "++" or "--" into "Height Offset" input to raise or lower sectors by their height.
Cosmetic fix in ZDoom_linedefs.cfg.


R2167 | c742684b | MaxED | 31.03.2015, 20:39
--------------------------------------------------------------------------------
Fixed documentation typos reported by Overwatch-C-17.
A couple of cosmetic fixes in ZDoom_linedefs.cfg.


R2166 | a58f3522 | MaxED | 30.03.2015, 23:44
--------------------------------------------------------------------------------
Added, Visual mode, UDMF: added "Change Pitch Clockwise", "Change Pitch Counterclockwise", "Change Roll Clockwise" and "Change Roll Counterclockwise" actions.
Added, Visual mode, UDMF: added "Increase Scale" and "Decrease Scale" actions.
Added, Visual mode, UDMF: "Reset Texture Offsets" action now resets scale when used on things.
Added, Visual mode, UDMF: "Reset Local Texture Offsets" action now resets scale, pitch and roll when used on things.
Changed, Visual mode, UDMF: "Reset Texture Offsets" action now only resets texture offsets (previously it also reset texture scale).
Changed, Visual mode, UDMF: "Reset Local Texture Offsets" action now resets texture offsets, scale and brightness of sidedefs and also rotation of floors/ceilings.
Changed, Visual mode, UDMF: thing box arrow now displays pitch and roll for things, which have attached model and appropriate MODELDEF flags.
Changed, Thing Edit Form, UDMF: negative pitch and roll can now be entered.
Updated documentation.


R2165 | 791914a5 | MaxED | 30.03.2015, 16:29
--------------------------------------------------------------------------------
Game configurations: added "locksprite" thing property.
Updated documentation.


R2164 | c5a4c198 | MaxED | 30.03.2015, 13:22
--------------------------------------------------------------------------------
High-DPI: main menu and toolbar icons are now scaled to match current DPI settings.
High-DPI: the width of status labels is now scaled to match current DPI settings.
Updated documentation.


R2163 | fd528103 | MaxED | 27.03.2015, 14:18
--------------------------------------------------------------------------------
Fixed, Visual mode: hitbox height of vertex handles was 2x higher than it's supposed to be.


R2162 | 07ef6631 | MaxED | 27.03.2015, 12:43
--------------------------------------------------------------------------------
Fixed, Linedefs mode, "Make Gradient Brightness" action, UDMF: "lightfog" sidedef flag should be updated when applying the action.


R2161 | 487c0f8d | MaxED | 27.03.2015, 10:51
--------------------------------------------------------------------------------
Changed, Linedef Edit form, non-UDMF: reduced window height (on Windows 7 it's 667 -&gt; 639 pixels in Doom map format, 736 -&gt; 698 pixels in Hexen map format).
Added inner highlight on mouse over to ImageSelectorControl.


R2160 | 8af08418 | MaxED | 26.03.2015, 22:31
--------------------------------------------------------------------------------
Fixed, Models, Classic and Visual mode: MODELDEF scale and rotation transforms were applied in incorrect order.
Changed, Visual mode: things with "NOINTERACTION" DECORATE flag can now be rendered above ceiling / below floor.


R2159 | 0359974e | MaxED | 26.03.2015, 12:30
--------------------------------------------------------------------------------
Fixed, Models, Classic and Visual mode: UDMF scale and rotation transforms were applied in incorrect order.
Fixed, Cosmetic, Script Editor: fixed a typo.
Internal, ImageBrowserControl: removed now unused KeyDown event.
Updated documentation.


R2158 | 1bd8c5ce | MaxED | 25.03.2015, 23:13
--------------------------------------------------------------------------------
Fixed, Texture Browser: restored Tab key functionality yet again...
Changed, Numeric Textbox: we should not change focus when "usemodifierkeys" is false.


R2157 | 25b68aa7 | MaxED | 25.03.2015, 22:17
--------------------------------------------------------------------------------
Fixed(?), Texture Browser: possibly fixed Texture Browser not showing up / locking edit forms when current map has a ton of textures (like 2000 or more) in a single texture group.
Internal: replaced CollapsibleSplitter with CollapsibleSplitContainer.


R2156 | 123170a8 | MaxED | 24.03.2015, 15:21
--------------------------------------------------------------------------------
Fixed, Game Configurations window: fixed a crash when manually entering test engine name then choosing it's location.


R2155 | 1b1546ae | MaxED | 23.03.2015, 23:39
--------------------------------------------------------------------------------
Fixed(?), Texture Browser: possibly fixed Texture Browser not showing up / locking edit forms when current map has a ton of textures (like 2000 or more) in a single texture group.
Changed, cosmetic, Sector Info panel, Visual mode: info about currently highlighted surface is now shown using different color.
Changed, cosmetic, Linedef Info panel, Visual mode, non-UDMF: texture offset labels for currently highlighted sidedef are now shown using different color.
Changed, cosmetic, Vertex Info panel, UDMF: floor and ceiling offset labels are now grayed out when they have default values.


R2154 | fcac2d12 | MaxED | 23.03.2015, 21:16
--------------------------------------------------------------------------------
Fixed, Thing/Linedef/Sector info panels: "Flags" group width was calculated incorrectly when showing the control for the first time.


R2153 | 5152a2d6 | MaxED | 23.03.2015, 19:34
--------------------------------------------------------------------------------
Fixed, "Make Door" action: highlighted sector should be used as an action target only when there are no sectors selected.
Fixed, "Make Door" action: used textures were not updated after performing the action.


R2152 | 4f5c2064 | MaxED | 23.03.2015, 15:21
--------------------------------------------------------------------------------
Looks like I've missed some stuff in the previous commit...


R2151 | dd568976 | MaxED | 23.03.2015, 15:19
--------------------------------------------------------------------------------
Changed, Numeric textboxes: you can now hold Ctrl or Shift keys while clicking a textbox buttons or using mouse wheel on a textbox to change value increment step.
Changed, Numeric textboxes: trailing zeros are no longer displayed to reduce visual noise.
Fixed, paired numeric controls: in some cases culture-specific decimal separator was not used.
Fixed, map loading: inability to initialize D3D device is now handled a bit more gracefully.
Fixed, main toolbar context menu: we should suppress context menu closing only when user clicks on a menu item while holding Shift key.
Fixed, Game configurations: several Skulltag things were not included in many Zandronum game configurations.


R2150 | 46509b54 | MaxED | 22.03.2015, 21:43
--------------------------------------------------------------------------------
Added, Texture Browser: wad resources now have subgroups.
Fixed, Texture Browser: we should not skip items with the same texture name when they belong to different imagegroups.


R2149 | d0f82170 | MaxED | 21.03.2015, 21:08
--------------------------------------------------------------------------------
Changed, Textures Browser: "[TEXTURES]" sub-entry should be shown for wads too.


R2148 | d72e642d | MaxED | 21.03.2015, 20:41
--------------------------------------------------------------------------------
Fixed, Script Editor, Script names parser, DECORATE actor names parser: in some cases (for example, when entering utter garbage instead of proper acs), parsers could get stuck in an infinite loop...
Updated ZDoom_ACS.cfg.


R2147 | 8cf084fc | MaxED | 18.03.2015, 19:49
--------------------------------------------------------------------------------
Fixed, Open Map Option window: a warning message is now displayed when the editor fails to find any maps in the wad being open.
Fixed, Open Map Option window: fixed a crash when switching to a map configuration with long texture names support enabled when the wad being open has no maps (this will probably never happen because of previous change, but let's be on the safe side...).


R2146 | 8643d2dd | MaxED | 17.03.2015, 15:54
--------------------------------------------------------------------------------
Added, Internal, Sidedef: LowRequired() and HighRequired() checks now take UDMF slopes into account.
Updated ZDoom ACC.
Updated ZDoom_ACS.cfg.
Updated ZDoom_DECORATE.cfg.


R2145 | fa4dd4e3 | MaxED | 17.03.2015, 13:28
--------------------------------------------------------------------------------
Added, Thing Edit form: thing class is now displayed.
Added, Game configurations: added "thingclasshelp" property. It's used to open a website when thing class name is clicked in the Thing Edit form.
Changed, "Raise/Lower sector to nearest" action: 3d floors are now taken into account when using the action on things.
Updated documentation.


R2144 | 2d02e9b5 | MaxED | 16.03.2015, 09:54
--------------------------------------------------------------------------------
Changed, Texture Browser: "Used Textures" group is now collapsible.


R2143 | 81522c32 | MaxED | 13.03.2015, 13:39
--------------------------------------------------------------------------------
All Texture Browser controls should have TabStop disabled to make Tab key work as intended...


R2142 | c40d0549 | MaxED | 13.03.2015, 12:06
--------------------------------------------------------------------------------
Changed, Texture Browser: texture groups list can now be collapsed.
Fixed, Texture Browser: restored Tab key functionality yet again (I broke this in r2248...).
Added a bit of boilerplate to some of Tag Explorer's settings.
Internal: added CollapsibleSplitter control.


R2141 | d5ed2df4 | MaxED | 11.03.2015, 13:01
--------------------------------------------------------------------------------
Updated build bath files.


R2140 | 369e39db | MaxED | 11.03.2015, 12:38
--------------------------------------------------------------------------------
Added: Tag Explorer now has polyobjects display mode.
Changed, Tag Explorer: several wildcards can now be used at once. For example, entering "#12 $9" will show only map elements with tag 12 and action 9.
Changed, Tag Explorer: you can now filter list by polyobject number by entering "^NN" in the Filter field.
Changed, cosmetic: reduced map resizing caused by UI resizing during map loading.


R2139 | 4bac3eb9 | MaxED | 10.03.2015, 23:35
--------------------------------------------------------------------------------
Updated ZDoom_ACS.cfg.
+ a couple of cosmetic changes.


R2138 | 0e23e64a | MaxED | 10.03.2015, 20:03
--------------------------------------------------------------------------------
Added Stair Sector Builder plugin by Boris Iwanski.
Removed a bunch of unused build configurations from Builder.sln.


R2137 | bb68e1fe | MaxED | 10.03.2015, 19:49
--------------------------------------------------------------------------------
Fixed, Fit Textures action: fixed a crash when trying to use the action on a 3d floor side.
Added, Fit Textures action: the action now takes 3d floor's control side texture offsets into account when used on 3d floor sides.
Updated ZDoom ACC.


R2136 | 141a4bda | MaxED | 09.03.2015, 13:56
--------------------------------------------------------------------------------
Fixed, DB2 bug, Dockers Control: in many cases previously selected tab was not reselected after removing current tab when "Collapse Dockers" setting was enabled.


R2135 | 1ff2a2cb | MaxED | 09.03.2015, 10:17
--------------------------------------------------------------------------------
Fixed, Dockers Control: fixed incorrect control width when showing control for the first time with "Collapse Dockers" setting enabled. 
Internal: MapSet.ConvertSelection no longer selects sectors with no sidedefs when converting selection to sectors (unless those sectors were already selected).


R2134 | 08e55996 | MaxED | 07.03.2015, 22:38
--------------------------------------------------------------------------------
Fixed, Texture Browser form: "All" texture set was always selected when opening the form after closing it with this set selected.
Changed, Texture Browser form: texture groups list can now be resized.
Changed, Texture Browser form: selected group in texture groups list is now highlighted using highlight color even when not focused.
Changed, Linedef Info panel cosmetic: changed vertical position of texture name labels to match with the ones in the Sector Info panel.


R2133 | 1d06e577 | MaxED | 06.03.2015, 20:12
--------------------------------------------------------------------------------
Preferences -&gt; Interface: added "Select texture group when opening image browsers" option. When enabled, the group current texture belongs to will be selected when opening image browsers (DB2 behavior). When disabled, "All" texture group will be selected.
Event lines: added event lines for polyobject anchor -&gt; polyobject start spot pairs.
Fixed, Things mode: event lines were not drawn after finishing panning.


R2132 | 0993c189 | MaxED | 06.03.2015, 00:19
--------------------------------------------------------------------------------
Changed, cosmetic: info panel, sidebar and most of the main toolbar buttons are now shown only when a map is loaded.
Fixed, cosmetic: fixed disappearing toolbars separators.


R2131 | c3ba3740 | MaxED | 05.03.2015, 09:51
--------------------------------------------------------------------------------
DECORATE parser: added "//$GZDB_SKIP" special comment. Parsing of the file is stopped after this comment is encountered.
Updated documentation.


R2130 | 7dc4aefd | MaxED | 04.03.2015, 21:05
--------------------------------------------------------------------------------
GLDEFS parser: added "//$GZDB_SKIP" special comment. Parsing of the file is stopped after this comment is encountered.
Updated ZDoom_DECORATE.cfg.


R2129 | 518d3db5 | MaxED | 04.03.2015, 10:37
--------------------------------------------------------------------------------
TEXTURES parser: "optional" texture definition keyword was not supported.
TEXTURES parser: part of a TEXTURES filename is now used as a path in Image Browser. For example, textures from "textures.stuff" will be located in "[TEXTURES]/stuff" in the Image Browser.
TEXTURES parser: added "//$GZDB_SKIP" special comment. Parsing of the file is stopped after this comment is encountered.
Updated documentation.


R2128 | 8357a96a | MaxED | 03.03.2015, 19:32
--------------------------------------------------------------------------------
Fixed, Visual mode: internal texture name was copied when using "Copy Texture" action on a missing texture (why would you need to copy a missing texture?..).


R2127 | 52ab9171 | MaxED | 03.03.2015, 10:42
--------------------------------------------------------------------------------
Visual Mode, UDMF: Change texture scale actions now try to change scale by one texture/sprite pixel at a time. Action info now also shows scaled texture/sprite size.
Info panels: float values are now formatted regardless of current CultureInfo (e.g. decimal separator is now always dot). Also, they are no longer clamped to 2 decimal places.
Updated ZDoom_ACS.cfg.


R2126 | f60dc25d | MaxED | 27.02.2015, 15:32
--------------------------------------------------------------------------------
Edit forms: tag lists are now sorted in descending order.


R2125 | bdadc363 | MaxED | 27.02.2015, 11:55
--------------------------------------------------------------------------------
Added, Thing Edit Form (UDMF): added random angle/pitch/roll checkboxes.
Changed, Thing Edit Form (UDMF): rearranged Action and Identification groups to match the rest of the Edit forms. 
Changed: Classic Thing Edit form no longer has tabs.


R2124 | 02b902e2 | MaxED | 26.02.2015, 15:42
--------------------------------------------------------------------------------
Fixed, Visual mode: ExtraFloor_LightOnly effect transferred brightness incorrectly (I broke this in r2236).
Changed, Visual mode: floors and ceilings with sky texture are now always rendered at full brightness.


R2123 | 7c8c36a0 | MaxED | 26.02.2015, 09:49
--------------------------------------------------------------------------------
Thing Info panel: thing class is now displayed.


R2122 | 5f37b315 | MaxED | 25.02.2015, 20:59
--------------------------------------------------------------------------------
Visual mode: Sector_Set3dFloor and ExtraFloor_LightOnly effects now affect sidedef brightness more similarly to GZDoom.
Visual mode, Linedef info panel: info for currently highlighted side is now shown using a different color.
Updated ZDoom_ACS.cfg.


R2121 | e84f7d1f | MaxED | 24.02.2015, 21:25
--------------------------------------------------------------------------------
Linedefs Mode, UDMF: rewritten "Make Gradient Brightness" action. Fixed some logic errors, added interpolation modes support.


R2120 | c07df8f5 | MaxED | 24.02.2015, 14:38
--------------------------------------------------------------------------------
Changed, Thing and Linedef Edit Forms, script selector drop-downs: scripts from include files are now shown using different color and after the map scripts.
Fixed, Visual mode, UDMF: sector geometry cache was not updated after using "Match Brightness" and "Change Brightness" actions on ceilings, so the changes made by them were not visible when using Classic modes in "View Ceiling Textures" mode.
Fixed, Visual mode, UDMF: "Match Brightness" and "Change Brightness" actions set brightness incorrectly in some cases.
Fixed: ACS script names gathering logic was unable to process relative #include and #import paths (like '#import "..\acs\qtilt.acs"').
Updated ZDoom_DECORATE.cfg.


R2119 | 386b74d2 | MaxED | 24.02.2015, 08:51
--------------------------------------------------------------------------------
Fixed a couple of incorrect argument types in ZDoom_linedefs.cfg.
Fixed apply/cancel buttons positions in Randomize Sectors/Things/Vertices windows.


R2118 | 00df72ef | MaxED | 22.02.2015, 22:07
--------------------------------------------------------------------------------
Updated ZDoom_ACS.cfg and ZDoom_DECORATE.cfg.


R2117 | 0ba6490b | MaxED | 20.02.2015, 14:22
--------------------------------------------------------------------------------
Changed, "Make Brightness Gradient" action: MAPINFO FadeColor and OutsideFogColor properties are now used when first or last sector doesn't have "fadecolor" property when making a fade gradient.
Fixed (probably), D3DDevice: looks like CreatePresentParameters() can also throw "D3DERR_DEVICELOST" error in some cases...


R2116 | e06a764d | MaxED | 19.02.2015, 21:50
--------------------------------------------------------------------------------
Fixed a typo in one of the Preferences window's tool-tips.
Updated ZDoom_DECORATE.cfg.


R2115 | 25ca6f4e | MaxED | 19.02.2015, 18:59
--------------------------------------------------------------------------------
Fixed, MODELDEF parser: looks like INHERITACTORPITCH and INHERITACTORROLL flags affect only pitch/roll set in the map editor, not "PitchOffset" and "RollOffset" MODELDEF properties...


R2114 | aed233d2 | MaxED | 19.02.2015, 14:50
--------------------------------------------------------------------------------
Fixed, TEXTURES parser: fixed incorrect stream rewinding when reading "Blend" patch property without a tint amount.


R2113 | 0ea022fa | MaxED | 19.02.2015, 14:00
--------------------------------------------------------------------------------
Fixed, Visual mode: "Paste Texture Flood-Fill" action used long texture names regardless of current setting in Map Options.
Internal: "uselongtexturenames" setting is now stored in map settings file, not in the program configuration file.
Fixed, Color Picker plugin: in some cases mouse movement was processed incorrectly.
Fixed, Color Picker plugin: float color value output was culture settings-dependant.


R2112 | 321a56a8 | MaxED | 15.02.2015, 21:16
--------------------------------------------------------------------------------
Interface: changed OK / Cancel buttons order.


R2111 | ec964e9d | MaxED | 14.02.2015, 19:15
--------------------------------------------------------------------------------
Sector Edit form, UDMF: it was impossible to remove a sound sequence if it was set previously.
Error Check form: number of selected items is now shown in the window's title.
Error Check form: fixed slowdowns when trying to select many (like 1000) results at once.


R2110 | e8e2cac1 | MaxED | 13.02.2015, 20:59
--------------------------------------------------------------------------------
Fixed, Sectors mode: selection info and highlight were not updated after using "Join Sectors" and "Merge Sectors" actions.
Linedefs mode: "Update 'lightfog' flag" was missing the click event handler.


R2109 | 133e1367 | MaxED | 12.02.2015, 23:04
--------------------------------------------------------------------------------
Sector drawing: basic properties (textures, brightness, floor and ceiling height) are now taken from the nearest sector when a new isolated sector (e.g. a sector, which doesn't not intersect with already existing map geometry and is not inside of it) is drawn. 
Visual mode: when "Synch camera position" setting is enabled, and the cursor was outside of a sector when entering Visual mode, camera height is now adjusted based on nearest sector (previously the height was adjusted only when the cursor was inside of a sector).  
"Auto-align textures X", "Auto-align textures X and Y" actions, UDMF: alignment source sidedef part's horizontal scale is now applied to all aligned sidedefs.
Visual mode, UDMF: 'lightfog' flag is now automatically updated when changing sidedef brightness or using "Match Brightness" action. 
Linedefs mode: added "Update 'lightfog' flag" menu item.
Game configurations: cosmetic changes in UDMF linedef flag names.
Updated ZDoom_DECORATE.cfg.


R2108 | 3d3905e3 | MaxED | 07.02.2015, 18:52
--------------------------------------------------------------------------------
Fixed, Visual mode: sector effects should be updated when deleting textures.
Fixed, Visual mode, 3D floors: in some cases 3d floor flags were handled differently than in GZDoom.


R2107 | cde97f2c | MaxED | 06.02.2015, 22:03
--------------------------------------------------------------------------------
Fixed, Edit Selection: in some cases thing angles were updated incorrectly when things with "FixedRotation" game configuration property were among selected things.
Fixed, Visual mode: floor brightness was calculated incorrectly when "Disable Light Effects"/"Restrict light inside" 3d floor flags were used and the floor had "lightfloor" property.
Fixed: "lightabsolute" flag was accessed incorrectly in previous commit.


R2106 | 54fccb73 | MaxED | 06.02.2015, 10:01
--------------------------------------------------------------------------------
Fixed, Scale control (UDMF): in some cases default values were shown when displaying mixed values.
Fixed, long texture names support: in some cases long texture names were not processed correctly when pasting map geometry.
Fixed, Visual mode: in some cases combined sidedef brightness was calculated incorrectly. Also, MAPINFO FadeColor and OutsideFogColor properties are now taken into account.
Hexen_linedefs.cfg: "Door Raise" and "Door Locked Raise" used incorrect enums for "Close Delay".


R2105 | e4d87253 | MaxED | 04.02.2015, 19:02
--------------------------------------------------------------------------------
DECORATE: added "$argN" special comment. It can be used to specify default argument names.
Updated documentation.


R2104 | dc607649 | MaxED | 01.02.2015, 19:44
--------------------------------------------------------------------------------
Linedefs mode, UDMF: added "Apply 'lightfog' flag" action.
ZDoom_linedefs.cfg: "Plane" actions don't require activation.


R2103 | d641c116 | MaxED | 30.01.2015, 20:24
--------------------------------------------------------------------------------
Visual mode, "Raise Floor/Ceiling to adjacent sector", "Lower Floor/Ceiling to adjacent sector": things with "absolutez" flag should be handled differently.


R2102 | 666b3486 | MaxED | 30.01.2015, 15:16
--------------------------------------------------------------------------------
Fixed, Visual mode: in some cases "Raise Floor/Ceiling to adjacent sector" was not working properly when used on things.


R2101 | e687642c | MaxED | 30.01.2015, 09:10
--------------------------------------------------------------------------------
Fixed, Visual mode: a case when thing's height was bigger than distance between floor and ceiling's planes is now handled the same way as in ZDoom.


R2100 | 9dc3a7ba | MaxED | 30.01.2015, 08:58
--------------------------------------------------------------------------------
Fixed, Visual mode: when thing's position is not absolute, it should always be positioned between floor and ceiling planes.


R2099 | 2a1cd2c7 | MaxED | 29.01.2015, 22:41
--------------------------------------------------------------------------------
Sound Environment mode: you can now add sound environment things using "Insert Thing" or "Edit Selection" actions (just like you add things in Things mode).
Sound Environment mode: you can now delete currently highlighted sound environment thing by using "Delete" action.
Sound Environment mode: the sidebar panel icons now have the same colors as corresponding sound environments.
Fixed, Sound Environment mode: in some cases several sidebar panel items were highlighted at once (I broke this in r2201).
Fixed, Fit Textures action: lower linedef parts were aligned incorrectly.
Changed, Fit Textures Options form: "Fit across multiple surfaces" checkbox is now disabled when the action is applied to a single surface.


R2098 | 12203f17 | MaxED | 29.01.2015, 13:14
--------------------------------------------------------------------------------
Fixed, Sectors Mode, UDMF: "Make Brightness Gradient" action was not working when "Sector Brightness" mode was selected...


R2097 | 3575ffc0 | MaxED | 29.01.2015, 09:18
--------------------------------------------------------------------------------
Added some more boilerplate to MapManager.CompileLump()


R2096 | 3c9ea89d | MaxED | 29.01.2015, 09:00
--------------------------------------------------------------------------------
Changed ZDoom/GZDoom/Zandronum configuration names to avoid confusion.


R2095 | ed2a832c | MaxED | 29.01.2015, 00:33
--------------------------------------------------------------------------------
Added some boilerplate to MapManager.CompileLump().


R2094 | 4b01f8e9 | MaxED | 27.01.2015, 15:29
--------------------------------------------------------------------------------
Visual mode, UDMF: renamed "Scale Texture Up/Down (X/Y)" actions to "Increase/Decrease Horizontal/Vertical Scale". These actions can now be used on things.


R2093 | aca13330 | MaxED | 27.01.2015, 14:27
--------------------------------------------------------------------------------
Fixed, DECORATE parser: "scale", "xscale" and "yscale" properties are now parsed the same way as in ZDoom.
Fixed, DECORATE parser: parser was unable to parse negative numeric properties.


R2092 | 844ad7db | MaxED | 27.01.2015, 12:40
--------------------------------------------------------------------------------
Fixed, Texture previews: texture size labels were displaying incorrect size or no size at all when showing TEXTURES textures with negative scale.
Fixed, Visual mode, UDMF: when several wall parts were selected, only one could be dragged with the mouse.
Fixed, Visual mode, Auto-align textures, UDMF: TEXTURES scale is now taken into account when aligning textures.
Fixed, Visual mode, Auto-align textures (Y), UDMF: nearest height matching is now applied to non-wrapped middle backsides.
Cosmetic changes in ZDoom_ACS.cfg.


R2091 | b047dc4a | MaxED | 26.01.2015, 10:45
--------------------------------------------------------------------------------
Changed, UDMF: rearranged linedef activation flags to make their order more logical.
Linedef/Thing Edit forms: cosmetic changes to named/numbered script drop-down locations.


R2090 | 0374a0bf | MaxED | 26.01.2015, 09:53
--------------------------------------------------------------------------------
Changed, Edit Sector/Linedef/Thing/Vertex forms: undo is now created either when user changes a value using a real-time control or when applying changes, not when opening a form.


R2089 | 9a5709cf | MaxED | 26.01.2015, 09:26
--------------------------------------------------------------------------------
ReverbsParser: added duplicate reverbs ID check.
Updated ZDoom_DECORATE.cfg.


R2088 | 637cd69c | MaxED | 26.01.2015, 00:44
--------------------------------------------------------------------------------
Changed, Sound Environment mode: on second thought, we don't need to scan all map things to find one to highlight...


R2087 | 1c769eec | MaxED | 26.01.2015, 00:22
--------------------------------------------------------------------------------
Core, internal: added ReverbsParser. Reverbs can be accessed using General.Map.Data.Reverbs.
Sound Environment Mode: sound environments can now be picked by editing sound environment things.
Sound Environment Mode: detected sound environments names are now used as item names in the tree view.
Fixed, Classic modes: incorrect texture was used as unknown floor/ceiling texture (I broke this in r2199).
Fixed, MainForm: reverted MainForm.UpdateToolStripSeparators. By making it look simpler I made it work more buggy...
Updated ZDoom_DECORATE.cfg.


R2086 | 7bacccf3 | MaxED | 24.01.2015, 00:09
--------------------------------------------------------------------------------
Program configuration: added some sanity checks to "currentengineindex" property.


R2085 | 43d4f80b | MaxED | 23.01.2015, 22:51
--------------------------------------------------------------------------------
Fixed: flats and textures defined in TEXTURES should override regular ones (adding long texture names support broke this).
Removed unused references from all projects.


R2084 | e99bad11 | MaxED | 23.01.2015, 15:46
--------------------------------------------------------------------------------
Updated ZDoom_DECORATE.cfg.


R2083 | 914f5ec9 | MaxED | 23.01.2015, 13:49
--------------------------------------------------------------------------------
Updated setup and automatic build files.


R2082 | 0a7bd9f6 | MaxED | 23.01.2015, 13:36
--------------------------------------------------------------------------------
Added Sound Propagation plugin by boris (https://github.com/biwa/soundpropagationmode).
Changes since 5bf51d0:
Large scale cleanup & refactoring.
Sound Propagation Mode: you can now click on doublesided linedefs to toggle sound blocking flag.
Sound Environment Mode: you can now click on doublesided linedefs to toggle sound zone boundary flag.
Sound Propagation Mode: reimplemented the highlighting of non-deaf things. Things are now highlighted using selection color.
Removed "Show tooltips" checkbox. Tooltips are now always enabled.
Fixed, Sound Environment Mode: thing tooltip about multiple active sound environment things was shown even when there was only one active sound environment thing.
Fixed, Sound Environment Mode: "Configure colors" toolbar button was not working because of missing action.
Fixed, cosmetic: "Configure colors" toolbar icon was missing a tooltip.
Fixed, cosmetic: display was not redrawn after changing colors using "Color configuration" window.


R2081 | 1f3ebad9 | MaxED | 23.01.2015, 13:02
--------------------------------------------------------------------------------
UDMF: rearranged linedef flags to make their order more logical.
Fixed, Thing Browser Control: "Multiple Things" icon was assigned to BackgroundImage instead if Image.
Updated ZDoom_DECORATE.cfg.


R2080 | 38d2b145 | MaxED | 22.01.2015, 21:34
--------------------------------------------------------------------------------
Fixed, Script Editor: named scripts were not shown in the script navigator drop-down when current map was not in UDMF.


R2079 | 3343f6d2 | MaxED | 22.01.2015, 20:03
--------------------------------------------------------------------------------
Fixed, Script Editor: in some cases script navigator drop-down was not updated when required.
Changed, Script Editor: changed text cursor behavior when selecting an item in the script navigator drop-down to Visual Studio-like.


R2078 | 30808417 | MaxED | 20.01.2015, 13:20
--------------------------------------------------------------------------------
Fixed, GLDEFS parser: we should check for duplicate entries within current resource, not globally.
Moved stuff around a bit in PK3Reader. Will it fix random crashes? I dunno, a least I was no longer able to trigger them...
Recompiled SharpCompress library using VS 2008, so it no longer references .net 4.0 stuff. Will it fix random crashes? See above.


R2077 | 3676bd1a | MaxED | 20.01.2015, 08:58
--------------------------------------------------------------------------------
Visual mode: "Auto-align textures" actions now align mixed textures when used on a selection (helpful if you want to align several different textures, which can tile into each other).
Cosmetic: errors and warnings are now cleared when reloading resources.


R2076 | 40a35d39 | MaxED | 19.01.2015, 20:53
--------------------------------------------------------------------------------
Script Editor: fixed an exception when a script configuration contained identical keyword and constant.
ZDoom_DECORATE.cfg: added a bunch of actor properties.


R2075 | 7c0711f2 | MaxED | 18.01.2015, 20:51
--------------------------------------------------------------------------------
Thing Info panel: sprite preview image is no longer smoothed.
PK3Reader: probably fixed a random sharpcompress crash when trying to access a closed file (totally unsure, need more testing).
ZDoom_linedefs.cfg: fixed a typo.


R2074 | 8e61edca | MaxED | 17.01.2015, 21:32
--------------------------------------------------------------------------------
ZDoom_misc.cfg: added an empty "spawn_projectile" enumeration to prevent warnings when game-specific enums group doesn't contain this enum.
Game_Chex.cfg was misplaced.


R2073 | 43f19187 | MaxED | 17.01.2015, 00:37
--------------------------------------------------------------------------------
Draw Grid mode: added "Horizontal Interpolation" and "Vertical Interpolation" toolbar menus.
Fixed, Sectors mode, UDMF: surface cache was not updated after applying floor/ceiling brightness gradients.
Cosmetic, Sectors mode, UDMF: brightness gradient modes now have more descriptive names.
Internal, InterpolationTools: replaced EaseInOutSine equation with one, which actually works.


R2072 | b8c87191 | MaxED | 16.01.2015, 22:38
--------------------------------------------------------------------------------
Sectors mode: added "Light and Fade" brightness gradient mode.
Sectors mode: "Gradient Interpolation Mode" toolbar menu.
Internal: extracted easing functions from Bridge Mode into InterpolationTools class.
+a couple of cosmetic changes.


R2071 | 29023107 | MaxED | 16.01.2015, 14:14
--------------------------------------------------------------------------------
Fixed: texture coordinates interpolation during linedef splitting was failing in UDMF map format when target sidedef's texture was in a sub-folder of a PK3 or Folder resource.


R2070 | cc4a5995 | MaxED | 15.01.2015, 22:51
--------------------------------------------------------------------------------
Visual mode, "Raise/Lower Sector to Nearest" actions: both floor and ceiling heights of adjacent sectors are now taken into account.


R2069 | f06387bd | MaxED | 15.01.2015, 21:48
--------------------------------------------------------------------------------
Fixed (DB2 bug): the first texture of every TEXTURE1 lump should be ignored, not the first texture loaded from the first map resource. Also, said texture(s) are no longer shown in the Textures browser.
Cosmetic update in ZDoom_DECORATE.cfg.


R2068 | b08f64ac | MaxED | 14.01.2015, 14:12
--------------------------------------------------------------------------------
Draw Settings panel: added "Get From Selection" buttons.
+a couple of cosmetic changes.


R2067 | 64e19845 | MaxED | 12.01.2015, 19:18
--------------------------------------------------------------------------------
Fixed, Fit Textures action: sidedefs were not sorted properly when trying to use the action on several disconnected sidedef strips with the same texture.
Fixed, Fit Textures action: update was not triggered when toggling "Fit across connected surfaces" check-box.


R2066 | e4cad3e0 | MaxED | 12.01.2015, 13:27
--------------------------------------------------------------------------------
Map Analysis mode: multiple results can now be selected (and fixed) at once.
Map Analysis mode: selection color is now used when rendering affected things.
Fixed, Map Analysis mode, "Check unused things" check: checker returned false-positive results when used in Doom map format.


R2065 | 8218a5d9 | MaxED | 11.01.2015, 20:42
--------------------------------------------------------------------------------
UDMF: raised sector slope precision to 7 decimal places when saving a map.
Nodes Viewer mode: added more boilerplate to classic nodes reader.
Thing Filters Form: program configuration was not marked as changed when saving thing filters.
Cosmetic layout fixes in Thing/Linedef/Sector Info panels.
Cosmetic text fixes in several Map Analysis results.
Internal: debug console is now cleared when creating a new map.
Updated ZDoom_DECORATE.cfg.


R2064 | c325d7ec | MaxED | 11.01.2015, 00:12
--------------------------------------------------------------------------------
Changed, "Snap selected map elements to grid" action: the action now works on any selected map element type.
Fixed, Sectors mode: holding Alt to (de)select things inside of sectors worked only in band selection mode. Now it also works when selecting individual sectors and when using paint selection mode.
Fixed, Statistics Control: forgot to remove some test code in r2176...
Internal: removed several unused icons.


R2063 | f98fb4ed | MaxED | 10.01.2015, 12:45
--------------------------------------------------------------------------------
Statistics control: relevant labels now turn red when current number of given map elements exceeds current map format's maximum.
Statistics control: things count was not updated when adding or deleting things.
Map Analysis mode: "Check texture alignment" is now disabled by default.
Updated Inno Setup script and images.
Added DirectX web installer to Builder\Setup.
Updated MakeRelease.bat.
Updated ZDoom_DECORATE.cfg.


R2062 | 1b911628 | MaxED | 09.01.2015, 14:56
--------------------------------------------------------------------------------
Fixed, Linedef Edit form (classic): it was impossible to enable disabled front/back sides, because corresponding check-boxes were inside of corresponding groups.
Fixed, Nodes Viewer Mode: the mode was unable to handle missing node lumps properly.
Fixed, Nodes Viewer Mode: the mode no longer builds nodes when unable to find both classic nodes and ZNODES at the same time.
Removed SlimDX installer, because it's no longer required.
Internal: debug console is now cleared when opening a map.


R2061 | 8238ae91 | MaxED | 09.01.2015, 09:34
--------------------------------------------------------------------------------
Nodes Viewer plugin: added a sanity check.


R2060 | a531e41a | MaxED | 09.01.2015, 09:11
--------------------------------------------------------------------------------
High-Dpi: redesigned Docker control's Pin button. Now it is rendered properly when using high-dpi display settings.


R2059 | c34d07c5 | MaxED | 08.01.2015, 16:01
--------------------------------------------------------------------------------
Fixed: apparently, adding dpiAware as asmv1 element broke Windows XP compatibility...


R2058 | d2f7fb8a | MaxED | 08.01.2015, 10:45
--------------------------------------------------------------------------------
DECORATE parser: added multiple actions per frame (http://zdoom.org/Changelog/7d0faa5bd5f39f1b5c721e8287f94dc04811a355/files) support.


R2057 | 90d475ec | MaxED | 07.01.2015, 23:14
--------------------------------------------------------------------------------
Fixed, Visual mode, "Move Texture Up/Down/Left/Right" actions: sidedef textures were moved several units at once when several sidedef parts were selected in Doom and Hexen map formats.


R2056 | 2cff348d | MaxED | 07.01.2015, 22:20
--------------------------------------------------------------------------------
Fixed, Visual Mode: untextured middle parts of double-sided linedefs were selected when Shift-selecting a sidedef part with missing texture ("-").


R2055 | 297d7d28 | MaxED | 07.01.2015, 19:32
--------------------------------------------------------------------------------
Map Analysis mode: added "Browse Texture" fix to "Missing Texture" and "Unknown Texture" error results.
Map Analysis mode: added "Browse Flat" fix to "Missing Flat" and "Unknown Flat" error results.
Fixed several typos in ZDoom_misc.cfg.


R2054 | bb263448 | MaxED | 06.01.2015, 13:46
--------------------------------------------------------------------------------
Woops, forgot to commit the icon!


R2053 | 86031291 | MaxED | 06.01.2015, 12:49
--------------------------------------------------------------------------------
High-Dpi: fixed most of alignment errors.


R2052 | c788802c | MaxED | 05.01.2015, 15:56
--------------------------------------------------------------------------------
High-DPI: fixed alignment issues in Sector, Thing, Linedef and Vertex Edit Forms, also in Open Map Options and Map Options Forms.
Changed: Thing Browser Form is now resizeable.
Changed: made default Texture Browser Form size smalled, so it properly fits the screen when using low display resolution.


R2051 | a91227e9 | MaxED | 05.01.2015, 11:30
--------------------------------------------------------------------------------
Linedef Edit Form (Doom/Hexen map formats): fixed incorrect window size when using low display resolution (like 1024x768).


R2050 | 9c11d7e6 | MaxED | 03.01.2015, 19:43
--------------------------------------------------------------------------------
DECORATE parser: added special handling for ZDoom's special sprite names (namely TNT1, "####" and "----").
Internal: changed the way apppath is acquired. It should no longer fail when launching the editor from a shared network folder.
Main Form: changed some labels of dynamic light and model rendering selectors to be less confusing.
Updated ZDoom_DECORATE.cfg.


R2049 | be14f852 | MaxED | 30.12.2014, 21:39
--------------------------------------------------------------------------------
Internal: moved TNT1A0 ignoring logic to a more adequate place (why these "proper implementation" ideas always occur right AFTER I commit stuff?..)


R2048 | 17564a96 | MaxED | 30.12.2014, 21:14
--------------------------------------------------------------------------------
Fixed: patches named TNT1A0 should be skipped when creating a texture.
Updated ZDoom_DECORATE.cfg.


R2047 | 704ec15c | MaxED | 30.12.2014, 14:21
--------------------------------------------------------------------------------
Added more thorough map name validation logic to New/Open/Switch Map forms.
High-DPI: added app.manifest, which enables application DPI-awareness.
High-DPI: ExceptionDialog is now displayed properly.


R2046 | ec69eb5d | MaxED | 29.12.2014, 22:44
--------------------------------------------------------------------------------
Also, we should not switch to a map named "MAP"...


R2045 | de43f4f9 | MaxED | 29.12.2014, 20:38
--------------------------------------------------------------------------------
Apparently, we can no longer load a map named "MAP" after r2151. Let's warn a user about this unfortunate event.


R2044 | 858bffd6 | MaxED | 29.12.2014, 19:15
--------------------------------------------------------------------------------
Added more checks and fixed incorrect flag assignment in UDMF -&gt; Hexen action conversion from r2155.


R2043 | 8491993b | MaxED | 29.12.2014, 13:28
--------------------------------------------------------------------------------
Updated SharpCompress library from 0.8.1 to 0.10.3. This fixes inability to load certain PK7 files and grants a 2x performance boost when loading PK3 and PK7 files.


R2042 | 4f7e2298 | MaxED | 29.12.2014, 10:19
--------------------------------------------------------------------------------
Added Hexen -&gt; UDMF and UDMF -&gt; Hexen action conversion as described in "Universal Doom Map Format ZDoom extensions" (udmf_zdoom.txt). It is used when changing map format form Hexen to UDMF and from UDMF to Hexen.
Game configurations, Line Identification action: added "Front side only" (128) flag to arg1.
Game configurations, Line Identification action: renamed arg1 flags to match corresponding UDMF flag names.
Updated udmf_zdoom.txt.


R2041 | 246ff4ae | MaxED | 24.12.2014, 19:32
--------------------------------------------------------------------------------
Fixed: some controls had inconsistent auto-scaling mode.
Fixed: PairedFloatControl had incorrect initial link icon.
Internal, AngleControl: rewritten AngleChanged event so it behaves like the rest of custom events.
Updated GZDB icon.


R2040 | 07d626bb | MaxED | 24.12.2014, 08:50
--------------------------------------------------------------------------------
Find and Replace mode: only used sidedef parts are now found when searching for missing texture ("-").
Find and Replace mode: only textures on used sidedef parts are now replaced when replacing missing texture ("-"),


R2039 | 4a1f8319 | MaxED | 23.12.2014, 13:32
--------------------------------------------------------------------------------
Fit Textures action: texture repeats can now be negative.
Fixed, Fit Textures action: vertical texture offset of a middle part of double-sided linedef with "Lower unpegged" flag was calculated incorrectly.
Fixed, Fit Textures action: texture offsets were calculated incorrectly when using the action on several groups of connected walls at once with "Fit across connected surfaces" enabled.
Fixed, Visual mode: middle parts of double-sided linedefs were not rendered when ScaleY was negative.
Updated ZDoom_DECORATE.cfg.


R2038 | deb43343 | MaxED | 22.12.2014, 22:36
--------------------------------------------------------------------------------
Visual mode: "Fit Textures" action can now fit textures across multiple selected surfaces. A number of times to repeat a texture can now be specified.  
Visual mode: removed "Fit Texture's Width" and "Fit Texture's Height" actions.
Visual mode: "Auto-align texture offsets" actions were incorrectly aligning double-sided middle walls in some cases.
Visual mode: "Auto-align texture offsets" actions now align non-wrapped double-sided middle walls to vertical offset closest to their initial vertical offset.
Visual mode: middle parts of double-sided walls were ignored when Shift-selecting walls.
Nodebuilders/Game configurations: GL nodes definitions were missing from game configurations.
Nodebuilders/Game configurations: "~MAP" wildcard can now be a part of a lump name. 
Nodebuilders: GL nodes were not properly handled by the editor.
Main Window: the window is now moved into the view when stored position is ouside of screen bounds. 
Classic and Visual modes: changing thing pitch was ignored in some cases.
Visual mode: raising and lowering a thing with "+SPAWNCEILING" flag now works the same way as when raising/lowering a regular thing.
Visual mode: using "Raise/Lower Floor/Ceiling to adjacent sector" actions on a thing with "+SPAWNCEILING" flag now works the same way as when using them on a regular thing.  
Rendering: even more fixes to MODELDEF and UDMF properties-related model rendering logic.
Internal, ResourceListEditor: rewritten resource validation check in a more OOP-ish way.
Configurations: fixed an infinite loop crash when a file was trying to include() itself.
UDMF thing flags: added Skill 6-8 to the flags list (because there are thing filters for these).
ZDoom_ACS.cfg: added definitions for SetTeleFog and SwapTeleFog.
ZDoom_DECORATE.cfg: added definitions for A_SetTeleFog and A_SwapTeleFog.
Updated ZDoom ACC.
Updated documentation.


R2037 | 59f8bea4 | MaxED | 19.12.2014, 10:24
--------------------------------------------------------------------------------
Image Selector Control: fixed a crash when clearing an image.


R2036 | a94829b7 | MaxED | 16.12.2014, 10:01
--------------------------------------------------------------------------------
Added "Use long texture names" check-box to Map Options and Open Map Options windows.
Resource List Editor: not existing resources are now shown using different color. 
Map Options, Open Map Options, Game Configurations windows: a warning is now shown when a map resource doesn't exist.
Some minor fixes to Resource List Editor's context menu.
Updated ZDoom_DECORATE.cfg.


R2035 | 12830020 | MaxED | 12.12.2014, 15:14
--------------------------------------------------------------------------------
Resource List Editor: fixed potential crash on pasting/replacing resources when there are duplicate resources in the list.
Resource List Editor: duplicate resources are no longer added when adding resources using drag and drop.


R2034 | 1648f162 | MaxED | 12.12.2014, 14:21
--------------------------------------------------------------------------------
Several items can now be selected at once in Resource List Editor.
Resource List Editor now has a context menu.
Fixed misleading warning asking user to install DirectX when unable to detect SlimDX.


R2033 | 716d9d26 | MaxED | 11.12.2014, 13:55
--------------------------------------------------------------------------------
Rendering: MODELDEF "offset" property is now supported.
Rendering: mode fixes to MODELDEF and UDMF properties-related model rendering logic.


R2032 | 4d9c5517 | MaxED | 10.12.2014, 23:50
--------------------------------------------------------------------------------
Fixed, Rendering: MODELDEF RollOffset, AngleOffset, Scale and ZOffset properties were applied incorrectly.
Fixed, Rendering: VOXELDEF Scale property was applied incorrectly.


R2031 | 33a35e21 | MaxED | 10.12.2014, 22:11
--------------------------------------------------------------------------------
Import Wavefront .obj as Terrain mode now works in all map formats.
Import Wavefront .obj as Terrain mode: floor height of each created sector is now set to the average height of an .obj polygon it was created from.
Import Wavefront .obj as Terrain Settings window: added "Use slopes" checkbox. When enabled, the mode will create slopes using vertex height offsets (UDMF) or Floor Vertex Height things (1504).
Fixed, Visual Mode: things were rendered at wrong height after using "Lower/Raise Height" actions in sectors with sloped floor (or ceiling for ceiling-aligned things) 
Fixed: info panel was not updated after switching to another Edit Mode.


R2030 | 979244a1 | MaxED | 10.12.2014, 15:22
--------------------------------------------------------------------------------
A couple of fixes to ScriptDocumentTab.FindPrevious() logic.


R2029 | 2f981476 | MaxED | 10.12.2014, 14:15
--------------------------------------------------------------------------------
Script Editor: added Quick Search panel.
Find and Replace window: added "Find Previous" button.


R2028 | e6e74478 | MaxED | 10.12.2014, 09:21
--------------------------------------------------------------------------------
Script Editor: expanding snippet by pressing the Tab key now works only when the text cursor is at the end of a keyword.
Updated ZDoom ACC.
Updated ZDoom_things.cfg.
Updated documentation.


R2027 | f9b5399a | MaxED | 08.12.2014, 22:06
--------------------------------------------------------------------------------
Added AngleByteHandler (type 22).
Bit Flags form now changes width to show flags with long names without scrolling.
Bit Flags form: flag numbers are now shown as well as names.
Game configurations: updated Hexen and ZDoom linedef definitions. Now they (hopefully) fully match ZDoom ones. 
Action Selector Control: fixed a crash when trying to increase action above maximum value using mouse wheel.
Sector/Linedef/Thing tag lists are now handled by corresponding TypeHandlers (and not by dirty hacks as before).
Linedef info panel: line peggedness labels were obscured by effect label in Doom/Hexen map formats.


R2026 | 868d1f50 | MaxED | 05.12.2014, 22:43
--------------------------------------------------------------------------------
Woops...


R2025 | 357f0554 | MaxED | 05.12.2014, 22:34
--------------------------------------------------------------------------------
Thing Edit Form: default action arguments were not applied.
Thing\Linedef Edit Form: added some tooltips.
Some cosmetic layout changes in LinedefEditForm.


R2024 | 3f7392b5 | MaxED | 05.12.2014, 20:42
--------------------------------------------------------------------------------
Game configurations: moved Zandronum linedef definitions to Zandronum_linedefs.cfg.
Game configurations: removed some irrelevant info.


R2023 | a0898c4e | MaxED | 05.12.2014, 15:33
--------------------------------------------------------------------------------
Thing/Linedef/Sector Edit forms: added help button to action special selector.
Cosmetic changes in Sector Info Panel and Thing Browser Control.
ArgumentInfo: fixed a crash when enum specified in a game configuration doesn't exist.
Updated Hexen and ZDoom linedef configs.
Updated ZDoom_DECORATE.cfg


R2022 | 2667f9b5 | MaxED | 04.12.2014, 11:06
--------------------------------------------------------------------------------
Thing, Sector, Linedef edit forms, UDMF: fixed more cases when missing game configuration blocks crashed the forms.
Thing and Sector edit forms, UDMF: fixed some minor layout issues.


R2021 | 1e421bda | MaxED | 04.12.2014, 08:50
--------------------------------------------------------------------------------
Fixed, Texture Browser form: we should not save "Long texture names" value when Map.Config.UseLongTextureNames is disabled.
Fixed, Linedef Edit form (UDMF): fixed a crash on opening the form when "linedefrenderstyles" block was missing from game configuration.


R2020 | 0ab9f070 | MaxED | 04.12.2014, 00:52
--------------------------------------------------------------------------------
Some cosmetic changes in ThingInfoPanel.


R2019 | b129e9b1 | MaxED | 04.12.2014, 00:30
--------------------------------------------------------------------------------
Texture Browser Control: "Long texture names" and "Show image size" values are now stored in program configuration.


R2018 | 15b2adfe | MaxED | 04.12.2014, 00:15
--------------------------------------------------------------------------------
Texture Browser Form: swapped foreground and background colors of texture size labels.
Fixed, Texture Browser Form: well, I broke "Tab" key functionality again (in previous commit)...
Maintenance: changed curly braces style to match DB2 one (hopefully not breaking anything in the process...).
Maintenance: changed private method names casing to match DB2 one.


R2017 | 99f3ba28 | MaxED | 03.12.2014, 10:06
--------------------------------------------------------------------------------
Changed long texture names handling. Texture names conversion is no longer required.
Texture browser form: added "Long texture names" check-box. It can be used to toggle between displaying long and short texture names.
Texture browser form: added "Show image size" check-box.
Texture browser form: image size is now shown differently.
Image Selector: added a button to toggle between long and short texture name.
Linedef info panel: long texture names are now displayed properly.
Sector info panel: long texture names are now displayed properly.
Fixed: "Save Screenshot" and "Save Edit Area Screenshot" actions were triggered multiple times when a child window was open.
Fixed: used textures should be always updated after using "Change map in current WAD" action.
Fixed, "Change map in current WAD": fixed a crash when trying to switch from a map with missing game configuration path.
Updated ZDoom_ACS.cfg.


R2016 | 6b765f5a | MaxED | 25.11.2014, 12:52
--------------------------------------------------------------------------------
Added long texture names support (enabled when "longtexturenames" game configuration property is set to true and "Use long texture names" check box is checked in Map Options).
Open Map in Current WAD: resources are now reloaded when current and target map's resources don't match.
Added some boilerplate to UniversalParser and PK3FileImage.
Internal: ImageSelectorControl now has "UsePreviews" property.
Internal: added ConfigurablePictureBox.
Updated ZDoom_DECORATE.cfg.


R2015 | ecc4cd92 | MaxED | 22.11.2014, 21:56
--------------------------------------------------------------------------------
Game configurations: fixed "Door Generic (202)" movement speed, type and delay, fixed "Door Close Wait Open (249)" movement speed and delay.


R2014 | f3bd56f3 | MaxED | 17.11.2014, 02:41
--------------------------------------------------------------------------------
Fixed: GZDB was not shown in alt-tab list when "Errors and Warnings" window was open.


R2013 | 18e52226 | MaxED | 15.11.2014, 21:25
--------------------------------------------------------------------------------
Linedef Edit Form, UDMF: "Lock number" now has a drop-down with supported key types (no LOCKDEFS support (yet?)). You can still type lock number manually.


R2012 | 66f75ec7 | MaxED | 13.11.2014, 10:43
--------------------------------------------------------------------------------
Internal: added a debug console.


R2011 | 2b7eee8d | MaxED | 12.11.2014, 12:22
--------------------------------------------------------------------------------
Draw modes: linedef length labels no longer overlap linedefs.


R2010 | 613e51ce | MaxED | 11.11.2014, 12:47
--------------------------------------------------------------------------------
Internal: removed GameConfiguration.MapLumpNames, instead GameConfiguration.MapLumps is now used.
Internal: removed some unrelated stuff from NodesViewer.csproj.


R2009 | 91f06ad9 | MaxED | 10.11.2014, 12:27
--------------------------------------------------------------------------------
Thing Edit form: "Mixed Things" icon is now displayed when several thing types are selected.
Thing Edit form: when selection contains more than one thing, thing types form selected category are now randomly applied to it.  
Fixed, Thing Edit form: selection change was not processed in some cases.


R2008 | 42fc2d8c | MaxED | 06.11.2014, 13:56
--------------------------------------------------------------------------------
Changed: reorganized controls in Thing Edit forms.
Changed: thing sprite is now displayed in ThingBrowserControl.


R2007 | ec1cf802 | MaxED | 05.11.2014, 15:31
--------------------------------------------------------------------------------
Updated ZDoom_DECORATE.cfg. Now it hopefully has nearly all DECORATE functions and flags.
Updated documentation.


R2006 | 6c1dbc0b | MaxED | 05.11.2014, 13:32
--------------------------------------------------------------------------------
Find and Replace mode:
"Find Any Texture or Flat", "Find Sector Flat" and "Find Sidedef Texture" options now support "*" (match any number of characters) and "?" (match any single character) wildcards.
"Find Any Texture or Flat" is now available any game configuration (previously it was disabled when "MixTexturesFlats" game configuration option was disabled, now only "Replace" functionality is disabled).
"Find Thing Flags" and "Find Linedef Flags" can now replace flags.
Added "Find Sidedef Flags" and "Find Sector Flags" search options.


R2005 | d45b812b | MaxED | 04.11.2014, 15:24
--------------------------------------------------------------------------------
Fixed, Draw Grid mode: fixed a crash on accepting the mode when start and end points had the same coordinates.
Fixed, Draw Grid mode: grid triangles are now aligned properly with previously drawn triangulated grids when using the same map grid size and "Lock slices to grid" and "Triangulate" options are enabled.
Fixed, Draw Grid mode: not all grid cells were drawn in some cases.
Fixed, Draw Grid mode: current grid size was not increased when "Lock slices to grid" was enabled and the start point was no longer on the map grid.
Changed, Draw Grid mode: snap to grid is now always enabled and snap to nearest is now always disabled when "Lock slices to grid" is enabled.
Changed, Draw Grid mode: when grid's width or height is 0 when accepting the mode, a segmented line is now drawn instead of just a line.


R2004 | 7a790f2d | MaxED | 04.11.2014, 00:06
--------------------------------------------------------------------------------
Hmm...


R2003 | 580eb492 | MaxED | 04.11.2014, 00:03
--------------------------------------------------------------------------------
Err...


R2002 | 27d02188 | MaxED | 03.11.2014, 15:03
--------------------------------------------------------------------------------
A slightly better implementation of previous commit...


R2001 | 720b4e01 | MaxED | 03.11.2014, 14:58
--------------------------------------------------------------------------------
Fixed, "OpenMapInCurrentWad" action: we should not switch to already opened map.
Fixed, Open Map form: a warning is now displayed when no map is selected when accepting the form.


R2000 | f986f5c9 | MaxED | 03.11.2014, 14:02
--------------------------------------------------------------------------------
Fixed, game configurations: Boom game configurations used incorrect "thingflagscompare" block.
Fixed, Thing edit form: implemented overcomplicated required flags check (which should work as expected this time. probably.).


R1999 | 06163d46 | MaxED | 02.11.2014, 20:32
--------------------------------------------------------------------------------
Fixed, Change Map form: keyboard focus was not properly updated after selecting current map in the maps list.


R1998 | 840cdf66 | MaxED | 02.11.2014, 20:02
--------------------------------------------------------------------------------
Fixed: when switching to a different map format, all nodes with "nodebuild" property set to true in the "maplumpnames" block of current game configuration are now removed.


R1997 | 77ba424f | MaxED | 02.11.2014, 18:15
--------------------------------------------------------------------------------
Fixed: it's now impossible to set grid size smaller than 1.


R1996 | cefb66ca | MaxED | 31.10.2014, 14:53
--------------------------------------------------------------------------------
A warning is now displayed when an unclosed marker range is found in a WAD (e.g. when there's a S_START, but no S_END after it).


R1995 | ecaf9331 | MaxED | 31.10.2014, 10:52
--------------------------------------------------------------------------------
Fixed: SaveScreenshots method was called several times when child windows were open.
Fixed incorrect screenshot size when a window was maximized.
Fixed: more than one screenshot per second can now be saved.
Changed screenshot filename date format to yyyy.mm.dd.


R1994 | 8defbb42 | MaxED | 31.10.2014, 08:42
--------------------------------------------------------------------------------
Fixed: in some cases incorrect window bounds were used when saving active window screenshot when several child windows were open.


R1993 | 47d248a7 | MaxED | 30.10.2014, 09:43
--------------------------------------------------------------------------------
Fixed: in some cases selection synchronization logic worked incorrectly when switching from Visual to Classic mode.


R1992 | 3e4fe14f | MaxED | 29.10.2014, 15:51
--------------------------------------------------------------------------------
Randomize Sectors form: floor/ceiling height controls now have "Offset mode" drop-downs. Available modes are "Raise and lower" (default), "Raise only" and "Lower only".
Consistency, Randomize Sectors form: persistent settings are now saved only when applying changes done in the form (e.g. in the same conditions as in Randomize Things / Vertices forms).


R1991 | 5e59c38d | MaxED | 29.10.2014, 14:11
--------------------------------------------------------------------------------
Fixed: Randomize Sectors / Vertices, UDMF: vertex handles were not updated.
Fixed: Randomize Sectors, UDMF: vertex height changes were not undone properly after using the mode (I broke it in r2101).
Fixed: Randomize Sectors: floor/ceiling textures can not be used as lower/upper textures when "MixTexturesAndFlats" is disabled. In this case the corresponding option is now changed to "Use default texture".


R1990 | 7a3d7436 | MaxED | 29.10.2014, 12:35
--------------------------------------------------------------------------------
Fixed, Thing Edit form: double-click on a thing type in the Things list was handled incorrectly in some cases.
Changed, Thing Edit form: multi-select mode is now disabled when only one thing is edited.
Internal: different implementation of MultiSelectTreeview (http://sourceforge.net/projects/mstreeview/) is now used.


R1989 | eba7dabf | MaxED | 28.10.2014, 22:50
--------------------------------------------------------------------------------
DECORATE parser: let's not use LANGUAGE keywords as actor titles.


R1988 | 5eba596a | MaxED | 28.10.2014, 15:35
--------------------------------------------------------------------------------
Randomize Sectors form: added "Use vertex heights" check-boxes. When enabled and used on triangular sectors, it can be used to create a terrain-like look.
Updated ZDoom_DECORATE.cfg.
Updated documentation, rearranged contents a bit.


R1987 | 064b790d | MaxED | 28.10.2014, 11:30
--------------------------------------------------------------------------------
Visual mode: selection info was not updated in some cases.


R1986 | 601280bb | MaxED | 28.10.2014, 10:31
--------------------------------------------------------------------------------
Game configurations, UDMF: added "midtex3dimpassible" linedef flag.
Linedef Edit form: resized controls to show all flags without scrolling.
Updated ACS and DECOTARE ZDoom configurations.


R1985 | 0d90d9b2 | MaxED | 28.10.2014, 10:23
--------------------------------------------------------------------------------
Visual mode: regular walls are now clipped by solid 3d floors (this should eliminate z-fighting).
Fixed, WavefrontExporter: floor and ceiling textures were not exported when using "classic" game configurations (ones with disabled "MixTexturesAndFlats" option). This should also fix incorrect flats on exported model when there are flats and textures with the same name.
Fixed, WavefrontExporter: 3d floors geometry and wall geometry around them was created incorrectly.
Fixed, WavefrontExporter: floor and ceiling textures of non-Vavoom 3d floors were swapped on exported geometry.


R1984 | 698f57b2 | MaxED | 26.10.2014, 21:11
--------------------------------------------------------------------------------
Fixed: since we are now using Dictionary in WADReader.GetDecorateData, all names should be unique.


R1983 | d4cfdd78 | MaxED | 23.10.2014, 15:27
--------------------------------------------------------------------------------
Fixed, DECORATE parser: we should use full path when reporting wad DECORATE parse errors.


R1982 | 05d097a7 | MaxED | 23.10.2014, 15:04
--------------------------------------------------------------------------------
Internal: removed ambiguous method override.


R1981 | 6df64156 | MaxED | 23.10.2014, 14:48
--------------------------------------------------------------------------------
DECORATE parser: parse errors are more detailed now.
Fixed, DECORATE parser: error status was not cleared when switching to different resource.
Fixed, DECORATE parser: fixed a parse error when DB2-specific actor properties (like "//$category") were located outside of actor's scope.


R1980 | badd7dce | MaxED | 23.10.2014, 10:18
--------------------------------------------------------------------------------
Fixed: undo list must be cleared during "Switch map in current wad" action.
Fixed incorrect non-UDMF &lt;-&gt; UDMF skills translations in Strife_misc.cfg.


R1979 | ab7d4b20 | MaxED | 22.10.2014, 15:07
--------------------------------------------------------------------------------
Renamed "Save Screenshot (editing area only)" action to "Save Screenshot (active window)". It will now save a screenshot of currently active window, or editing area if no windows are open.
Added icons for "Save Screenshot" menu items.
Development: "Save Screenshot (active window)" action will work on a child Form only if it is inherited from DelayedForm.


R1978 | 1ae9481a | MaxED | 21.10.2014, 15:35
--------------------------------------------------------------------------------
Fixed: regular and block comment parsing was broken in TEXTMAP parser.
Updated MissingThing icon.
More changes in ZDoom_linedefs.cfg and Hexen_linedefs.cfg.


R1977 | c90d10c0 | MaxED | 20.10.2014, 14:16
--------------------------------------------------------------------------------
General interface: dynamic lights rendering mode and model rendering mode are now selected via drop-downs.
Renamed "Toggle dynamic lights rendering" action to "Show dynamic lights".
Changed: "Show dynamic lights" action now toggles between available dynamic light rendering modes.
Renamed "Toggle models rendering" action to "Show models".
Changed: "Show models" action now toggles between available model rendering modes.
Removed "Toggle dynamic lights animation" and "Render selected/all models" actions.
Fixed, Randomize Sectors form: selection highlight was not updated after applying the changes when the form was shown in Sectors mode.
Consistency: selection is now cleared after applying changes done in Randomize Things and Randomize Vertices forms.
Fixed, Classic modes: sprites of things with attached models were not rendered when model rendering was disabled.
Updated documentation.


R1976 | fccb8106 | MaxED | 17.10.2014, 15:43
--------------------------------------------------------------------------------
Updated documentation.


R1975 | 558cd6f2 | MaxED | 17.10.2014, 14:50
--------------------------------------------------------------------------------
Changed FormBorderStyle from FixedToolWindow to FixedDialog. GZDB should no longer disappear from the alt-tab list when a child form is opened.


R1974 | 50137207 | MaxED | 17.10.2014, 13:55
--------------------------------------------------------------------------------
Sector Edit form, UDMF: added "Slopes" tab.
Visual mode: "Lower/Raise Floor/Ceiling" actions now work on surfaces with sector slopes.
Cosmetic: numeric textboxes, which support relative values, now have differently colored text and a tooltip.
Internal: renamed Sector.CeilingSlopeOffset to Sector.CeilSlopeOffset, Sector.CeilingSlope to Sector.CeilSlope to match their names with similar sector properties.


R1973 | 25a83650 | MaxED | 17.10.2014, 13:19
--------------------------------------------------------------------------------
Updated some icons. The new ones should be more visible when using dark Windows themes.


R1972 | eb9781b3 | MaxED | 15.10.2014, 10:36
--------------------------------------------------------------------------------
Optimization, PK3: approximately 2x performance increase during background resource loading (~7 seconds vs ~16 seconds in r2083, tested on Enjay's Genetech MAP01).
Fixed, PK7: fixed a potential crash when using several PK7 resources with overlapping files.


R1971 | 91152ee6 | MaxED | 14.10.2014, 00:01
--------------------------------------------------------------------------------
Changed, Visual mode: "Help" panel is now updated only if it is the active tab.
Internal: added General.Interface.ActiveDockerTabName property.


R1970 | 7a9e01c0 | MaxED | 13.10.2014, 11:32
--------------------------------------------------------------------------------
Changed, Directory/PK3/PK7: on second thought, we don't need to load textures/flats from all possible locations (does anyone really needs to see sprites and graphics in the texture browser?), so this logic now only works when looking for patches.
Game Configurations: added "Custom Ambient Sound (no gravity)":14067, added a couple of missing parameters to other sound-related things.


R1969 | 0cfb0207 | MaxED | 13.10.2014, 00:22
--------------------------------------------------------------------------------
Fixed, Directory/PK3/PK7 image loading: we should use DoomTexture as expected format when loading flats from non-"Flats" folders.


R1968 | 10da1284 | MaxED | 12.10.2014, 23:59
--------------------------------------------------------------------------------
Changed: both DoomTexture and DoomFlat formats should be checked when determining an image format if "Mix textures and flats" flag is set.
Changed: "imgz" images are now skipped while loading textures.


R1967 | 8b0f973b | MaxED | 09.10.2014, 21:29
--------------------------------------------------------------------------------
Fixed: it was possible to add the same Docker several times using General.Interface.AddDocker().


R1966 | 76302375 | MaxED | 09.10.2014, 16:16
--------------------------------------------------------------------------------
Fixed, Tag Explorer: "Export to file" logic was broken.


R1965 | d8df65b2 | MaxED | 07.10.2014, 11:56
--------------------------------------------------------------------------------
More fixes to PK3/Directory patch and texture search/creation logic.


R1964 | 7c048ece | MaxED | 07.10.2014, 10:56
--------------------------------------------------------------------------------
More fixes to PK3/Directory patch and texture search logic.
Fixed, Textures Browser form: fixed another case of the blank textures list after opening the form.


R1963 | 88e5e790 | MaxED | 07.10.2014, 02:23
--------------------------------------------------------------------------------
Textures Browser form: empty texture sets are no longer shown when mixed textures & flats is disabled in the current game configuration.
Textures Browser form: PK3/Directory TEXTURES images are now shown in a separate folder in the resources tree.
Fixed, Textures Browser form: fixed a logic error when trying to select initial flat when mix textures & flats was disabled in the current game configuration (this resulted in the blank textures list after opening the form).
Fixed, Textures Browser form: resources tree showed textures count even when browsing flats.
Fixed, Textures Browser form: PK3/Directory textures took precedence even when browsing flats (this means when there were a flat and a texture with the same name, a texture was displayed when browsing flats).
Fixed, Classic modes: actor's scale set in DECORATE was ignored when rendering models.
Fixed, MODELDEF parser: in some cases, several model definitions were skipped when trying to skip the current one.
Fixed, resource management: flat and sprite TEXTURES definitions were loaded only from TEXTURES files named "TEXTURES".
Fixed/added, PK3/folder resource management: patch locations for sprites defined in TEXTURES are now checked the same way as in ZDoom (previously only the "sprites" folder was checked).
Fixed/added, PK3/folder resource management: patch locations for textures defined in TEXTURES are now checked the same way as in ZDoom (previously only the "textures" folder was checked).
Fixed, PK3/folder resource management: flats defined in TEXTURES were not added to the global Flats image list.
Fixed, PK3/folder resource management: in some cases, the image search algorithm could find flats, textures, patches or sprites in incorrect folders (for example, it could find a flat in "flats_backup" folder).


R1962 | 6bc4325b | MaxED | 03.10.2014, 23:55
--------------------------------------------------------------------------------
Fixed: VirtualSectorField was cleared from sector properties when pasting map geometry in Doom/Hexen map formats leading to incorrect sector assignment [I broke this in r2009, so it seems].


R1961 | 9d69448c | MaxED | 01.10.2014, 10:17
--------------------------------------------------------------------------------
Reverted r2025 changes, because performance improvement was not worth the trouble...


R1960 | ae7d6dd3 | MaxED | 01.10.2014, 00:31
--------------------------------------------------------------------------------
Fixed a broken lookup update logic in WAD.Remove() and WAD.RemoveAt() again.
MakeSVNRelease.bat: changed log start revision from 1 to 1496 (GZDB's second commit).


R1959 | f924dbcb | MaxED | 30.09.2014, 22:14
--------------------------------------------------------------------------------
Fixed a broken lookup update logic in WAD.Remove() and WAD.RemoveAt().


R1958 | fa1a1d42 | MaxED | 30.09.2014, 21:46
--------------------------------------------------------------------------------
Fixed, Classic modes: Alt-dragging map elements (e.g. "snap to grid increment while dragging" mode) was not working properly.


R1957 | b95a059e | MaxED | 30.09.2014, 15:29
--------------------------------------------------------------------------------
Added ChangelogMaker tool, updated MakeSVNRelease.bat


R1956 | bc1c32d5 | MaxED | 30.09.2014, 14:02
--------------------------------------------------------------------------------
Map Analysis: added "Check unused things" check.
Map Analysis, internal: some ErrorCheckers and ErrorResult had inconsistent namespaces.
Thing Edit forms, internal: optimized missing flags check a bit.


R1955 | b90b7b8a | MaxED | 29.09.2014, 22:49
--------------------------------------------------------------------------------
Thing Edit Form: a warning is now displayed when a thing doesn't have any skill or class or game mode flags.
Game Configurations: moved "thingflagscompare" from Game to Map format blocks. "Check stuck things" check now works properly in Doom/Boom game configurations.
Map Analysis: fixed a possible crash during "Check texture alignment" check.
Map Analysis: ResultStuckThingInLine now highlights both thing and line.
Map Analysis: ResultStuckThingInThing now highlights both things and allows to delete any of them.
Internal, Map Analysis: rewritten parts of "Check stuck things" class.
Internal, Map Analysis: changed the way processed stuff is stored in "Check texture alignment" class.
Internal: changed CurrentDomainOnUnhandledException, so ExceptionDialog with proper info shows up even if adding exception to the Event Log failed.
Internal: changed format, in which thingflagscompare info is stored.


R1954 | adc2a4af | MaxED | 29.09.2014, 16:05
--------------------------------------------------------------------------------
Map Analysis: "Check texture alignment" check now works in UDMF map format.
Fixed incorrect syntax in ZDoom_DECORATE.cfg.


R1953 | 377fa0f5 | MaxED | 29.09.2014, 11:52
--------------------------------------------------------------------------------
More changes to ZDoom_ACS.cfg and ZDoom_DECORATE.cfg...


R1952 | 146fc3f4 | MaxED | 29.09.2014, 10:41
--------------------------------------------------------------------------------
Map Analysis form: fixed a crash caused by running analysis, opening another map then trying to run analysis again.
Map Analysis form: error checks are now alphabetically sorted.
Map Analysis form: added "Toggle All" check box.
Internal: CheckboxArrayControl now has Sort() method.
More fixes in ZDoom_DECORATE.cfg


R1951 | c84ac24b | MaxED | 26.09.2014, 09:48
--------------------------------------------------------------------------------
Scripting: added A_DamageSelf, A_DamageTarget, A_DamageTracer and CheckClass definitions, fixed a bunch of inconsistencies in ZDoom_DECORATE.cfg.


R1950 | e849c041 | MaxED | 24.09.2014, 13:47
--------------------------------------------------------------------------------
Changed: when using "Save map" action, only .dbs file is saved when map was not changed.
Cosmetic: changed Angle Control's outline color.


R1949 | 7235fa63 | MaxED | 24.09.2014, 10:48
--------------------------------------------------------------------------------
Cosmetic: Angle Control now has angle marks.


R1948 | c98c9b49 | MaxED | 24.09.2014, 01:29
--------------------------------------------------------------------------------
Internal: sort sector levels only if there are more than 2 of them in a given sector.


R1947 | 88ae5688 | MaxED | 23.09.2014, 23:34
--------------------------------------------------------------------------------
Added: Map Analysis: added "Check texture alignment" check. Currently it works only in Doom/Hexen map formats.


R1946 | cc1c4077 | MaxED | 23.09.2014, 10:54
--------------------------------------------------------------------------------
Action Selector control: actions can now be scrolled using up/down keys and mouse wheel.


R1945 | 62e5f0b7 | MaxED | 23.09.2014, 10:33
--------------------------------------------------------------------------------
Updated ZDoom ACC.
More changes in ZDoom_linedefs.cfg.


R1944 | 84ffec92 | MaxED | 23.09.2014, 01:49
--------------------------------------------------------------------------------
ZDoom_linedefs.cfg: Thing_SetGoal was missing 4-th argument.


R1943 | e611c934 | MaxED | 22.09.2014, 21:01
--------------------------------------------------------------------------------
Fixed: Drag Geometry Mode: dragged sectors, linedefs or vertices were snapped to 0, 0 in some cases when trying to snap them to a linedef fully inside of a grid cell.


R1942 | ee8e31db | MaxED | 22.09.2014, 16:33
--------------------------------------------------------------------------------
Fixed: Visual mode: vavoom-type 3d floor sidedefs were not selectable.
Fixed: Visual mode: "Select" action with "with the same textures" / "with the same height" modifiers (Shift/Ctrl + LMB) was not working properly when used on vavoom-type 3d floor sidedefs.
Fixed: Visual mode, UDMF, "Auto-align textures" actions: vertical texture offset was calculated incorrectly for vavoom-type 3d floors.


R1941 | ccc2e000 | MaxED | 22.09.2014, 13:51
--------------------------------------------------------------------------------
Visual mode: "Select" action with "with the same textures" / "with the same height" modifiers (Shift/Ctrl + LMB) now works properly with vavoom-type 3d floors.


R1940 | da00faf2 | MaxED | 22.09.2014, 11:04
--------------------------------------------------------------------------------
Visual mode: "Select" action with "with the same textures" / "with the same height" modifiers (Shift/Ctrl + LMB) now works when used on floors and ceilings of a 3d floor.


R1939 | e6b997a7 | MaxED | 22.09.2014, 02:16
--------------------------------------------------------------------------------
MODELDEF parser: fixed a crash when trying to add a model definition when another one was already created for the same actor.
ZDoom_DECORATE.cfg: added A_SetSpeed definition.


R1938 | 786caf3b | MaxED | 21.09.2014, 00:05
--------------------------------------------------------------------------------
ZDoom_ACS.cfg: added "DropInventory" function definition.
Visual mode: vertex handle size is now updated after closing the Preferences form.


R1937 | a6e44dc9 | MaxED | 20.09.2014, 20:34
--------------------------------------------------------------------------------
Preferences Form: renamed "Scale models in visual modes" to "Stretched view in visual modes". When enabled, this setting now increases vertical scale of the world and sprites in visual mode instead of decreasing vertical scale of models.


R1936 | a1f81e64 | MaxED | 20.09.2014, 00:19
--------------------------------------------------------------------------------
Sector slopes were not copied by "Copy Properties" actions and were missing from Paste Properties Options form.
Added several missing flags to ZDoom_DECORATE.cfg.


R1935 | 5d8e62f8 | MaxED | 19.09.2014, 00:06
--------------------------------------------------------------------------------
Visual mode: "Select" action with "with the same textures" / "with the same height" modifiers (Shift/Ctrl + LMB) now works when used on sides of a 3d floor.
Visual mode: "Select" action with "with the same textures" modifier (Shift + LMB) now selects adjacent sidedefs only when their height intersects with the height of the current sidedef.
Visual mode: "Select" action with "with the same textures" modifier (Shift + LMB) was not selecting connected one-sided sidedefs when used on a sidedef without a texture.
Cosmetic: fixed a couple of action descriptions in BuilderModes' Actions.cfg.
Cosmetic: MainForm.UpdateToolStripSeparators was working incorrectly in some cases.
Cosmetic: ErrorChecksForm's title was not updated when no errors were found.


R1934 | 3c116da3 | MaxED | 17.09.2014, 15:16
--------------------------------------------------------------------------------
Reformatted debug output from previous commit so it no longer generates compilation warnings when compiling in Release mode.


R1933 | c6b0f385 | MaxED | 17.09.2014, 14:46
--------------------------------------------------------------------------------
Fixed a crash when trying to update a vertex handle geometry.
The editor will fail more gracefully when no D3D device is detected.
In some cases the editor was constantly checking D3D device availability when minimized.
Added more DX-related debug output (only in Debug builds).


R1932 | 2d9c4393 | MaxED | 16.09.2014, 22:26
--------------------------------------------------------------------------------
Sidedef texture offsets are now translated when pasting map elements from UDMF to non-UDMF maps.
Fixed: certain UDMF-only properties were not cleared when pasting map elements from UDMF to non-UDMF maps.
Fixed a bug introduced in r2043: helper objects were not updated in some cases.


R1931 | 145e92ea | MaxED | 16.09.2014, 17:22
--------------------------------------------------------------------------------
Cosmetic: reformatted screenshot labels a bit.
More changes to Hexen_linedefs.cfg and ZDoom_linedefs.cfg.


R1930 | c7252865 | MaxED | 16.09.2014, 10:51
--------------------------------------------------------------------------------
Preferences: added "Vertex scale (3D)" preference, renamed "Vertex scale factor" to "Vertex scale (2D)".


R1929 | 33ec020d | MaxED | 16.09.2014, 01:37
--------------------------------------------------------------------------------
Game Configurations: added "requiresactivation" linedef property (defaults to "true").
Linedef Edit Form, UDMF: missing activation flags warning is now displayed only for linedef actions with "requiresactivation" property set in a game configuration.
Game configurations: fixed a couple of property names, added more enums & default values.
Updated BCC compiler to rev. 20140818r2.


R1928 | 70db005f | MaxED | 15.09.2014, 16:49
--------------------------------------------------------------------------------
Linedef Edit Form: activation flags check was not updated properly.


R1927 | 032c8aaa | MaxED | 15.09.2014, 16:12
--------------------------------------------------------------------------------
Split Linedef Edit Form into 2 versions: one for Doom/Hexen, and the other for UDMF map format.
Linedef Edit Form, UDMF: added less annoying warning about missing activation flags (no checks if an action actually requires activation yet...)


R1926 | 2056febb | MaxED | 15.09.2014, 11:35
--------------------------------------------------------------------------------
Flags Form: added special handling for flag with zero value.


R1925 | 7b735dc8 | MaxED | 15.09.2014, 10:35
--------------------------------------------------------------------------------
Sector Edit Form (Doom/Hexen): ermm... negative sector brightness is actually a thing...


R1924 | 71a3f1c7 | MaxED | 15.09.2014, 10:15
--------------------------------------------------------------------------------
Sector Edit Form (Doom/Hexen): it was possible to set negative Brightness.
Sector Edit Form (UDMF): sector brightness value was processed incorrectly when relative value was entered.
Internal: added "ButtonStepsWrapAround" property to ButtonsNumericTextbox.
Internal, SectorEditFormUDMF: more changes to Slopes tab. Still not operational...


R1923 | f9cedc23 | MaxED | 13.09.2014, 23:57
--------------------------------------------------------------------------------
Sector Edit Form: added "height offset" input. It can be used to change floor and ceiling height by given value. Also added some tooltips.


R1922 | cf82e5e1 | MaxED | 12.09.2014, 23:36
--------------------------------------------------------------------------------
Map Analysis mode: "Check overlapping vertices" returned false-positive results in some cases.
Map Analysis mode: fixed a couple of minor glitches related to enabling/disabling results list, "fix" buttons and "fix all" checkbox.


R1921 | 99f6a9a5 | MaxED | 12.09.2014, 23:08
--------------------------------------------------------------------------------
Map Analysis mode: results can now be hidden individually.
Updated documentation.


R1920 | 9b3b04d8 | MaxED | 12.09.2014, 16:58
--------------------------------------------------------------------------------
Map Analysis mode: results list now has a context menu, which allows to hide/show results based on type of selected result and to  copy description of selected result to clipboard.


R1919 | c97dd0e4 | MaxED | 12.09.2014, 14:19
--------------------------------------------------------------------------------
Map Analysis mode: errors can now be copied to clipboard.
Map Analysis mode: export to file command will now show "Save File" dialog instead of putting the file in the same folder as the map, also added some boilerplate.
Tag Explorer plugin: save to file command will now show "Save File" dialog instead of putting the file in the same folder as the map, also added some boilerplate.
Internal: reformatted GZCrash.log a bit.


R1918 | ad403de8 | MaxED | 11.09.2014, 23:53
--------------------------------------------------------------------------------
Classic modes: changed tinting of selected sprites from multiply to modulate.
Internal: more info is now displayed when a shader fails to compile.


R1917 | 814bf470 | MaxED | 11.09.2014, 19:49
--------------------------------------------------------------------------------
Linedef Edit Form: disabled missing activation flags warning.


R1916 | d916e546 | MaxED | 11.09.2014, 19:37
--------------------------------------------------------------------------------
Comments Panel: probably fixed a possible crash when UpdateList() is triggered during map unloading.


R1915 | 22c5d6c0 | MaxED | 11.09.2014, 13:51
--------------------------------------------------------------------------------
Visplane Explorer: added "Open Doors" and "Heat Colors" options.


R1914 | a7488939 | MaxED | 11.09.2014, 10:26
--------------------------------------------------------------------------------
Updated Visplane Explorer plugin to v1.0. Visplanes of Hexen maps can now be explored.
Map Options Form: example map name now uses current game's naming scheme.


R1913 | 422c605b | MaxED | 10.09.2014, 18:56
--------------------------------------------------------------------------------
Linedef Edit Form, UDMF: missing activation flags warning was shown even when action was 0...


R1912 | 7b70316b | MaxED | 09.09.2014, 15:54
--------------------------------------------------------------------------------
Internal: optimized WAD.FindLump() and WAD.FindLumpIndex() functions. They should work ~30x faster now (although, overall performance increase because of this change is fairly noticeable).


R1911 | 5e7de038 | MaxED | 09.09.2014, 14:16
--------------------------------------------------------------------------------
View projection is now updated when engaging Visual mode. This means no more distorted visuals after disproportionately changing window size.


R1910 | 359cea1c | MaxED | 09.09.2014, 11:49
--------------------------------------------------------------------------------
Game Configurations Form: added a help item to "Testing" tab, which displays info about command line placeholders when mouseovered.
Added some missing flags to ZDoom_DECORATE.cfg.


R1909 | 1521f9ba | MaxED | 08.09.2014, 23:26
--------------------------------------------------------------------------------
Linedef Edit Form, UDMF: a waring is now shown when trying to apply a non-zero action without any activation flags.
Program Configuration: selected test engine index was not saved when applying the form.
Program Configuration: selected test engine index was not pasted when pasting a game configuration or test engines.
Program Configuration: in some cases current test engine name was not saved when applying the form.
Program Configuration: fixed broken logic when trying to add a test engine with the same file name as already existing one.


R1908 | 697069e2 | MaxED | 08.09.2014, 15:09
--------------------------------------------------------------------------------
Texture Browser Form: some minor logic fixes (no texture groups were selected when initial texture was empty and no texture group was stored in the program configuration).
Texture Browser Form: don't save current texture group when the form was canceled.
Keyboard Shortcut Reference export: generated html will now be saved to program configuration folder if working folder is write-protected.
Internal: added SupportedMapFormats property to EditModeAttribute. A mode with this property specified will be available only in specified map formats.
Interface: Ceiling Align Mode and Floor Align Mode are now enabled by default.
Interface: Ceiling Align Mode and Floor Align Mode are now only available in UDMF map format.
Interface: Visplane Explorer Mode is now available only in Doom map format.


R1907 | bfda0c99 | MaxED | 04.09.2014, 15:48
--------------------------------------------------------------------------------
Find & Replace Mode: sector effects and linedef actions are now searched on bit by bit basis. That means map elements with partially matching Generalized effect/action can now be found.


R1906 | f596b883 | MaxED | 04.09.2014, 14:34
--------------------------------------------------------------------------------
Proper labels are now displayed for generalized sector effects.
Internal, Edit Sectors form: more changes to "Slopes" tab logic. It's still incomplete...


R1905 | daf8c443 | MaxED | 04.09.2014, 09:57
--------------------------------------------------------------------------------
Screenshots: message about missing save folder should not be displayed when using the default save path.
Screenshots: added wad and map names to info text of edit area screenshots.


R1904 | 8ea8c154 | MaxED | 03.09.2014, 16:07
--------------------------------------------------------------------------------
Thing Edit form: position changes were handled differently than other similar properties.
Thing Edit form: absolute thing height was calculated incorrectly in some cases.
General: added a generic update logic when current editing mode doesn't handle OnEditFormValuesChanged event.
Internal, AngleControl: added "AngleOffset" property.


R1903 | 1da7e446 | MaxED | 03.09.2014, 09:50
--------------------------------------------------------------------------------
Generalized sector effects were not enabled in Boom game configurations.
Updated documentation a bit.


R1902 | 50c136fb | MaxED | 02.09.2014, 22:44
--------------------------------------------------------------------------------
Import .obj as Terrain: created terrain was horizontally flipped when importing a model with up axis set to X or Z.
Also, I would like to use this opportunity to thank Siberian Tiger from DTD Team for helping me with SVN builds for more than two years. You made my constant wrestling with the code a much less tedious process.


R1901 | 3819eb56 | MaxED | 02.09.2014, 20:52
--------------------------------------------------------------------------------
Import .obj as Terrain: vertex order was incorrect when creating sectors from a model with up axis set to Z.


R1900 | 90689ad1 | MaxED | 30.08.2014, 20:12
--------------------------------------------------------------------------------
Fixed a crash when saving a map after changing map format.


R1899 | 10dd68b8 | MaxED | 28.08.2014, 13:16
--------------------------------------------------------------------------------
Classic modes: Draw Grid, Rectangle and Ellipse modes were missing "toggle grid snapping" mode (enabled by holding Shift key while drawing).


R1898 | a585db60 | MaxED | 26.08.2014, 13:08
--------------------------------------------------------------------------------
Visual mode, 3d floors: fixed broken 3d floor visibility detection one more time.
Game Configurations: changed default map name for Doom maps to "E1M1".
New Map Form: "E1M1" is now used as a default name for Doom maps.
Thing Browser Control: double-click event is now sent only if user clicked in the node's label area.
Interface: added info messages for several toolbar toggles.
Interface: made Brightness icon more readable when using dark windows themes.


R1897 | 6f7af0e2 | MaxED | 25.08.2014, 16:13
--------------------------------------------------------------------------------
Visual mode, UDMF: added some boilerplate to prevent invalid sector slopes from showing up/crashing the editor.


R1896 | c95c26bb | MaxED | 25.08.2014, 13:15
--------------------------------------------------------------------------------
Fixed: MapSet.GetSectorByCoordinates() returned "false" in some cases when a given coordinate was on top of sector's vertex.
Internal: UDMF sector slopes and offsets are no longer stored in sector.Fields. Use sector.FloorSlope, sector.FloorSlopeOffset, sector.CeilingSlope and sector.CeilingSlopeOffset.


R1895 | aee55d49 | MaxED | 25.08.2014, 11:41
--------------------------------------------------------------------------------
Visual mode, 3d floors: fixed broken 3d floor visibility detection (which failed in some cases when real floor or ceiling was sloped).


R1894 | 4f0cfb1e | MaxED | 19.08.2014, 23:58
--------------------------------------------------------------------------------
Map Analysis form: fixed a bug related to window resizing introduced in r2002.


R1893 | bce65134 | MaxED | 13.08.2014, 00:43
--------------------------------------------------------------------------------
"Fatal Non-UI Error" message was shown incorrectly.


R1892 | be12251c | MaxED | 12.08.2014, 11:06
--------------------------------------------------------------------------------
Tag Range plugin: 0 should not be considered as "used tag"


R1891 | 18dea2d7 | MaxED | 12.08.2014, 10:30
--------------------------------------------------------------------------------
Tag Range plugin: tags of selected map elements should not be considered as "already used".


R1890 | 9802b653 | MaxED | 12.08.2014, 10:13
--------------------------------------------------------------------------------
Tag Range plugin: custom increment can now be set.
Tag Range plugin: tags can be set in relative mode (when this mode is enabled, generated values are added to existing tags instead of replacing them).
Updated documentation.


R1889 | 2a880920 | MaxED | 11.08.2014, 12:30
--------------------------------------------------------------------------------
Map Analysis Mode: made several error descriptions more... descriptive.
Map Analysis form is now resize-able.
Map Analysis form: number of found errors is now shown in the form's title.


R1888 | 780ccae4 | MaxED | 11.08.2014, 11:39
--------------------------------------------------------------------------------
Game Configurations, Error Checker: all blocking things are now checked for being stuck in other things.
Thing Type Info: errorcheck is now set to THING_ERROR_INSIDE_STUCK for blocking DECORATE things.


R1887 | 450ee02e | MaxED | 11.08.2014, 10:35
--------------------------------------------------------------------------------
Tag Selector, changed: tag ranges are now set using "&gt;=N" and "&lt;=N" syntax.
Tag Selector: tags can now be set relatively using "++N" and "--N" syntax.


R1886 | a07a5c1b | MaxED | 08.08.2014, 14:35
--------------------------------------------------------------------------------
Some more updates to ZDoom_DECORATE.cfg and ZDoom_ACS.cfg


R1885 | dc36abb0 | MaxED | 08.08.2014, 13:49
--------------------------------------------------------------------------------
Updated ZDoom_DECORATE.cfg


R1884 | ae0fc036 | MaxED | 08.08.2014, 13:00
--------------------------------------------------------------------------------
